package com.sharppaint.drawtools;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.LinearGradientPaint;
import java.awt.MultipleGradientPaint;
import java.awt.RadialGradientPaint;
import java.awt.MultipleGradientPaint.CycleMethod;

public abstract class GradientHelper extends Element {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -7724661712186905202L;
	
	transient float sx1;
	transient float sy1;
	transient float sWidth;
	transient float sHeight;
	transient CycleMethod cycleMethod;
	
	protected void initGradient() {
		gradListSize = gradList.size();
		gradColors = new Color[gradListSize];
		gradDist = new float[gradListSize];

		for(int i=0; i<gradList.size(); i++) {
			gradRect = gradList.get(i);	
			gradColors[i] = gradRect.getColor();
			gradDist[i] = gradRect.getDist();
			//System.out.println("gradDist" + gradDist[i]);
			//System.out.println("gradDist[i]" + gradDist[i]);
			//System.out.println("gradDist[i]" + gradDist[i]);
		}
		for(int i=0; i<gradList.size()-1; i++) {
			if(gradDist[i] > gradDist[i+1]) {
				
			} else if(gradDist[i] == gradDist[i+1]){
				
			}
		}
	}
	
	protected void drawGradient(Graphics2D g2d) {
		AlphaComposite ac = AlphaComposite.getInstance(
				AlphaComposite.SRC_OVER, gradientOpacity);
		g2d.setComposite(ac);
		if(isGradCycle) {
			cycleMethod = MultipleGradientPaint.CycleMethod.REPEAT;
		} else {
			cycleMethod = MultipleGradientPaint.CycleMethod.NO_CYCLE;				
		}
		if(gradStyle == DrawToolConst.LINEAR_GRAD) {
			if(angleGrad>=0 && angleGrad<=45
					&& width*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						x1,
						y1,
						x1+width*scaleGrad, 
						y1+angleGrad/45*height*scaleGrad, 
						gradDist, gradColors, 
						cycleMethod));
			} else if(angleGrad>45 && angleGrad<135
					&& (-45+angleGrad)/90*width*scaleGrad
							!= (width+(45-angleGrad)/90*width)*scaleGrad
					&& height*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						x1+(-45+angleGrad)/90*width*scaleGrad, 
						y1,
						x1+(width+(45-angleGrad)/90*width)*scaleGrad, 
						y1+height*scaleGrad, 
						gradDist, gradColors, 
						cycleMethod));						
			} else if(angleGrad>=135 && angleGrad<=180
					&& width*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						x1+width*scaleGrad, 
						y1,
						x1, 
						y1+(height+(135-angleGrad)/45*height)*scaleGrad, 
						gradDist, gradColors,
						cycleMethod));
			} else if(angleGrad>=-45 && angleGrad<0
					&& width*scaleGrad!=0
					&& (-angleGrad)/45*height*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						x1, 
						y1+(-angleGrad)/45*height*scaleGrad, 
						x1+width*scaleGrad, 
						y1, 
						gradDist, gradColors, 
						cycleMethod));
			} else if(angleGrad>-135 && angleGrad<-45
					&& (-45-angleGrad)/90*width*scaleGrad
						!=(width+(45+angleGrad)/90*width)*scaleGrad
					&& height*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						x1+(-45-angleGrad)/90*width*scaleGrad, 
						y1+height*scaleGrad, 
						x1+(width+(45+angleGrad)/90*width)*scaleGrad, 
						y1,
						gradDist, gradColors, 
						cycleMethod));						
			} else if(angleGrad>=-180 && angleGrad<=-135
					&& width*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						x1+width*scaleGrad, 
						y1+(height+(135+angleGrad)/45*height)*scaleGrad, 
						x1, 
						y1,
						gradDist, gradColors,
						cycleMethod));
			} 			
		} else {
			boolean isRadianZero = false;
			if(angleGrad>=0 && angleGrad<=90) {
				if(scaleGrad*width/2.0f+(height-width)/2*angleGrad/90 != 0) {
					gradRadius = Math.abs(scaleGrad*width/2.0f+(height-width)/2*angleGrad/90);
					g2d.setPaint(new RadialGradientPaint(
							x1+width/2,
							y1+height/2,
							gradRadius,
							gradDist, gradColors,
							cycleMethod));
				} else {
					isRadianZero = true;				
				}
			} else if(angleGrad>90 && angleGrad<=180) {
				if(scaleGrad*width/2.0f+(height-width)/2*Math.abs(angleGrad-180)/90 != 0) {
					gradRadius = Math.abs(scaleGrad*width/2.0f+(height-width)/2*Math.abs(angleGrad-180)/90);
					g2d.setPaint(new RadialGradientPaint(
							x1+width/2,
							y1+height/2,
							gradRadius,
							gradDist, gradColors, 
							cycleMethod));	
				} else {
					isRadianZero = true;					
				}
			} else if(angleGrad>=-90 && angleGrad<0) {
				if(scaleGrad*width/2.0f+(height-width)/2*Math.abs(angleGrad)/90 != 0) {
					gradRadius = Math.abs(
							scaleGrad*width/2.0f+(height-width)/2*Math.abs(angleGrad)/90);
					g2d.setPaint(new RadialGradientPaint(
							x1+width/2,
							y1+height/2,
							gradRadius,
							gradDist, gradColors, 
							cycleMethod));	
				} else {
					isRadianZero = true;	
				}
			} else if(angleGrad>=-180 && angleGrad<-90) {
				if(scaleGrad*width/2.0f+(height-width)/2*(angleGrad+180)/90 != 0) {
					gradRadius = Math.abs(
							scaleGrad*width/2.0f+(height-width)/2*(angleGrad+180)/90);
					g2d.setPaint(new RadialGradientPaint(
							x1+width/2,
							y1+height/2,
							gradRadius,
							gradDist, gradColors, 
							cycleMethod));	
				} else {
					isRadianZero = true;
				}
			} 
			if(isRadianZero) {
				gradRadius = 1;
				g2d.setPaint(new RadialGradientPaint(
						x1+width/2, y1+height/2,
						gradRadius, gradDist, gradColors,
						cycleMethod));	
			}
		}
		//System.out.println(width + "width  "  + gradRadius);
	}
	
	protected void drawGradientTransform(Graphics2D g2d) {
		AlphaComposite ac = AlphaComposite.getInstance(
				AlphaComposite.SRC_OVER, gradientOpacity);
		g2d.setComposite(ac);
		if(isGradCycle) {
			cycleMethod = MultipleGradientPaint.CycleMethod.REPEAT;
		} else {
			cycleMethod = MultipleGradientPaint.CycleMethod.NO_CYCLE;				
		}
		if(gradStyle == DrawToolConst.LINEAR_GRAD) {
			if(angleGrad>=0 && angleGrad<=45
					&& width*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						-width/2, 
						-height/2, 
						-width/2+width*scaleGrad, 
						-height/2+angleGrad/45*height*scaleGrad, 
						gradDist, gradColors, 
						cycleMethod));
			} else if(angleGrad>45 && angleGrad<135) {
				g2d.setPaint(new LinearGradientPaint(
						-width/2+(-45+angleGrad)/90*width*scaleGrad, 
						-height/2,
						-width/2+(width+(45-angleGrad)/90*width)*scaleGrad, 
						-height/2+height*scaleGrad, 
						gradDist, gradColors, 
						cycleMethod));						
			} else if(angleGrad>=135 && angleGrad<=180
					&& width*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						-width/2+width*scaleGrad, 
						-height/2,
						-width/2, 
						-height/2+(height+(135-angleGrad)/45*height)*scaleGrad, 
						gradDist, gradColors,
						cycleMethod));
			} else if(angleGrad>=-45 && angleGrad<0) {
				g2d.setPaint(new LinearGradientPaint(
						-width/2, 
						-height/2+(-angleGrad)/45*height*scaleGrad, 
						-width/2+width*scaleGrad, 
						-height/2, 
						gradDist, gradColors, 
						cycleMethod));
			} else if(angleGrad>-135 && angleGrad<-45) {
				g2d.setPaint(new LinearGradientPaint(
						-width/2+(-45-angleGrad)/90*width*scaleGrad, 
						-height/2+height*scaleGrad, 
						-width/2+(width+(45+angleGrad)/90*width)*scaleGrad, 
						-height/2,
						gradDist, gradColors, 
						cycleMethod));						
			} else if(angleGrad>=-180 && angleGrad<=-135
					&& width*scaleGrad!=0) {
				g2d.setPaint(new LinearGradientPaint(
						-width/2+width*scaleGrad, 
						-height/2+(height+(135+angleGrad)/45*height)*scaleGrad, 
						-width/2, 
						-height/2,
						gradDist, gradColors,
						cycleMethod));
			} 
		} else {
			boolean isRadianZero = false;
			if(angleGrad>=0 && angleGrad<=90) {
				if(scaleGrad*width/2.0f+(height-width)/2*angleGrad/90 != 0) {
					gradRadius = Math.abs(
							scaleGrad*width/2.0f+(height-width)/2*angleGrad/90);
					g2d.setPaint(new RadialGradientPaint(
							0, 0,
							gradRadius,
							gradDist, gradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;				
				}
			} else if(angleGrad>90 && angleGrad<=180) {
				if(scaleGrad*width/2.0f+(height-width)/2*Math.abs(angleGrad-180)/90 != 0) {
					gradRadius = Math.abs(scaleGrad*width/2.0f+(height-width)/2
							*Math.abs(angleGrad-180)/90);
					g2d.setPaint(new RadialGradientPaint(
							0, 0,
							gradRadius,
							gradDist, gradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;				
				}
			} else if(angleGrad>=-90 && angleGrad<0) {
				if(scaleGrad*width/2.0f+(height-width)/2*Math.abs(angleGrad)/90 != 0) {
					gradRadius = Math.abs(scaleGrad*width/2.0f+(height-width)/2
							*Math.abs(angleGrad)/90);
					g2d.setPaint(new RadialGradientPaint(
							0, 0,
							gradRadius,
							gradDist, gradColors, 
							cycleMethod));	
				} else {
					isRadianZero = true;				
				}
			} else if(angleGrad>=-180 && angleGrad<-90) {
				if(scaleGrad*width/2.0f+(height-width)/2*(angleGrad+180)/90 != 0) {
					gradRadius = Math.abs(scaleGrad*width/2.0f+(height-width)/2
							*(angleGrad+180)/90);
					g2d.setPaint(new RadialGradientPaint(
							0, 0,
							gradRadius,
							gradDist, gradColors, 
							cycleMethod));	
				} else {
					isRadianZero = true;				
				}
			}
			if(isRadianZero) {
				gradRadius = 1;
				g2d.setPaint(new RadialGradientPaint(
						0, 0,
						gradRadius, gradDist, gradColors,
						cycleMethod));	
			} 			
		}
		//g2d.fill(drawShape);
	}
	
	protected void initStrokeGradient() {
		strokeGradListSize = strokeGradList.size();
		strokeGradColors = new Color[strokeGradListSize];
		strokeGradDist = new float[strokeGradListSize];

		for(int i=0; i<strokeGradListSize; i++) {
			gradRect = strokeGradList.get(i);	
			strokeGradColors[i] = gradRect.getColor();
			strokeGradDist[i] = gradRect.getDist();
		}		
	}
	
	protected void drawStrokeGradient(Graphics2D g2d) {
		if(strokePosition == DrawToolConst.STROKE_POSITION_CENTER) {
			sx1 = x1-strokeSize/2;
			sy1 = y1-strokeSize/2;
			sWidth = width + strokeSize;
			sHeight = height + strokeSize;
			paintStrokeGradient(g2d);
		}
		else if(strokePosition == DrawToolConst.STROKE_POSITION_OUTSIDE) {
			sx1 = x1-strokeSize;
			sy1 = y1-strokeSize;
			sWidth = width + strokeSize*2;
			sHeight = height + strokeSize*2;			
			paintStrokeGradient(g2d);
		}
		else {
			sx1 = x1;
			sy1 = y1;
			sWidth = width;
			sHeight = height;				
			paintStrokeGradient(g2d);	
		}
	}

	protected void drawStrokeGradientTransform(Graphics2D g2d) {
		if(strokePosition == DrawToolConst.STROKE_POSITION_CENTER) {
			sWidth = width + strokeSize;
			sHeight = height + strokeSize;			
			paintStrokeGradientTransform(g2d);			
		}
		else if(strokePosition == DrawToolConst.STROKE_POSITION_OUTSIDE) {
			sWidth = width + strokeSize*2;
			sHeight = height + strokeSize*2;		
			paintStrokeGradientTransform(g2d);
		}
		else {
			sWidth = width;
			sHeight = height;		
			paintStrokeGradientTransform(g2d);
		}
	}
	
	private void paintStrokeGradient(Graphics2D g2d) {
		if(isStrokeGradCycle) {
			cycleMethod = MultipleGradientPaint.CycleMethod.REPEAT;
		} else {
			cycleMethod = MultipleGradientPaint.CycleMethod.NO_CYCLE;				
		}
		if(strokeGradStyle == DrawToolConst.LINEAR_GRAD
				&& strokeGradDist != null
				&& strokeGradColors != null) {
			if(strokeGradAngle>=0 && strokeGradAngle<=45
					&& sWidth*strokeGradScale!=0) {
				g2d.setPaint(new LinearGradientPaint(
						sx1, 
						sy1, 
						sx1+sWidth*strokeGradScale, 
						sy1+strokeGradAngle/45*sHeight*strokeGradScale, 
						strokeGradDist, strokeGradColors, 
						cycleMethod));
			} else if(strokeGradAngle>45 && strokeGradAngle<135) {
				g2d.setPaint(new LinearGradientPaint(
						sx1+(-45+strokeGradAngle)/90*sWidth*strokeGradScale, 
						sy1,
						sx1+(sWidth+(45-strokeGradAngle)/90*sWidth)*strokeGradScale, 
						sy1+sHeight*strokeGradScale, 
						strokeGradDist, strokeGradColors, 
						cycleMethod));						
			} else if(strokeGradAngle>=135 && strokeGradAngle<=180
					&& sWidth*strokeGradScale!=0) {
				g2d.setPaint(new LinearGradientPaint(
						sx1+sWidth*strokeGradScale, 
						sy1,
						sx1, 
						sy1+(sHeight+(135-strokeGradAngle)/45*sHeight)*strokeGradScale, 
						strokeGradDist, strokeGradColors,
						cycleMethod));
			} else if(strokeGradAngle>=-45 && strokeGradAngle<0) {
				g2d.setPaint(new LinearGradientPaint(
						sx1, 
						sy1+(-strokeGradAngle)/45*sHeight*strokeGradScale, 
						sx1+sWidth*strokeGradScale, 
						sy1, 
						strokeGradDist, strokeGradColors, 
						cycleMethod));
			} else if(strokeGradAngle>-135 && strokeGradAngle<-45) {
				g2d.setPaint(new LinearGradientPaint(
						sx1+(-45-strokeGradAngle)/90*sWidth*strokeGradScale, 
						sy1+sHeight*strokeGradScale, 
						sx1+(sWidth+(45+strokeGradAngle)/90*sWidth)*strokeGradScale, 
						sy1,
						strokeGradDist, strokeGradColors, 
						cycleMethod));						
			} else if(strokeGradAngle>=-180 && strokeGradAngle<=-135
					&& sWidth*strokeGradScale!=0) {
				g2d.setPaint(new LinearGradientPaint(
						sx1+sWidth*strokeGradScale, 
						sy1+(sHeight+(135+strokeGradAngle)/45*sHeight)*strokeGradScale, 
						sx1, 
						sy1,
						strokeGradDist, strokeGradColors,
						cycleMethod));
			}
		} else {
			boolean isRadianZero = false;
			if(strokeGradAngle>=0 && strokeGradAngle<=90) {
				if(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2*strokeGradAngle/90 != 0) {
					strokeGradRadius = Math.abs(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
							*strokeGradAngle/90);
					g2d.setPaint(new RadialGradientPaint(
							sx1+sWidth/2,
							sy1+sHeight/2,
							strokeGradRadius,
							strokeGradDist, strokeGradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;				
				}
			} else if(strokeGradAngle>90 && strokeGradAngle<=180) {
				if(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
						*Math.abs(strokeGradAngle-180)/90 != 0) {
					strokeGradRadius = Math.abs(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
							*Math.abs(strokeGradAngle-180)/90);
					g2d.setPaint(new RadialGradientPaint(
							sx1+sWidth/2,
							sy1+sHeight/2,
							strokeGradRadius,
							strokeGradDist, strokeGradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;				
				}
			} else if(strokeGradAngle>=-90 && strokeGradAngle<0) {
				if(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
						*Math.abs(strokeGradAngle)/90 != 0) {
					strokeGradRadius = Math.abs(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
							*Math.abs(strokeGradAngle)/90);
					g2d.setPaint(new RadialGradientPaint(
							sx1+sWidth/2,
							sy1+sHeight/2,
							strokeGradRadius,
							strokeGradDist, strokeGradColors, 
							cycleMethod));	
				} else {
					isRadianZero = true;				
				}
			} else if(strokeGradAngle>=-180 && strokeGradAngle<-90) {
				if(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
						*(strokeGradAngle+180)/90 != 0) {
					strokeGradRadius = Math.abs(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
							*(strokeGradAngle+180)/90);
					g2d.setPaint(new RadialGradientPaint(
							sx1+sWidth/2,
							sy1+sHeight/2,
							strokeGradRadius,
							strokeGradDist, strokeGradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;				
				}
			} 
			if(isRadianZero) {
				strokeGradRadius = 1;
				g2d.setPaint(new RadialGradientPaint(
						sx1+sWidth/2, sy1+sHeight/2,
						strokeGradRadius, gradDist, gradColors,
						cycleMethod));
			}
		}
	}
	
	private void paintStrokeGradientTransform(Graphics2D g2d) {
		if(isStrokeGradCycle) {
			cycleMethod = MultipleGradientPaint.CycleMethod.REPEAT;
		} else {
			cycleMethod = MultipleGradientPaint.CycleMethod.NO_CYCLE;				
		}
		if(strokeGradStyle == DrawToolConst.LINEAR_GRAD) {
			if(strokeGradAngle>=0 && strokeGradAngle<=45
					&& sWidth*strokeGradScale!=0) {
				g2d.setPaint(new LinearGradientPaint(
						-sWidth/2, 
						-sHeight/2, 
						-sWidth/2+sWidth*strokeGradScale, 
						-sHeight/2+strokeGradAngle/45*sHeight*strokeGradScale, 
						strokeGradDist, strokeGradColors, 
						cycleMethod));
			} else if(strokeGradAngle>45 && strokeGradAngle<135) {
				g2d.setPaint(new LinearGradientPaint(
						-sWidth/2+(-45+strokeGradAngle)/90*sWidth*strokeGradScale, 
						-sHeight/2,
						-sWidth/2+(sWidth+(45-strokeGradAngle)/90*sWidth)*strokeGradScale, 
						-sHeight/2+sHeight*strokeGradScale, 
						strokeGradDist, strokeGradColors, 
						cycleMethod));						
			} else if(strokeGradAngle>=135 && strokeGradAngle<=180
					&& sWidth*strokeGradScale!=0) {
				g2d.setPaint(new LinearGradientPaint(
						-sWidth/2+sWidth*strokeGradScale, 
						-sHeight/2,
						-sWidth/2, 
						-sHeight/2+(sHeight+(135-strokeGradAngle)/45*sHeight)*strokeGradScale, 
						strokeGradDist, strokeGradColors,
						cycleMethod));
			} else if(strokeGradAngle>=-45 && strokeGradAngle<0) {
				g2d.setPaint(new LinearGradientPaint(
						-sWidth/2, 
						-sHeight/2+(-strokeGradAngle)/45*sHeight*strokeGradScale, 
						-sWidth/2+sWidth*strokeGradScale, 
						-sHeight/2, 
						strokeGradDist, strokeGradColors, 
						cycleMethod));
			} else if(strokeGradAngle>-135 && strokeGradAngle<-45) {
				g2d.setPaint(new LinearGradientPaint(
						-sWidth/2+(-45-strokeGradAngle)/90*sWidth*strokeGradScale, 
						-sHeight/2+sHeight*strokeGradScale, 
						-sWidth/2+(sWidth+(45+strokeGradAngle)/90*sWidth)*strokeGradScale, 
						-sHeight/2,
						strokeGradDist, strokeGradColors, 
						cycleMethod));						
			} else if(strokeGradAngle>=-180 && strokeGradAngle<=-135
					&& sWidth*strokeGradScale!=0) {
				g2d.setPaint(new LinearGradientPaint(
						-sWidth/2+sWidth*strokeGradScale, 
						-sHeight/2+(sHeight+(135+strokeGradAngle)/45*sHeight)*strokeGradScale, 
						-sWidth/2, 
						-sHeight/2,
						strokeGradDist, strokeGradColors,
						cycleMethod));
			}
		} else {
			boolean isRadianZero = false;
			if(strokeGradAngle>=0 && strokeGradAngle<=90) {
				if(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
						*strokeGradAngle/90 != 0) {
					strokeGradRadius = Math.abs(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
							*strokeGradAngle/90);
					g2d.setPaint(new RadialGradientPaint(
							0, 0,
							strokeGradRadius,
							strokeGradDist, strokeGradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;					
				}
			} else if(strokeGradAngle>90 && strokeGradAngle<=180) {
				if(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
						*Math.abs(strokeGradAngle-180)/90 != 0) {
					strokeGradRadius = Math.abs(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
							*Math.abs(strokeGradAngle-180)/90);
					g2d.setPaint(new RadialGradientPaint(
							0, 0,
							strokeGradRadius,
							strokeGradDist, strokeGradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;				
				}
			} else if(strokeGradAngle>=-90 && strokeGradAngle<0) {
				if(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
						*Math.abs(strokeGradAngle)/90 != 0) {
					strokeGradRadius = Math.abs(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
							*Math.abs(strokeGradAngle)/90);
					g2d.setPaint(new RadialGradientPaint(
							0, 0,
							strokeGradRadius,
							strokeGradDist, strokeGradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;					
				}
			} else if(strokeGradAngle>=-180 && strokeGradAngle<-90) {
				if(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
						*(strokeGradAngle+180)/90 != 0) {
					strokeGradRadius = Math.abs(strokeGradScale*sWidth/2.0f+(sHeight-sWidth)/2
							*(strokeGradAngle+180)/90);
					g2d.setPaint(new RadialGradientPaint(
							0, 0,
							strokeGradRadius,
							strokeGradDist, strokeGradColors, 
							cycleMethod));
				} else {
					isRadianZero = true;			
				}
			}
			if(isRadianZero) {
				strokeGradRadius = 1;
				g2d.setPaint(new RadialGradientPaint(
						0, 0,
						strokeGradRadius, gradDist, gradColors,
						cycleMethod));
			}
		}
	}
}
