package com.sharppaint.drawtools;
import java.awt.Color;
import java.awt.Graphics;
import java.io.Serializable;

public class GradientTool implements Serializable{	
	/**
	 * 
	 */
	/********************** never change *********************/
	private static final long serialVersionUID = 7277883450751953671L;
	private int x1, y1, x2, y2, width, height;
	private float dist;
	private Color gradientColor;	
	transient private boolean match = false, select = false;
	/********************** never change *********************/
	public final static int GRADIENT_RECT_WIDTH=10;
	public final static int GRADIENT_RECT_HEIGHT=13;
	
	public GradientTool(int _x1, Color _backColor) {
		x1=_x1;		
		x2=_x1+GRADIENT_RECT_WIDTH;
		y1=0;	
		y2=GRADIENT_RECT_HEIGHT;
		width = GRADIENT_RECT_WIDTH;
		height = GRADIENT_RECT_HEIGHT;
		gradientColor = _backColor;
		dist = x1/200.0f;
	}
	public GradientTool(GradientTool g) {
		x1=g.x1;		
		x2=g.x2;
		y1=g.y1;	
		y2=g.y2;
		width = g.width;
		height = g.height;
		gradientColor = g.gradientColor;
		dist = g.dist;
	}
	public void setX(int _x1) {
		x1=_x1;
		x2=_x1+GRADIENT_RECT_WIDTH;
		dist = x1/200.0f;
	}
	public Color getColor() {
		return gradientColor;
	}
	public void setColor(Color _backColor) {
		gradientColor = _backColor;
	}
	public void setSelected(boolean sel) {
		select = sel;
	}
	public int getX() {
		return x1;
	}
	public float getDist() {
		return dist;
	}
	public void translate(int _x1, int _x2) {	
		//x1 = x1-(_x1-_x2);
		x1 = x1+(_x2-_x1);
		x2 = x2+(_x2-_x1);
		dist = x1/200.0f;
	}
	public boolean match(int x,int y) {
		if ( (x>=x1 && x<=x2) && (y>=y1 && y<=y2) ) {
			match=true;
		}
		else
			match=false;
		return match;
	}
	public void draw(Graphics g) {		
		g.setColor( gradientColor );		
		g.fillRect( x1, y1, width, height );
		if(select) {
			g.setColor(Color.CYAN);
			g.drawRect( x1-1, y1-1, width+2, height+2 );
		}
	}
}
