package com.sharppaint.drawtools;


import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.geom.Ellipse2D;
import java.awt.geom.GeneralPath;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.util.ArrayList;

import javax.swing.ImageIcon;


public class PenTool extends GradientHelper{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 4448506393292499998L;
	
	/********************** never change *********************/	
	//private boolean closePath = false;
	private AffineTransform atMulti, saveMult;
	private float startX1, startY1;
	boolean startSecondLine;
	boolean isMakePath;
	transient private ArrayList<PointF> undoPenToolList;
	transient private Rectangle bound;
	transient private GeneralPath tempPath;
	transient private boolean penWhileMode;
	transient private boolean isCountUnderAfterRemoveCurve;
	/********************** never change *********************/
	
	public PenTool(float _x1, float _y1) {
		toolName = DrawToolConst.PEN;
		path = new GeneralPath();
		tempPath = new GeneralPath();
		x1=_x1;
		y1=_y1;
		ctrlX1 = x1;
		ctrlY1 = y1;
		startX1=_x1;
		startY1=_y1;
		path.moveTo(x1, y1);
		tempPath.moveTo(x1, y1);
		atMulti = new AffineTransform();
		saveMult = new AffineTransform();
		angle = 0;
		rotateMode = false;		
		points = new PointF[1200];
		points[0] = new PointF(x1, y1);
		pointCount++;
		isMakePath = false;
		startSecondLine = false;
	}
	public PenTool(Element e) {
		toolName = DrawToolConst.PEN;		
		path = (GeneralPath) e.path.clone();
		//tempPath = (GeneralPath) ((PenTool)e).tempPath.clone();
		atMulti = new AffineTransform();
		saveMult = new AffineTransform();
		isMakePath = ((PenTool)e).isMakePath;
		x1=e.x1;
		y1=e.y1;
		startX1=((PenTool)e).startX1;
		startY1=((PenTool)e).startY1;
		colorMode = e.colorMode;
		gradientMode = e.gradientMode;
		patternMode = e.patternMode;
		strokeMode = e.strokeMode;
		
		angle = e.angle;
		rotateMode = e.rotateMode;
		scaleMode = e.scaleMode;
		scaleX = e.scaleX;
		scaleY = e.scaleY;
		selectStroke = e.selectStroke;
		if(colorMode) {
			colorOpacity = e.colorOpacity;
			fillColor = e.fillColor;
		}
		if(gradientMode) {
			gradientOpacity = e.gradientOpacity;
			scaleGrad = e.scaleGrad;
			angleGrad = e.angleGrad;
			gradStyle = e.gradStyle;
			isGradCycle = e.isGradCycle;
			gradList = new ArrayList<GradientTool>();
			for(int i=0; i<e.gradList.size(); i++) {
				gradRect = new GradientTool(e.gradList.get(i));
				gradList.add(gradRect);
			}
			initGradient();
		}
		if(patternMode) {
			patternPath = e.patternPath;
			patternScale = e.patternScale;
			patternOpacity = e.patternOpacity;
			patternImg = new ImageIcon(
					getClass().getResource(patternPath)).getImage();
			patternSrcWidth = e.patternSrcWidth;
			patternSrcHeight = e.patternSrcHeight;
			patternScaleWidth = e.patternScaleWidth;
		}
		if(strokeMode) {
			strokeSize = e.strokeSize;
			strokeOpacity = e.strokeOpacity;
			strokePosition = e.strokePosition;
			strokeFillSelector = e.strokeFillSelector;
			if(strokeFillSelector == 0) {
				strokeColor = e.strokeColor;
			}
			else if(strokeFillSelector == 1) {
				strokeGradScale = e.strokeGradScale;
				strokeGradAngle = e.strokeGradAngle;
				strokeGradStyle = e.strokeGradStyle;
				isStrokeGradCycle = e.isStrokeGradCycle;
				strokeGradList = new ArrayList<GradientTool>();
				for(int i=0; i<e.strokeGradList.size(); i++) {
					gradRect = new GradientTool(e.strokeGradList.get(i));
					strokeGradList.add(gradRect);
				}
				initStrokeGradient();
			}
			else if(strokeFillSelector == 2) {
				strokePatternScale = e.strokePatternScale;
				strokePatternPath = e.strokePatternPath;
				strokeImg = new ImageIcon(
						getClass().getResource(strokePatternPath)).getImage();
				strokeImgWidth = e.strokeImgWidth;
				strokeImgHeight = e.strokeImgHeight;
				strokePatternScaleWidth = e.strokePatternScaleWidth;
			}
		}
		selectStroke = e.selectStroke;
		points = new PointF[1200];
		points = e.points;
		pointCount = e.pointCount;
		setCopyPoint(e.points);
	}

	public void setFirstCtrlValue(float ctrlX1, float ctrlY1) {
		this.ctrlX1 = ctrlX1;
		this.ctrlY1 = ctrlY1;
	}
	
	public void setFirstCtrlValueEqual(float _ctrlX1, float _ctrlY1) {
		if( 2*Math.abs(_ctrlX1-x1) < Math.abs(_ctrlY1-y1) ) {
			ctrlX1 = x1;
			ctrlY1 = _ctrlY1;
		} else if(Math.abs(_ctrlX1-x1) > 2*Math.abs(_ctrlY1-y1) ) {
			ctrlY1 = y1;
			ctrlX1 = _ctrlX1;
		} else {
			if(_ctrlY1-y2 > 0) {
				ctrlY1 = y1 + (Math.abs(_ctrlX1-x1)+Math.abs(_ctrlY1-y1))/2;
			} else {
				ctrlY1 = y1 - (Math.abs(_ctrlX1-x1)+Math.abs(_ctrlY1-y1))/2;
			}
			if(_ctrlX1-x1 > 0) {
				ctrlX1 = x1 + (Math.abs(_ctrlX1-x1)+Math.abs(_ctrlY1-y1))/2;
			} else {
				ctrlX1 = x1 - (Math.abs(_ctrlX1-x1)+Math.abs(_ctrlY1-y1))/2;
			}
		}
	}
	
	public boolean isStartPoint(float sx2, float sy2) {
		if(Math.abs(startX1-sx2) < 2 && Math.abs(startY1-sy2) < 2) {
			return true;
		}
		return false;		
	}
	
	public void setDestPoint(float _x2, float _y2) {
		x2 = _x2;
		y2 = _y2;
	}

	public void setSecondCtrlValueEqual(float _ctrlX2, float _ctrlY2) {
		startSecondLine = true;
		tempPath = (GeneralPath) path.clone();
		if( 2*Math.abs(_ctrlX2-x2) < Math.abs(_ctrlY2-y2) ) {
			ctrlX2 = x2;
			ctrlY2 = _ctrlY2;
		} else if(Math.abs(_ctrlX2-x2) > 2*Math.abs(_ctrlY2-y2) ) {
			ctrlY2 = y2;
			ctrlX2 = _ctrlX2;
		} else {
			if(_ctrlY2-y2 > 0) {
				ctrlY2 = y2 + (Math.abs(_ctrlX2-x2)+Math.abs(_ctrlY2-y2))/2;
			} else {
				ctrlY2 = y2 - (Math.abs(_ctrlX2-x2)+Math.abs(_ctrlY2-y2))/2;
			}
			if(_ctrlX2-x2 > 0) {
				ctrlX2 = x2 + (Math.abs(_ctrlX2-x2)+Math.abs(_ctrlY2-y2))/2;
			} else {
				ctrlX2 = x2 - (Math.abs(_ctrlX2-x2)+Math.abs(_ctrlY2-y2))/2;
			}
		}
		tempPath.curveTo(ctrlX1, ctrlY1, x2*2-ctrlX2, y2*2-ctrlY2, x2, y2);
		isMakePath = false;
		isCountUnderAfterRemoveCurve = false;
	}
	
	public void setSecondCtrlValue(float ctrlX2, float ctrlY2) {
		startSecondLine = true;
		tempPath = (GeneralPath) path.clone();
		this.ctrlX2 = ctrlX2;
		this.ctrlY2 = ctrlY2;
		tempPath.curveTo(ctrlX1, ctrlY1, x2*2-ctrlX2, y2*2-ctrlY2, x2, y2);
		isMakePath = false;
		isCountUnderAfterRemoveCurve = false;
	}
	
	public void addCurve(
			float ctrlX1, float ctrlY1, 
			float ctrlX2, float ctrlY2, 
			float x2, float y2) {
		path.curveTo(ctrlX1, ctrlY1, ctrlX2, ctrlY2, x2, y2);
		setPoint(ctrlX1, ctrlY1);
		setPoint(ctrlX2, ctrlY2);
		setPoint(x2, y2);
		isMakePath = true;
	}
	
	public ArrayList<PointF> removeCurve() {
		if(undoPenToolList == null) {
			undoPenToolList = new ArrayList<PointF>();
		}
		if(pointCount>1) {
			for(int i=pointCount-1; i>pointCount-4; i--) {
				undoPenToolList.add(points[i]);
			}
			ctrlX1 = points[pointCount-3].getX();
			ctrlY1 = points[pointCount-3].getY();
			//ctrlX1 = points[pointCount-4].getX()*2-points[pointCount-5].getX();
			//ctrlY1 = points[pointCount-4].getY()*2-points[pointCount-5].getY();
			if(pointCount>3) {
				x1 = points[pointCount-4].getX();
				y1 = points[pointCount-4].getY();
			}
			pointCount = pointCount-3;
			//points[pointCount]
		} else if (pointCount == 1){
			undoPenToolList.add(points[pointCount-1]);
			pointCount--;
			return null;
		} else {
			return null;
		}
		setPathfromPoint();
		tempPath = (GeneralPath) path.clone();
		return undoPenToolList;
	}
	
	public boolean redoCurve() {
		int undoListSize = undoPenToolList.size()-1;
		if(undoListSize>1) {
			ctrlX1 = undoPenToolList.get(undoListSize).getX();
			ctrlY1 = undoPenToolList.get(undoListSize).getY();
			ctrlX2 = undoPenToolList.get(undoListSize-1).getX();
			ctrlY2 = undoPenToolList.get(undoListSize-1).getY();
			x2 = undoPenToolList.get(undoListSize-2).getX();
			y2 = undoPenToolList.get(undoListSize-2).getY();
			undoPenToolList.remove(undoListSize-2);
			undoPenToolList.remove(undoListSize-2);
			undoPenToolList.remove(undoListSize-2);
			//path.curveTo(ctrlX1, ctrlY1, ctrlX2+(x2-ctrlX2)*2, ctrlY2+(y2-ctrlY2)*2, x2, y2);
			path.curveTo(ctrlX1, ctrlY1, ctrlX2, ctrlY2, x2, y2);
			tempPath = (GeneralPath) path.clone();
			setPoint(ctrlX1, ctrlY1);
			setPoint(ctrlX2, ctrlY2);
			setPoint(x2, y2);
			ctrlX1 = 2*x2-ctrlX2;
			ctrlY1 = 2*y2-ctrlY2;
			
			isMakePath = true;
			x1 = x2;
			y1 = y2;
		}
		isCountUnderAfterRemoveCurve = false;
		if(undoPenToolList.size() != 0)
			return true;
		else
			return false;
	}
	
	public void makeCurve() {
		undoPenToolList = null;
		path.curveTo(ctrlX1, ctrlY1, 2*x2-ctrlX2, 2*y2-ctrlY2, x2, y2);
		setPoint(ctrlX1, ctrlY1);
		setPoint(2*x2-ctrlX2, 2*y2-ctrlY2);
		setPoint(x2, y2);
		ctrlX1 = ctrlX2;
		ctrlY1 = ctrlY2;
		isMakePath = true;
		x1 = x2;
		y1 = y2;
	}
		
	public void setPoint(float x, float y){
		points[pointCount] = new PointF(x, y);
		pointCount++;
	}
	
	public void setCopyPoint(PointF[] p){
		for(int i=0; i<pointCount; i++) {
			points[i].setX(p[i].getX());
			points[i].setY(p[i].getY());
		}
	}
	
	public void setPathfromPoint() {
		path = new GeneralPath();
		path.moveTo(points[0].getX(), points[0].getY());
		for ( int i=1; i < pointCount; i++ ){
			ctrlX1 = points[i].getX();
			ctrlY1 = points[i].getY();
			i++;
			if(i<pointCount) {
				ctrlX2 = points[i].getX();
				ctrlY2 = points[i].getY();
			}
			i++;
			if(i<pointCount) {
				x2 = points[i].getX();
				y2 = points[i].getY();
			}
			path.curveTo(ctrlX1, ctrlY1, ctrlX2, ctrlY2, x2, y2);
		}
		setPenBounds();
		if(pointCount>2) {
			x1 = x2;
			y1 = y2;
			ctrlX1 = 2*x2-ctrlX2;
			ctrlY1 = 2*y2-ctrlY2;
		} else {
			isCountUnderAfterRemoveCurve = true;
		}
	}
	public void setPenBounds() {
		bound = path.getBounds();
		x1 = (float)bound.getMinX();
		y1 = (float)bound.getMinY();
		width = (float)bound.getWidth();
		height = (float)bound.getHeight();
	}

	public PointF[] getPoints() {
		return points;
	}
	
	public boolean match(float x, float y) {
		match = false;
		if(path.contains(x, y))
			match = true;
		return match;
	}	
	
	public void translate(float _x1, float _y1, float _x2, float _y2) {
		atMulti.setToTranslation(_x2-_x1, _y2-_y1);
		path.transform(atMulti);
		bound = path.getBounds();
		x1 = (float)bound.getMinX();
		y1 = (float)bound.getMinY();	
		width = (float)bound.getWidth();
		height = (float)bound.getHeight();;
		for(int i=0;i<pointCount;i++){
			points[i].translate(_x2-_x1, _y2-_y1);
		}
	}

	/*
	public void resize(float _x1, float _y1, float _x2, float _y2) {
		if(Math.abs(x1-_x1) < Math.abs(x2-_x1)){
			setTransValue( x1-(_x1-_x2), y1, x2, y2 );
		}else{
			setTransValue( x1, y1, x2-(_x1-_x2), y2 );
		}		
		if(Math.abs(y1-_y1) < Math.abs(y2-_y1)){
			setTransValue( x1, y1-(_y1-_y2), x2, y2 );
		}else{
			setTransValue( x1, y1, x2, y2-(_y1-_y2));
		}
	}*/
		
	public void simpleDraw(Graphics g, float scale) {
		Graphics2D g2d = (Graphics2D) g;
		AffineTransform ats = new AffineTransform();	
		AffineTransform saveforms = g2d.getTransform();	
		ats.scale(scale, scale);
		g2d.transform(ats);
		g2d.setStroke(new BasicStroke(5));
		g2d.setColor(Color.WHITE);
		if(rotateMode || scaleMode) {
			at = new AffineTransform();	
			saveform = g2d.getTransform();		
			at.setToTranslation(x1 + width/2, y1 + height/2);
			saveMult.setToTranslation(-x1-width/2, -y1-height/2);
			if(rotateMode) { 
				at.rotate(Math.toRadians(angle)); 
			}
			if(scaleMode) {
				at.scale(scaleX, scaleY);
			}
			g2d.transform(at); 
			g2d.fill(saveMult.createTransformedShape(path));
			g2d.setColor(Color.BLACK);
			g2d.draw(saveMult.createTransformedShape(path));
			g2d.setTransform(saveform);
		}
		else {	//not rotate, not resize mode
			g2d.fill(path);
			g2d.setColor(Color.BLACK);
			g2d.draw(path);
		}
		g2d.setTransform(saveforms);
	}
	public void draw(Graphics g) {
		Graphics2D g2d = (Graphics2D) g;		
		g2d.setStroke(new BasicStroke(strokeSize));
		if(hide == false) {
			if(rotateMode || scaleMode) {
				at = new AffineTransform();
				saveform = g2d.getTransform();	
				at.setToTranslation(x1 + width/2, y1 + height/2);
				//AffineTransform saveMult = new AffineTransform();
				saveMult.setToTranslation(-x1-width/2, -y1-height/2);
				if(rotateMode) { 
					at.rotate(Math.toRadians(angle)); 
				}
				if(scaleMode) {
					at.scale(scaleX, scaleY);
				}
				g2d.transform(at); 
				
				if(colorMode) {
					AlphaComposite ac = AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, colorOpacity);
					g2d.setComposite(ac);
					g2d.setColor(fillColor);
					g2d.fill(saveMult.createTransformedShape(path));
				}					
				if(gradientMode && width!=0) {
					drawGradientTransform(g2d);
					g2d.fill(saveMult.createTransformedShape(path));
				}
				if(patternMode) {
					if(firstPatternMode) {
						bi = new BufferedImage(
								patternScaleWidth, patternScaleWidth, 
								BufferedImage.TYPE_INT_RGB);
						big = bi.createGraphics();
						big.drawImage(patternImg, 0, 0, 
								patternScaleWidth, patternScaleWidth, 
								0, 0, patternSrcWidth, patternSrcHeight, null);
						texture = new TexturePaint(bi, 
								new Rectangle2D.Float(
										-width/2, -height/2, 
										patternScaleWidth, patternScaleWidth));
						AlphaComposite pac = AlphaComposite.getInstance(
								AlphaComposite.SRC_OVER, patternOpacity);
						g2d.setComposite(pac);
						g2d.setPaint(texture);						
						g2d.fill(saveMult.createTransformedShape(path));
						firstPatternMode = false;
					}
					else {
						AlphaComposite pac = AlphaComposite.getInstance(
								AlphaComposite.SRC_OVER, patternOpacity);
						g2d.setComposite(pac);
						g2d.setPaint(texture);	
						g2d.fill(saveMult.createTransformedShape(path));
					}
				}
				if(strokeMode) {	//strokeMode
					g2d.setStroke(new BasicStroke(strokeSize));
					AlphaComposite ac = AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, strokeOpacity);
					g2d.setComposite(ac);
					if(strokeFillSelector == 0) {	
						g2d.setColor(strokeColor);
					}
					else if(strokeFillSelector == 1 && width!=0) {	//gradient
						drawStrokeGradientTransform(g2d);
					}
					else if(strokeFillSelector == 2) {	//pattern
						if(firstStrokePatternMode) {
							BufferedImage bii = new BufferedImage(
									strokePatternScaleWidth, strokePatternScaleWidth, 
									BufferedImage.TYPE_INT_RGB);
							Graphics2D biig = bii.createGraphics();
							biig.drawImage(strokeImg, 0, 0, 
									strokePatternScaleWidth, strokePatternScaleWidth, 
									0, 0, strokeImgWidth, 
									strokeImgHeight, null);
							strokeTexture = new TexturePaint(bii, 
									new Rectangle2D.Float(
											-width/2, -height/2, 
											strokePatternScaleWidth, 
											strokePatternScaleWidth));		
							firstStrokePatternMode = false;
						}
						g2d.setPaint(strokeTexture);
					}
					g2d.draw(saveMult.createTransformedShape(path));						
				}			
				if(select) {
					if(selectStroke == null)
						selectStroke = new BasicStroke(1);
					g2d.setStroke(selectStroke);
					g2d.setColor(Color.BLUE);
					g2d.draw(saveMult.createTransformedShape(path));
				} else if(reShape) {
					drawReshapeStroke(g2d, rotateMode || scaleMode);				
				}
				g2d.setTransform(saveform);
				//g2d.setClip(new Rectangle(0, 0, screenWidth, screenHeight));
			}
			else {	//not rotate, not resize mode
				if(colorMode) {
					AlphaComposite ac = AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, colorOpacity);
					g2d.setComposite(ac);
					g2d.setColor(fillColor);
					g2d.fill(path);
				}
				if(gradientMode && width!=0)  {
					drawGradient(g2d);
					g2d.fill(path);
				}			
				if(patternMode) {
					if(firstPatternMode) {						
						bi = new BufferedImage(
								patternScaleWidth, patternScaleWidth, 
								BufferedImage.TYPE_INT_RGB);
						big = bi.createGraphics();
						big.drawImage(patternImg, 0, 0, 
								patternScaleWidth, patternScaleWidth, 
								0, 0, patternSrcWidth, patternSrcHeight, null);
						texture = new TexturePaint(bi, 
								new Rectangle2D.Float(
								x1, y1, 
								patternScaleWidth, 
								patternScaleWidth));
						AlphaComposite pac = AlphaComposite.getInstance(
								AlphaComposite.SRC_OVER, patternOpacity);
					g2d.setComposite(pac);
						g2d.setPaint(texture);						
						g2d.fill(path);
						firstPatternMode = false;
					}
					else {
						AlphaComposite pac = AlphaComposite.getInstance(
								AlphaComposite.SRC_OVER, patternOpacity);
						g2d.setComposite(pac);
						g2d.setPaint(texture);
						g2d.fill(path);
					}
				}
				if(strokeMode) {	//strokeMode
					//g2d.setStroke(new BasicStroke(strokeSize));
					g2d.setStroke(new BasicStroke(strokeSize));
					AlphaComposite ac = AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, strokeOpacity);
					g2d.setComposite(ac);
					if(strokeFillSelector == 0) {	
						g2d.setColor(strokeColor);
					}
					else if(strokeFillSelector == 1 && width!=0) {	//gradient
						drawStrokeGradient(g2d);
					}
					else if(strokeFillSelector == 2) {	//pattern
						if(firstStrokePatternMode) {
							BufferedImage bii = new BufferedImage(
									strokePatternScaleWidth, strokePatternScaleWidth, 
									BufferedImage.TYPE_INT_RGB);
							Graphics2D biig = bii.createGraphics();
							biig.drawImage(strokeImg, 0, 0, 
									strokePatternScaleWidth, strokePatternScaleWidth, 
									0, 0, strokeImgWidth, 
									strokeImgHeight, null);
							strokeTexture = new TexturePaint(bii, 
									new Rectangle2D.Float(
											x1, y1, 
											strokePatternScaleWidth, 
											strokePatternScaleWidth));
							firstStrokePatternMode = false;
						}
						g2d.setPaint(strokeTexture);							
					}				

					if(isMakePath) {
						g2d.draw(path);
					}
					else {
						g2d.draw(tempPath);
					}
				}	
				//ctrlX2+(x2-ctrlX2)*2
				g2d.setStroke(new BasicStroke((float)(0.5 / scaleX)));
				g2d.setColor(Color.BLUE);
				if(penWhileMode) {
					if(startSecondLine) {
						//g2d.setStroke(new BasicStroke(6.5f));
						g2d.draw(new Line2D.Float(x1, y1, ctrlX1, ctrlY1));
						g2d.fill(new Rectangle2D.Float(x1-2, y1-2, 4, 4));
						g2d.fill(new Ellipse2D.Float(ctrlX1-2, ctrlY1-2, 4, 4));
						//g2d.fill(new Ellipse2D.Float(ctrlX1-2, ctrlX1-2, 4, 4));
					} else {
						//g2d.setStroke(new BasicStroke(3.5f));
						g2d.draw(new Line2D.Float(x1+(x1-ctrlX1), y1+(y1-ctrlY1), ctrlX1, ctrlY1));
						g2d.fill(new Rectangle2D.Float(x1-2, y1-2, 4, 4));
						g2d.fill(new Ellipse2D.Float(x1+(x1-ctrlX1)-2, y1+(y1-ctrlY1)-2, 4, 4));
						g2d.fill(new Ellipse2D.Float(ctrlX1-2, ctrlY1-2, 4, 4));			
					}
					if(!isCountUnderAfterRemoveCurve) {
						//g2d.setStroke(new BasicStroke(1.0f));
						g2d.draw(new Line2D.Float(x2+(x2-ctrlX2), y2+(y2-ctrlY2), ctrlX2, ctrlY2));
						g2d.fill(new Rectangle2D.Float(x2-2, y2-2, 4, 4));
						g2d.fill(new Ellipse2D.Float(x2+(x2-ctrlX2)-2, y2+(y2-ctrlY2)-2, 4, 4));
						g2d.fill(new Ellipse2D.Float(ctrlX2-2, ctrlY2-2, 4, 4));
					}
				}		
				if(select) {
					if(selectStroke == null)
						selectStroke = new BasicStroke(1);
					//g2d.setStroke(selectStroke);
					//g2d.setColor(Color.BLUE);
					//g2d.draw(path);
				} else if(reShape) {
					drawReshapeStroke(g2d, rotateMode || scaleMode);				
				}
			}	//not rotate block end
		}
	}
	
	public void smallDraw(Graphics g, float scale) {
		Graphics2D g2d = (Graphics2D) g;
		AffineTransform ats = new AffineTransform();	
		AffineTransform saveforms = g2d.getTransform();	
		ats.scale(scale, scale);
		g2d.transform(ats);
		
		if(rotateMode || scaleMode) {
			at = new AffineTransform();
			saveform = g2d.getTransform();	
			at.setToTranslation(x1 + width/2, y1 + height/2);
			//AffineTransform saveMult = new AffineTransform();
			saveMult.setToTranslation(-x1-width/2, -y1-height/2);
			if(rotateMode) { 
				at.rotate(Math.toRadians(angle)); 
			}
			if(scaleMode) {
				at.scale(scaleX, scaleY);
			}
			g2d.transform(at); 
			if(colorMode) {
				AlphaComposite ac = AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, colorOpacity);
				g2d.setComposite(ac);
				g2d.setColor(fillColor);
				g2d.fill(saveMult.createTransformedShape(path));
			}					
			if(gradientMode) {
				if(width!=0) {
					drawGradientTransform(g2d);
					g2d.fill(saveMult.createTransformedShape(path));
				}
			}
			if(patternMode) {			
				AlphaComposite pac = AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, patternOpacity);
				g2d.setComposite(pac);
				g2d.setPaint(texture);
				g2d.fill(saveMult.createTransformedShape(path));	
			}
			if(strokeMode) {	//strokeMode
				g2d.setStroke(new BasicStroke(strokeSize));
				AlphaComposite ac = AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, strokeOpacity);
				g2d.setComposite(ac);
				if(strokeFillSelector == 0) {	
					g2d.setColor(strokeColor);
				}
				else if(strokeFillSelector == 1) {	//gradient
					//initStrokeGradient();
					if(width!=0) {
						drawStrokeGradientTransform(g2d);
					}
				}
				else if(strokeFillSelector == 2) {	//pattern
					g2d.setPaint(strokeTexture);			
				}					
				if(strokePosition == 0) {	//outside
					g2d.draw(saveMult.createTransformedShape(path));
				}
				else if(strokePosition == 1) {	//inside
					g2d.draw(saveMult.createTransformedShape(path));
				}
				else if(strokePosition == 2) {	//center
					g2d.draw(saveMult.createTransformedShape(path));
				}
			}
			g2d.setTransform(saveform);
		}
		else {	//not rotate, not resize mode
			if(colorMode) {
				AlphaComposite ac = AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, colorOpacity);
				g2d.setComposite(ac);
				g2d.setColor(fillColor);
				g2d.fill(path);
			}
			if(gradientMode)  {
				if(width!=0) {
					drawGradient(g2d);	
					g2d.fill(path);
				}
			}			
			if(patternMode) {
				AlphaComposite pac = AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, patternOpacity);
				g2d.setComposite(pac);
				g2d.setPaint(texture);
				g2d.fill(path);
			}
			if(strokeMode) {	//strokeMode
				//g2d.setStroke(new BasicStroke(strokeSize));
				g2d.setStroke(new BasicStroke(strokeSize));
				AlphaComposite ac = AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, strokeOpacity);
				g2d.setComposite(ac);
				if(strokeFillSelector == 0) {	
					g2d.setColor(strokeColor);
				}
				else if(strokeFillSelector == 1) {	//gradient
					//initStrokeGradient();
					if(width!=0) {
						drawStrokeGradient(g2d);
					}
				}
				else if(strokeFillSelector == 2) {	//pattern
					g2d.setPaint(strokeTexture);			
				}					
				if(strokePosition == 0) {	//outside
					g2d.draw(path);
				}
				else if(strokePosition == 1) {	//inside
					g2d.draw(path);
				}
				else if(strokePosition == 2) {	//center
					g2d.draw(path);
				}
			}
		}	//not rotate block end
		g2d.setTransform(saveforms);
	}
	
	public float getStartX1() {
		return startX1;
	}
	
	public float getStartY1() {
		return startY1;
	}
	public void setStartX1(float startX1) {
		this.startX1 = startX1;
	}
	public void setStartY1(float startY1) {
		this.startY1 = startY1;
	}
	
	public void setPenWhileMode(boolean _penWhileMode) {
		penWhileMode = _penWhileMode;
	}
	
	
	public boolean isPenWhileMode() {
		return penWhileMode;
	}	
}
