package com.sharppaint.drawtools;
import java.awt.*;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
//import java.util.Hashtable;
//import java.awt.font.LineBreakMeasurer;
//import java.awt.font.TextAttribute;
//import java.text.AttributedCharacterIterator;
//import java.text.AttributedString;

import javax.swing.ImageIcon;

import com.sharppaint.Constants;
import com.sharppaint.MainWindow;
import com.sharppaint.layermanager.LayerManagementDialog;


public class TextTool extends GradientHelper {
	/**
	 * 
	 */
	private static final long serialVersionUID = -5450048415110990873L;

	/************************version 0.7***********************/
	/********************** never change *********************/
	private int fontSize;
	private int fontStyle;
	private String fontName;
	private String text;
	private float centerX, centerY;
	private float textEditBoxWidth, textEditBoxHeight;
   
    
    //private LineBreakMeasurer lineMeasurer;
    //private int paragraphStart;
    //private int paragraphEnd;
    //transient private Hashtable<TextAttribute, Object> map =
    //   new Hashtable<TextAttribute, Object>();
	//transient private AttributedString attributeText;
	transient private Font font;
	transient private int textImageWidth, textImageHeight;
	transient private ImageIcon imageicon;
	transient private Shape sha;
	transient private boolean alreadyDraw;
	transient private Image textImg;
	/********************** never change *********************/
	
	public TextTool(float _x1, float _y1,
			int _fontSize, int _fontStyle, 
			String _fontName, String _text){
		toolName = DrawToolConst.TEXT;
		x1 = _x1;
		y1 = _y1;
		fontSize = _fontSize;
		fontStyle = _fontStyle;
		fontName = _fontName;
		//System.out.println(fontName);
		text = _text;
		angle = 0;
		rotateMode = false;
	}
	
	public TextTool(Element e){
		toolName = DrawToolConst.TEXT;
		//font
		x1 = ((TextTool)e).x1;
		y1 = ((TextTool)e).y1;
		fontSize = ((TextTool)e).fontSize;
		fontStyle = ((TextTool)e).fontStyle;
		fontName = ((TextTool)e).fontName;
		text = ((TextTool)e).text;
		font = new Font( fontName, fontStyle, fontSize);
		x2 = ((TextTool)e).x2;
		y2 = ((TextTool)e).y2;
		centerX = ((TextTool)e).centerX;
		centerY = ((TextTool)e).centerY;
		width = e.width;
		height = e.height;
		textImg = ((TextTool)e).textImg;
		
		angle = e.angle;
		rotateMode = e.rotateMode;
		
		colorMode = e.colorMode;
		gradientMode = e.gradientMode;
		patternMode = e.patternMode;
		strokeMode = e.strokeMode;		
		
		angle = e.angle;
		rotateMode = e.rotateMode;
		scaleMode = e.scaleMode;
		scaleX = e.scaleX;
		scaleY = e.scaleY;
		selectStroke = e.selectStroke;
		
		if(colorMode) {
			colorOpacity = e.colorOpacity;
			fillColor = e.fillColor;
		}
		if(gradientMode) {		//gradList = e.gradList;		
			gradientOpacity = e.gradientOpacity;
			scaleGrad = e.scaleGrad;
			angleGrad = e.angleGrad;
			gradStyle = e.gradStyle;
			isGradCycle = e.isGradCycle;
			gradList = new ArrayList<GradientTool>();
			for(int i=0; i<e.gradList.size(); i++) {
				gradRect = new GradientTool(e.gradList.get(i));
				gradList.add(gradRect);
			}
			initGradient();
		}
		if(patternMode) {
			patternPath = e.patternPath;
			patternScale = e.patternScale;
			patternOpacity = e.patternOpacity;
			patternImg = new ImageIcon(
					getClass().getResource(patternPath)).getImage();
			patternSrcWidth = e.patternSrcWidth;
			patternSrcHeight = e.patternSrcHeight;
			patternScaleWidth = e.patternScaleWidth;
		}
		if(strokeMode) {
			strokeSize = e.strokeSize;
			strokeOpacity = e.strokeOpacity;
			strokePosition = e.strokePosition;
			strokeFillSelector = e.strokeFillSelector;
			if(strokeFillSelector == 0) {
				strokeColor = e.strokeColor;
			}
			else if(strokeFillSelector == 1) {
				strokeGradScale = e.strokeGradScale;
				strokeGradAngle = e.strokeGradAngle;
				strokeGradStyle = e.strokeGradStyle;
				isStrokeGradCycle = e.isStrokeGradCycle;
				strokeGradList = new ArrayList<GradientTool>();
				for(int i=0; i<e.strokeGradList.size(); i++) {
					gradRect = new GradientTool(e.strokeGradList.get(i));
					strokeGradList.add(gradRect);
				}
				initStrokeGradient();
			}
			else if(strokeFillSelector == 2) {
				strokePatternScale = e.strokePatternScale;
				strokePatternPath = e.strokePatternPath;
				strokeImg = new ImageIcon(
						getClass().getResource(strokePatternPath)).getImage();
				strokeImgWidth = e.strokeImgWidth;
				strokeImgHeight = e.strokeImgHeight;
				strokePatternScaleWidth = e.strokePatternScaleWidth;
			}
		}
		selectStroke = e.selectStroke;
	}
	public void alignY1FromSVG() {
		y1 = y1-height;
	}
	private void setTextMetric(float _width, float _height) {
		width = _width;
		height = _height;
		centerX = width/2.0f;
		centerY = height/2.0f;
		x2 = x1 + width;
		y2 = y1 + height;
	}
	public void setText(String _text) {
		text = _text;
	}
	public String getText() {
		return text;
	}
	public Font getFont() {
		return font;
	}
	public void setFont(String _name,  int _style, int _size) {		
		fontName = _name;
		fontStyle = _style;
		fontSize = _size;
		font = new Font( fontName, fontStyle, fontSize );
	}
	public void initTextTool() {
		imageicon = new ImageIcon(
				getClass().getResource(Constants.ICON_PATH + "texti.gif"));
		textImg = imageicon.getImage();
		font = new Font( fontName, fontStyle, fontSize);
		initTextMetric();
	}
	private void initTextMetric() {
		Graphics g2 = MainWindow.getInstance().getGraphics();
		FontMetrics metrics = 
				g2.getFontMetrics(font);
	    float adv = metrics.stringWidth(text);
	    float hgt = metrics.getHeight() - (metrics.getHeight()-fontSize)/2.0f;
	    setTextMetric(adv, hgt);
	}
	public boolean match(float x,float y) {
		//if(sha.contains(x, y))		match = true;
		if ( (x>=x1 && x<=x2) && (y>=y1 && y<=y2) ) {
			match=true;
		}
		else
			match=false;
		return match;
	}
	public void initSmallPanelSize() {
		alreadyDraw = false;
	}
	public void translate(float _x1, float _y1, float _x2, float _y2) {
		x1=x1-(_x1-_x2);
		y1=y1-(_y1-_y2);
		x2=x2-(_x1-_x2);
		y2=y2-(_y1-_y2);	
	}
	public void simpleDraw(Graphics g, float scale) {
		if(alreadyDraw == false) {
			textImageWidth = LayerManagementDialog.getInstance().getSDrawPanelWidth()-2;
			textImageHeight = LayerManagementDialog.getInstance().getSDrawPanelHeight()-2;
			alreadyDraw = true;
		}
		Graphics2D g2d = (Graphics2D) g;
		g2d.drawImage(textImg, 2, 2, 
				textImageWidth, textImageHeight, 
				0, 0, textImg.getWidth(null), textImg.getHeight(null), null);
	}
	public void smallDraw(Graphics g, float scale) {
		Graphics2D g2d = (Graphics2D) g;
		g2d.drawImage(textImg, 2, 2, 
				textImageWidth, textImageHeight, 
				0, 0, textImg.getWidth(null), textImg.getHeight(null), null);
	}
	public void draw(Graphics g) {
		Graphics2D g2d = (Graphics2D) g;
		g2d.setFont( font );		
			    
		if(hide == false) {
			if(rotateMode || scaleMode) {
				FontRenderContext frc = g2d.getFontRenderContext();
				TextLayout tl = new TextLayout(text, font, frc);
		        //float sw = (float) tl.getBounds().getWidth();
		        //float sh = (float) tl.getBounds().getHeight();
				AffineTransform Tx = 
					AffineTransform.getTranslateInstance(x1, y1+height);
				sha = tl.getOutline(Tx);
				at = new AffineTransform();	
				saveform = g2d.getTransform();
				at.setToTranslation(x1 + centerX, y1 + height*18.0f/25.0f);
				AffineTransform saveMult = new AffineTransform();
				saveMult.setToTranslation(-x1-centerX, -y1-height*18.0f/25.0f);
				if(rotateMode) { 
					at.rotate(Math.toRadians(angle)); 
				}
				if(scaleMode) {
					at.scale(scaleX, scaleY);
				}
				g2d.transform(at); 
				
				if(colorMode) {
					AlphaComposite ac = AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, colorOpacity);
					g2d.setComposite(ac);
					g2d.setColor(fillColor);
					g2d.fill(saveMult.createTransformedShape(sha));
				}					
				if(gradientMode && width!=0) {
					drawGradientTransform(g2d);
					g2d.fill(saveMult.createTransformedShape(sha));
				}
				if(patternMode) {
					if(firstPatternMode) {
						bi = new BufferedImage(patternScaleWidth, 
								patternScaleWidth, 
								BufferedImage.TYPE_INT_RGB);
						big = bi.createGraphics();
						big.drawImage(patternImg, 
								0, 0, patternScaleWidth, patternScaleWidth, 
								0, 0, patternSrcWidth, patternSrcHeight, null);
						texture = new TexturePaint(bi, 
								new Rectangle2D.Float(
										-centerX, -height*3.0f/4.0f, 
										patternScaleWidth, patternScaleWidth));
						AlphaComposite pac = AlphaComposite.getInstance(
								AlphaComposite.SRC_OVER, patternOpacity);
						g2d.setComposite(pac);
						g2d.setPaint(texture);						
						g2d.fill(saveMult.createTransformedShape(sha));
						firstPatternMode = false;
					}
					else {
						AlphaComposite pac = AlphaComposite.getInstance(
								AlphaComposite.SRC_OVER, patternOpacity);
						g2d.setComposite(pac);
						g2d.setPaint(texture);	
						g2d.fill(saveMult.createTransformedShape(sha));
					}
				}
				if(strokeMode) {	//strokeMode
					g2d.setStroke(new BasicStroke(strokeSize));
					AlphaComposite ac = AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, strokeOpacity);
					g2d.setComposite(ac);
					if(strokeFillSelector == 0) {	
						g2d.setColor(strokeColor);
					}
					else if(strokeFillSelector == 1) {	//gradient
						drawStrokeGradientTransform(g2d);
					}
					else if(strokeFillSelector == 2) {	//pattern
						if(firstStrokePatternMode) {
							BufferedImage bii = new BufferedImage(
									strokePatternScaleWidth, strokePatternScaleWidth, 
									BufferedImage.TYPE_INT_RGB);
							Graphics2D biig = bii.createGraphics();
							biig.drawImage(strokeImg, 
									0, 0, strokePatternScaleWidth, strokePatternScaleWidth, 
									0, 0, strokeImgWidth, strokeImgHeight, null);
							strokeTexture = new TexturePaint(bii, 
									new Rectangle2D.Float(
											-centerX, -height*3.0f/4.0f,
											strokePatternScaleWidth, 
											strokePatternScaleWidth));	
							firstStrokePatternMode = false;
						}
						g2d.setPaint(strokeTexture);
					}					
					if(strokePosition == 0) {	//outside
						g2d.draw(saveMult.createTransformedShape(sha));
					}
					else if(strokePosition == 1) {	//inside
						g2d.draw(saveMult.createTransformedShape(sha));
					}
					else if(strokePosition == 2) {	//center
						g2d.draw(saveMult.createTransformedShape(sha));
					}
				}		
				if(select) {
					if(selectStroke == null)
						selectStroke = new BasicStroke(1);
					g2d.setStroke(selectStroke);
					g2d.setColor(Color.BLUE);
					g2d.draw(new Rectangle2D.Float(
							-centerX, -height*18.0f/25.0f, 
							textEditBoxWidth, textEditBoxHeight));
				} else if(reShape) {
					drawReshapeStroke(g2d, rotateMode || scaleMode);				
				}
				g2d.setTransform(saveform);
				//g2d.setClip(new Rectangle(0, 0, screenWidth, screenHeight));
			}
			else {	//not rotate, not resize mode
				FontRenderContext frc = g2d.getFontRenderContext();
				TextLayout tl = new TextLayout(text, font, frc);
		        //float sw = (float) tl.getBounds().getWidth();
		        //float sh = (float) tl.getBounds().getHeight();
				AffineTransform Tx = 
					AffineTransform.getTranslateInstance(x1, y1+height);
				sha = tl.getOutline(Tx);				//g2d.draw(sha);
				if(colorMode) {
					AlphaComposite ac = AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, colorOpacity);
					g2d.setComposite(ac);
					g2d.setColor(fillColor);
					g2d.fill(sha);
				}
				if(gradientMode)  {
					drawGradient(g2d);
					g2d.fill(sha);
				}
				if(patternMode) {
					if(firstPatternMode) {						
						bi = new BufferedImage(
								patternScaleWidth, patternScaleWidth, 
								BufferedImage.TYPE_INT_RGB);
						big = bi.createGraphics();
						big.drawImage(patternImg, 0, 0, 
								patternScaleWidth, patternScaleWidth, 
								0, 0, patternSrcWidth, patternSrcHeight, null);
						texture = new TexturePaint(bi, 
								new Rectangle2D.Float(x1, y1, 
									patternScaleWidth, 
									patternScaleWidth));
						AlphaComposite pac = AlphaComposite.getInstance(
								AlphaComposite.SRC_OVER, patternOpacity);
						g2d.setComposite(pac);
						g2d.setPaint(texture);						
						g2d.fill(sha);
						firstPatternMode = false;
					}
					else {
						AlphaComposite pac = AlphaComposite.getInstance(
								AlphaComposite.SRC_OVER, patternOpacity);
						g2d.setComposite(pac);
						g2d.setPaint(texture);
						g2d.fill(sha);
					}
				}
				if(strokeMode) {	//strokeMode
					g2d.setStroke(new BasicStroke(strokeSize));
					AlphaComposite ac = AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, strokeOpacity);
					g2d.setComposite(ac);
					if(strokeFillSelector == 0) {	
						g2d.setColor(strokeColor);
					}
					else if(strokeFillSelector == 1) {	//gradient
						drawStrokeGradient(g2d);
					}
					else if(strokeFillSelector == 2) {	//pattern
						if(firstStrokePatternMode) {
							BufferedImage bii = new BufferedImage(
									strokePatternScaleWidth, strokePatternScaleWidth, 
									BufferedImage.TYPE_INT_RGB);
							Graphics2D biig = bii.createGraphics();
							biig.drawImage(strokeImg, 0, 0, 
									strokePatternScaleWidth, strokePatternScaleWidth, 
									0, 0, strokeImgWidth, 
									strokeImgHeight, null);
							strokeTexture = new TexturePaint(bii, 
									new Rectangle2D.Float(x1, y1, 
											strokePatternScaleWidth, 
											strokePatternScaleWidth));
							firstStrokePatternMode = false;
						}
						g2d.setPaint(strokeTexture);	
					}					
					if(strokePosition == 0) {	//outside
						g2d.draw(sha);
					}
					else if(strokePosition == 1) {	//inside
						g2d.draw(sha);
					}
					else if(strokePosition == 2) {	//center
						g2d.draw(sha);
					}
				}			
				if(select) {
					if(selectStroke == null)
						selectStroke = new BasicStroke(1);
					g2d.setStroke(selectStroke);
					g2d.setColor(Color.BLUE);
					g2d.draw(new Rectangle2D.Float(x1, y1, textEditBoxWidth, textEditBoxHeight));
					//g2d.draw(drawShape);
				} else if(reShape) {
					drawReshapeStroke(g2d, rotateMode || scaleMode);				
				}
			}	//not editmode block end
		}
	}
	
	public float getTextEditBoxWidth() {
		return textEditBoxWidth;
	}
	
	public void setTextEditBoxWidth(float textEditBoxWidth) {
		this.textEditBoxWidth = textEditBoxWidth;
	}
	
	public float getTextEditBoxHeight() {
		return textEditBoxHeight;
	}
	
	public void setTextEditBoxHeight(float textEditBoxHeight) {
		this.textEditBoxHeight = textEditBoxHeight;
	}
	
	public void setTextImageHeight(int textImageHeight) {
		this.textImageHeight = textImageHeight;
	}
	
	public void setTextImageWidth(int textImageWidth) {
		this.textImageWidth = textImageWidth;
	}

	public float getTextY1AddedHeight() {
		return y1+height;
	}
	
	public String getFontName() {
		return fontName;
	}
	
	public int getFontSize() {
		return fontSize;
	}
	
	public int getFontStyle() {
		return fontStyle;
	}
}
