package com.sharppaint.file;

import java.io.*;

import javax.swing.*;

import com.sharppaint.MainWindow;
import com.sharppaint.drawtools.DrawToolConst;
import com.sharppaint.drawtools.Element;
import com.sharppaint.drawtools.ImageTool;
import com.sharppaint.drawtools.MultiLineTool;
import com.sharppaint.drawtools.PenTool;
import com.sharppaint.drawtools.PreviewTool;
import com.sharppaint.drawtools.TextTool;
import com.sharppaint.svg.ElementParser;

import java.util.*;
import java.awt.Image;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;

public class FileTool  {
	
	private static final long serialVersionUID = -7474637785691653026L;
	
	private Element element;
	private Vector<Element> tempDrawVector;
	private JFileChooser fileChooser;
	private File file;
	private MyFileFilter jpg, spd, gif, png, svg, all;
	private String filePath;
	private String ext;
	private int canvasWidth, canvasHeight;
	private ElementParser elementParser;
	public final static int PREVIEW_COUNT = 70;
	private static FileTool fileTool = null;

	public static FileTool getInstance() {
		if (fileTool == null)
			fileTool = new FileTool();
		return fileTool;
	}
	private FileTool(){
		element = null;
		tempDrawVector = new Vector<Element>();
		file = null;
		jpg = new MyFileFilter();
		jpg.addExtension("JPG");
		jpg.addExtension("JPEG");
		jpg.setDescription("JPEG");
		spd = new MyFileFilter();
		spd.addExtension("SPD");
		spd.setDescription("SharpPaint");
		gif = new MyFileFilter();
		gif.addExtension("GIF");
		gif.setDescription("GIF");
		png = new MyFileFilter();
		png.addExtension("PNG");
		png.setDescription("PNG");
		svg = new MyFileFilter();
		svg.addExtension("SVG");
		svg.setDescription("SVG");
	}
	//vector file ְޱ  get, set޼
	@SuppressWarnings("unchecked")
	public void setVector(Vector<Element> vector) { 
		tempDrawVector = (Vector<Element>)vector.clone();
	}
	@SuppressWarnings("unchecked")
	public Vector getVector() { return (Vector<Element>)tempDrawVector.clone(); }
	public void setFile(File _file) { file=_file; }
	public File getFile() { return file; }
	
	public void selectExt() {
		fileChooser.removeChoosableFileFilter(spd);
	}
	public boolean openImage() {
		boolean access = false;
		fileChooser = new JFileChooser();
	    fileChooser.setFileSelectionMode( JFileChooser.FILES_AND_DIRECTORIES );
	    
		String[] allFile = {"gif", "jpg", "png"};
		all = new MyFileFilter(allFile, " ׸ ");
		fileChooser.addChoosableFileFilter(spd);
		fileChooser.addChoosableFileFilter(gif);
		fileChooser.addChoosableFileFilter(jpg);
		fileChooser.addChoosableFileFilter(png);
		fileChooser.addChoosableFileFilter(svg);
		fileChooser.addChoosableFileFilter(all);
		fileChooser.setFileView(new ImageFileView());
		fileChooser.setAccessory(new ImagePreview(fileChooser));

	    int cancel=fileChooser.showOpenDialog(
	    		MainWindow.getInstance());	    
	    file=fileChooser.getSelectedFile();
	    
	    tempDrawVector = new Vector<Element>();
	    if(cancel!=JFileChooser.CANCEL_OPTION){	    	
		    access = true;
	    } else { access=false; }
	    return access;
	}
	public boolean openFile() {	// 
		boolean access = false;
		fileChooser = new JFileChooser();
	    fileChooser.setFileSelectionMode( JFileChooser.FILES_AND_DIRECTORIES );
	    
		String[] allFile = {"spd", "gif", "jpg", "png", "svg"};
		all = new MyFileFilter(allFile, " ׸ ");
		fileChooser.addChoosableFileFilter(spd);
		fileChooser.addChoosableFileFilter(gif);
		fileChooser.addChoosableFileFilter(jpg);
		fileChooser.addChoosableFileFilter(png);
		fileChooser.addChoosableFileFilter(svg);
		fileChooser.addChoosableFileFilter(all);
		fileChooser.setFileView(new ImageFileView());
		fileChooser.setAccessory(new ImagePreview(fileChooser));

	    int cancel=fileChooser.showOpenDialog(
	    		MainWindow.getInstance());		    
	    file=fileChooser.getSelectedFile();
	    if(file != null) {
		    boolean existFile = 
		    	MainWindow.getInstance().checkExistFileName(file.getName());
		    if(existFile) {
		    	return false;
		    }
	    }
	    
	    tempDrawVector = new Vector<Element>();
	    
	    int imagePixel[];                         // ̹ ȼ  迭
		int imageWidth, imageHeight;
		
	    if(cancel!=JFileChooser.CANCEL_OPTION){	    	
	    	String []s=file.getName().split("[.]");
	    	if(s.length>1) {
		    	ext = s[1];
		    	if(ext.equalsIgnoreCase("spd")) {
				    try {
				    	ObjectInputStream is = new ObjectInputStream(new FileInputStream(file));
				    	canvasWidth=is.readInt();
			    		canvasHeight=is.readInt();
				    	try {
				    		if((element = (Element)is.readObject()) != null) {
				    			if( element.getToolName() == DrawToolConst.PREVIEW) {
				    				is.readObject();
				    			} else if( element.getToolName() == DrawToolConst.IMAGE) {
					    			imageWidth = ((ImageTool)element).getImageWidth();
									imageHeight =  ((ImageTool)element).getImageHeight();
									imagePixel = (int[])is.readObject();
					    			Image image = 
					    	    		MainWindow.getInstance().createImage(new MemoryImageSource(
					    					imageWidth, 
					    					imageHeight,
					    					imagePixel, 0, imageWidth));
					    			((ImageTool)element).setImage(image);
					    			((ImageTool)element).initElements();
					    		} else if ( element.getToolName() == DrawToolConst.PEN) {
					    			((PenTool)element).setPathfromPoint();
					    		} else if ( element.getToolName() == DrawToolConst.MULTILINE) {
					    			((MultiLineTool)element).setPathfromPoint();
					    		} else if ( element.getToolName() == DrawToolConst.TEXT) {
					    			((TextTool)element).initTextTool();
					    		}
				    			if( element.getToolName() != DrawToolConst.PREVIEW) {
						    		if(element.getPatternMode()) {
						    			imageWidth = element.getPatternImgWidth();
										imageHeight =  element.getPatternImgHeight(); 
										imagePixel = (int[])is.readObject();
						    			Image patternImg = MainWindow.getInstance().createImage(
						    					new MemoryImageSource(
						    							imageWidth, imageHeight, imagePixel, 
						    							0, imageWidth));
						    			element.setPatternImg(patternImg);
						    		}
						    		if(element.getStrokeMode() 
						    				&& (element.getStrokeFillMode()
						    						== DrawToolConst.STROKE_PATTERN)) {
						    			imageWidth = element.getSPatternImgWidth();
										imageHeight =  element.getSPatternImgHeight();
										imagePixel = (int[])is.readObject();
						    			Image strokeImg = MainWindow.getInstance().createImage(
						    					new MemoryImageSource(
						    							imageWidth, 
						    							imageHeight, 
						    							imagePixel, 
						    							0, imageWidth));
						    			element.setStrokePatternImage(strokeImg);
						    		}
				    				tempDrawVector.add(element);
				    			}
				    		}
				    		while((element = (Element)is.readObject()) != null ) {
					    		if( element.getToolName() == DrawToolConst.IMAGE) {
					    			imageWidth = ((ImageTool)element).getImageWidth();
									imageHeight =  ((ImageTool)element).getImageHeight();
									imagePixel = (int[])is.readObject();
					    			Image image = 
					    	    		MainWindow.getInstance().createImage(new MemoryImageSource(
					    					imageWidth, 
					    					imageHeight,
					    					imagePixel, 0, imageWidth));
					    			((ImageTool)element).setImage(image);
					    			((ImageTool)element).initElements();
					    		} else if ( element.getToolName() == DrawToolConst.PEN) {
					    			((PenTool)element).setPathfromPoint();
					    		} else if ( element.getToolName() == DrawToolConst.MULTILINE) {
					    			((MultiLineTool)element).setPathfromPoint();
					    		} else if ( element.getToolName() == DrawToolConst.TEXT) {
					    			((TextTool)element).initTextTool();
					    		}
					    		if(element.getPatternMode()) {
					    			imageWidth = element.getPatternImgWidth();
									imageHeight =  element.getPatternImgHeight(); 
									imagePixel = (int[])is.readObject();
					    			Image patternImg = MainWindow.getInstance().createImage(
					    					new MemoryImageSource(
					    							imageWidth, imageHeight, imagePixel, 
					    							0, imageWidth));
					    			element.setPatternImg(patternImg);
					    		}
					    		if(element.getStrokeMode() 
					    				&& (element.getStrokeFillMode()
					    						== DrawToolConst.STROKE_PATTERN)) {
					    			imageWidth = element.getSPatternImgWidth();
									imageHeight =  element.getSPatternImgHeight();
									imagePixel = (int[])is.readObject();
					    			Image strokeImg = MainWindow.getInstance().createImage(
					    					new MemoryImageSource(
					    							imageWidth, 
					    							imageHeight, 
					    							imagePixel, 
					    							0, imageWidth));
					    			element.setStrokePatternImage(strokeImg);
					    		}
					    		tempDrawVector.add(element);
				    		}			    		
				    	} catch(Exception e){ }
				    } catch (Exception e) {
				    	 e.printStackTrace();
				    }
		    	} 
		    	/**
		         * svg file open
		    	 * 
		    	*/
		    	else if(ext.equalsIgnoreCase("svg")) {
		    		elementParser = ElementParser.getInstance();
		    		elementParser.init();
		    		elementParser.svgOpen(
		    				file, tempDrawVector);
		    	}
	    	}
	    	//else if(ext.equals("jpg")) {
	    	//}
		    access = true;
	    } else { access=false; }
	    return access;
	}

	public String saveFile(){			// ο ̸  
		fileChooser = new JFileChooser();
		fileChooser.setFileSelectionMode( JFileChooser.FILES_AND_DIRECTORIES );		
		fileChooser.setFileFilter(gif);
		fileChooser.setFileFilter(jpg);		
		fileChooser.setFileFilter(png);
		fileChooser.setFileFilter(spd);
		fileChooser.setFileFilter(svg);
		fileChooser.setFileView(new ImageFileView());
		fileChooser.setAccessory(new ImagePreview(fileChooser));
		
		fileChooser.setDialogTitle("ٸ ̸ ");
		int cancel=fileChooser.showSaveDialog(MainWindow.getInstance());
	    file = fileChooser.getSelectedFile();
	    
	    if(cancel!=JFileChooser.CANCEL_OPTION) {
	    	save();
	    }
	    else
	    	return null;
	    return filePath;
	}	

	//image file ̸ path , spd 
	private void save() {		// ޼ (ȣϱ  ϴ ʿ tempDrawVector setϿ 
		try{
	    	filePath = file.getPath();
	    	MyFileFilter tempFilter = (MyFileFilter)fileChooser.getFileFilter();
	    	if(tempFilter.equals(jpg)) {
	    		if(!filePath.endsWith(".jpg")) {
	    			filePath = filePath + '.' + "jpg";
	    		}
	    		JOptionPane.showMessageDialog(null,"Ǿϴ.");	    		
	    	}
	    	else if(tempFilter.equals(gif)) {
	    		if(!filePath.endsWith(".gif")) {
	    			filePath = filePath + '.' + "gif";
	    		}
	    		JOptionPane.showMessageDialog(null,"Ǿϴ.");	    		
	    	}
	    	else if(tempFilter.equals(png)) {
	    		if(!filePath.endsWith(".png")) {
	    			filePath = filePath + '.' + "png";
	    		}
	    		JOptionPane.showMessageDialog(null,"Ǿϴ.");	    		
	    	}
	    	else if(tempFilter.equals(spd)) {
	    		if(!filePath.endsWith(".spd")) {
	    			filePath = filePath + '.' + "spd";
	    		}	    		   
	    		ObjectOutputStream os = new ObjectOutputStream(new FileOutputStream(filePath));
	    		os.writeInt(canvasWidth);
	    		os.writeInt(canvasHeight);
	    		if(tempDrawVector.size()>PREVIEW_COUNT) {
		    		Image previewImage = MainWindow.getInstance().getPanel().getVimg();
		    		int prevImageWidth =  previewImage.getWidth(null);
					int prevImageHeight = previewImage.getHeight(null);
					int prevImagePixel[] = new int[prevImageWidth * prevImageHeight]; //imagePixelʱȭ 
				    PixelGrabber prevGrabber = new PixelGrabber(previewImage, 0, 0, 
				    		prevImageWidth, prevImageHeight, prevImagePixel, 0, prevImageWidth);
				    try {
				    	prevGrabber.grabPixels();
				    } catch(Exception e) {
				        e.printStackTrace();
				    }
				    element = new PreviewTool();
				    element.setX1(0);
				    element.setY1(0);
				    element.setWidth(prevImageWidth);
				    element.setHeight(prevImageHeight);
				    os.writeObject(element);
				    os.writeObject(prevImagePixel);
	    		}
				for(int i=0;i<tempDrawVector.size();i++){
					element = (Element)tempDrawVector.elementAt(i);
				    os.writeObject(element);
					if( element.getToolName() == DrawToolConst.IMAGE) {
						int imagePixel[];	//ȼ  迭
						Image image = ((ImageTool)tempDrawVector.elementAt(i)).getImage();
			    		   
						int imageWidth =  image.getWidth(null);
						int imageHeight = image.getHeight(null);
					    imagePixel = new int[imageWidth * imageHeight]; //imagePixelʱȭ 
					    PixelGrabber grabber = new PixelGrabber(image, 0, 0, 
					    		imageWidth, imageHeight, imagePixel, 0, imageWidth);
					    try {
					        grabber.grabPixels();
					    } catch(Exception e) {
					        e.printStackTrace();
					    }
					    os.writeObject(imagePixel);
					}
					if (element.getPatternMode()) {
						int imagePixel[];
						Image patternImg = element.getPatternImg(); 
						int imageWidth = patternImg.getWidth(null);
						int imageHeight = patternImg.getHeight(null);
					    imagePixel = new int[imageWidth * imageHeight]; 
					    PixelGrabber grabber = new PixelGrabber(patternImg, 0, 0, 
					    		imageWidth, imageHeight, imagePixel, 0, imageWidth);
					    try {
					        grabber.grabPixels();
					    } catch(Exception e) {
					        e.printStackTrace(); }
					    os.writeObject(imagePixel);
					}
					if (element.getStrokeMode() && 
							element.getStrokeFillMode()==DrawToolConst.STROKE_PATTERN) {
						int imagePixel[];                         // ̹ ȼ  迭
						Image strokeImg = element.getStrokePatternImg();  
						int imageWidth =  strokeImg.getWidth(null);
						int imageHeight = strokeImg.getHeight(null);
					    imagePixel = new int[imageWidth * imageHeight];     
					    PixelGrabber grabber = new PixelGrabber(strokeImg, 0, 0, 
					    		imageWidth, imageHeight, imagePixel, 0, imageWidth);
					    try {
					        grabber.grabPixels();
					    } catch(Exception e) {
					        e.printStackTrace(); }
					    os.writeObject(imagePixel);
					}	
				}
				os.close();
				JOptionPane.showMessageDialog(null,"Ǿϴ.");
	    	}
	    	/**
	         * svg file save
	    	 * 
	    	*/
	    	else if(tempFilter.equals(svg)) {
	    		if(!filePath.endsWith(".svg")) {
	    			filePath = filePath + '.' + "svg";
	    		}
	    		elementParser = ElementParser.getInstance();
	    		elementParser.init();
	    		elementParser.svgSave(
	    				filePath, canvasWidth, canvasHeight, tempDrawVector);
	    		
	    		JOptionPane.showMessageDialog(null,"Ǿϴ.");	 
	    	}
	    } catch(Exception e) { 
	    	e.printStackTrace();
	    }    
	}
	public void saveFile(String path){	//̹   		
    	String []s = path.split("[.]");
    	ext = s[1];
    	filePath = path;
		try{
	    	if(ext.equalsIgnoreCase("jpg") || ext.equalsIgnoreCase("gif") || ext.equalsIgnoreCase("png")) {
	    		JOptionPane.showMessageDialog(null,"Ǿϴ.");	    		
	    	}
	    	else if(ext.equalsIgnoreCase("spd")) {
	    		//System.out.println(filePath + "   FileTool207line");
	    		ObjectOutputStream os = new ObjectOutputStream(new FileOutputStream(filePath));
	    		os.writeInt(canvasWidth);
	    		os.writeInt(canvasHeight);
	    		if(tempDrawVector.size()>PREVIEW_COUNT) {
		    		Image previewImage = MainWindow.getInstance().getPanel().getVimg();
		    		int prevImageWidth = previewImage.getWidth(null);
					int prevImageHeight = previewImage.getHeight(null);
					int prevImagePixel[] = new int[prevImageWidth * prevImageHeight]; //imagePixelʱȭ 
				    PixelGrabber prevGrabber = new PixelGrabber(previewImage, 0, 0, 
				    		prevImageWidth, prevImageHeight, prevImagePixel, 0, prevImageWidth);
				    try {
				    	prevGrabber.grabPixels();
				    } catch(Exception e) {
				        e.printStackTrace();
				    }
				    element = new PreviewTool();
				    element.setX1(0);
				    element.setY1(0);
				    element.setWidth(prevImageWidth);
				    element.setHeight(prevImageHeight);
				    os.writeObject(element);
				    os.writeObject(prevImagePixel);
	    		}
				for(int i=0;i<tempDrawVector.size();i++){
					element = (Element)tempDrawVector.elementAt(i);
					os.writeObject(element);
					if( element.getToolName() == DrawToolConst.IMAGE) {
						int imagePixel[];                         // ̹ ȼ  迭
						//Image image = element.getImage();       // ̹ ü
						Image image = ((ImageTool)tempDrawVector.elementAt(i)).getImage();
						int imageWidth =  image.getWidth(null);
						int imageHeight = image.getHeight(null);
					    imagePixel = new int[imageWidth * imageHeight];  
					    PixelGrabber grabber = new PixelGrabber(image, 0, 0, 
					    		imageWidth, imageHeight, imagePixel, 0, imageWidth);
					    try {
					        grabber.grabPixels();
					    } catch(Exception e) {
					        e.printStackTrace(); }
					    os.writeObject(imagePixel);
					}
					if (element.getPatternMode()) {
						int imagePixel[];                         // ̹ ȼ  迭
						Image patternImg = element.getPatternImg();        //̹ ü
						int imageWidth =  patternImg.getWidth(null);
						int imageHeight = patternImg.getHeight(null);
					    imagePixel = new int[imageWidth * imageHeight];    //imagePixel ʱȭ 
					    PixelGrabber grabber = new PixelGrabber(patternImg, 0, 0, 
					    		imageWidth, imageHeight, imagePixel, 0, imageWidth);
					    try {
					        grabber.grabPixels();
					    } catch(Exception e) {
					        e.printStackTrace(); }
					    os.writeObject(imagePixel);
					}
					if (element.getStrokeMode() && 
							element.getStrokeFillMode()==DrawToolConst.STROKE_PATTERN) {
						int imagePixel[];                         // ̹ ȼ  迭
						Image strokeImg = element.getStrokePatternImg();   // ̹ ü
						int imageWidth =  strokeImg.getWidth(null);
						int imageHeight = strokeImg.getHeight(null);
					    imagePixel = new int[imageWidth * imageHeight];    // imagePixel ʱȭ 
					    PixelGrabber grabber = new PixelGrabber(strokeImg, 0, 0, 
					    		imageWidth, imageHeight, imagePixel, 0, imageWidth);
					    try {
					        grabber.grabPixels();
					    } catch(Exception e) {
					        e.printStackTrace(); }
					    os.writeObject(imagePixel);
					}	
				}
				JOptionPane.showMessageDialog(null,"Ǿϴ.");
				os.close();
	    	}
	    	else if(ext.equalsIgnoreCase("svg")) {
	    		elementParser = ElementParser.getInstance();
	    		elementParser.init();
	    		elementParser.svgSave(
	    				filePath, canvasWidth, canvasHeight, tempDrawVector);
	    	}
	    	
		}
		catch(IOException e) { 
	    	e.printStackTrace();
	    }    
	}
	public void setCanvasSize(int _width, int _height) {
		canvasWidth=_width;
		canvasHeight=_height;
	}
	public void setCanvasWidth(int _width) {
		canvasWidth=_width;
	}
	public void setCanvasHeight(int _height) {
		canvasHeight=_height;
	}
	public String getFilePath() {
		return file.getPath();
	}
	public String getFileName() {
		return file.getName();
	}
	public String getExt() {
		return ext;
	}
	public int getCanvasWidth() {
		return canvasWidth;
	}
	public int getCanvasHeight() {
		return canvasHeight;
	}
}
