package com.sharppaint.file;
import javax.swing.*;

import com.sharppaint.drawtools.DrawToolConst;
import com.sharppaint.drawtools.Element;
import com.sharppaint.drawtools.ImageTool;
import com.sharppaint.drawtools.MultiLineTool;
import com.sharppaint.drawtools.PenTool;
import com.sharppaint.drawtools.PreviewTool;
import com.sharppaint.drawtools.TextTool;

import java.beans.*;
import java.awt.*;
import java.awt.image.MemoryImageSource;
import java.awt.image.VolatileImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.util.Vector;

public class ImagePreview extends JComponent
                          implements PropertyChangeListener {
	private static final long serialVersionUID = 5089842857466308479L;
	private ImageIcon thumbnail = null;
	private File file = null;
	private Vector<Element> drawVector;
	private Element element;
	private int width, height, imageWidth, imageHeight, panelWidth, panelHeight;
	private int imagePixel[];                         // ̹ ȼ  迭
	private boolean spdPreview;
	private VolatileImage  bimg;
	private float scale;
	private static final int WIDTH=150, HEIGHT=250;
	private boolean isPreview;
    public ImagePreview(JFileChooser fc) {
        setPreferredSize(new Dimension(WIDTH, HEIGHT));
        spdPreview = false;
        fc.addPropertyChangeListener(this);
    }

    public void loadImage() {
        if (file == null) {
            thumbnail = null;
            return;
        }

        //Don't use createImageIcon (which is a wrapper for getResource)
        //because the image we're trying to load is probably not one
        //of this program's own resources.
        String []s=file.getName().split("[.]");
        String ext = "";
        if(s.length > 1)
        	ext = s[1];
    	//if spd then draw preview panel
    	if(ext.equalsIgnoreCase("spd")) {
		    try {
		        drawVector = new Vector<Element>();
		    	ObjectInputStream is = new ObjectInputStream(new FileInputStream(file));
		    	width=is.readInt();
	    		height=is.readInt();
		    	try {
		    		isPreview = false;
		    		while((element = (Element)is.readObject()) != null ) {
		    			if( element.getToolName() == DrawToolConst.PREVIEW) {
		    				imageWidth = Math.round(element.getWidth());
							imageHeight = Math.round(element.getHeight()); 
							imagePixel = (int[])is.readObject();
			    			Image image = createImage(new MemoryImageSource(
			    					imageWidth, 
			    					imageHeight, 
			    					imagePixel, 0, imageWidth));
			    			((PreviewTool)element).setImage(image);
			    			isPreview = true;
			    			break;
		    			} else if( element.getToolName() == DrawToolConst.IMAGE) {
			    			imageWidth = ((ImageTool)element).getImageWidth();
							imageHeight = ((ImageTool)element).getImageHeight();
							imagePixel = (int[])is.readObject();
			    			Image image = createImage(new MemoryImageSource(
			    					imageWidth,
			    					imageHeight,
			    					imagePixel, 0, imageWidth));
			    			((ImageTool)element).setImage(image);
			    			((ImageTool)element).initElements();
			    		}
			    		else if ( element.getToolName() == DrawToolConst.PEN) {
			    			((PenTool)element).setPathfromPoint();
			    		}
			    		else if ( element.getToolName() == DrawToolConst.MULTILINE) {
			    			((MultiLineTool)element).setPathfromPoint();
			    		}
			    		else if ( element.getToolName()  == DrawToolConst.TEXT) {
			    			((TextTool)element).initTextTool();
			    		}
			    		if(element.getPatternMode()) {
			    			imageWidth = element.getPatternImgWidth();
							imageHeight =  element.getPatternImgHeight(); 
							imagePixel = (int[])is.readObject();
			    			Image patternImg = createImage(
			    					new MemoryImageSource(
			    							imageWidth, imageHeight, imagePixel, 
			    							0, imageWidth));
			    			element.setPatternImg(patternImg);
			    		}
			    		if(element.getStrokeMode() && 
			    				element.getStrokeFillMode()
			    					==DrawToolConst.STROKE_PATTERN) {
			    			imageWidth = element.getSPatternImgWidth();
							imageHeight =  element.getSPatternImgHeight(); 
							imagePixel = (int[])is.readObject();
			    			Image strokeImg = createImage(
			    					new MemoryImageSource(
			    							imageWidth, 
			    							imageHeight, 
			    							imagePixel, 
			    							0, imageWidth));
			    			element.setStrokePatternImage(strokeImg);
			    		}
			    		drawVector.add(element);
		    		}			    		
		    	} catch(Exception e){ }
		    } catch (Exception e) {
		    	 e.printStackTrace();
		    }
	        spdPreview = true;
	        if(width > 140) {
	        	scale = 140.0f/width;
	        	panelWidth = 140;
	        	panelHeight = Math.round(height*scale);
	        	//width = 
	        }
	        else {
	        	panelWidth = width;
	        	panelHeight = height;
	        }
	        int tempHeight = getHeight()-10;
	        if(panelHeight > tempHeight) {
	        	scale = (float)tempHeight/panelHeight;
	        	panelHeight = tempHeight;
	        	panelWidth = Math.round(panelWidth*scale);
	        }
    	}
    	else {
	        spdPreview = false;
	        ImageIcon tmpIcon = new ImageIcon(file.getPath());
	        if (tmpIcon != null) {
	            if (tmpIcon.getIconWidth() > 140) {
	                thumbnail = new ImageIcon(tmpIcon.getImage().
	                                          getScaledInstance(140, -1,
	                                                      Image.SCALE_DEFAULT));
	            } else { //no need to miniaturize
	                thumbnail = tmpIcon;
	            }
		        int tempHeight = getHeight()-10;
	            if (thumbnail.getImage().getHeight(null) > tempHeight) {
	                thumbnail = new ImageIcon(tmpIcon.getImage().
	                                          getScaledInstance(-1, tempHeight,
	                                        		  Image.SCALE_DEFAULT));
	            }
	        }
	    	}
    }

    public void propertyChange(PropertyChangeEvent e) {
        boolean update = false;
        String prop = e.getPropertyName();

        //If the directory changed, don't show an image.
        if (JFileChooser.DIRECTORY_CHANGED_PROPERTY.equals(prop)) {
            file = null;
            update = true;

        //If a file became selected, find out which one.
        } else if (JFileChooser.SELECTED_FILE_CHANGED_PROPERTY.equals(prop)) {
            file = (File) e.getNewValue();
            update = true;
        }

        //Update the preview accordingly.
        if (update) {
            thumbnail = null;
            if (isShowing()) {
                loadImage();
                repaint();
            }
        }
    }

    protected void paintComponent(Graphics g) {
        if (thumbnail == null) {
            loadImage();
        }
 
        if(spdPreview) {
        	Graphics2D g2 = (Graphics2D)g;
           	Graphics2D g2d = null;
           	bimg=null;
            if (bimg == null || bimg.getWidth() != width || bimg.getHeight() != height) {
               	bimg = (VolatileImage) createVolatileImage(width, height);
               	//bimg = (VolatileImage ) createVolatileImage(Math.round(width*scalePrint), 
               	//		Math.round(height*scalePrint));
            }         
            g2d = bimg.createGraphics();
            g2d.setBackground(Color.WHITE);
            g2d.clearRect(0, 0, width, height);
    	    g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
    	               RenderingHints.VALUE_ANTIALIAS_ON);
    	    if(!isPreview) {
	    	    for(int i=0; i<drawVector.size(); i++) {
	        		element = drawVector.elementAt(i);
	        		element.draw(g2d);
	        	}
    	    } else {
    	    	element.draw(g2d);
    	    }
        	
	        int x = getWidth()/2 - panelWidth/2;
	        int y = getHeight()/2 - panelHeight/2;
	        if (y < 0) {
	            y = 0;
	        }
	        if (x < 5) {
	            x = 5;
	        }
            g2.drawImage(bimg, x, y, panelWidth+x, panelHeight+y, 0, 0, width, height, this);
        	g2d.dispose();
        	g2.dispose();
        }
        else if(thumbnail != null){
	        int x = getWidth()/2 - thumbnail.getIconWidth()/2;
	        int y = getHeight()/2 - thumbnail.getIconHeight()/2;
	        if (y < 0) {
	            y = 0;
	        }
	        if (x < 5) {
	            x = 5;
	        }
	        thumbnail.paintIcon(this, g, x, y);
        }
    }
}

