package com.sharppaint.svg;

import java.io.*;
import java.util.Vector;


import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import com.sharppaint.MainWindow;
import com.sharppaint.drawtools.*;
import com.sharppaint.file.FileTool;
import com.sun.org.apache.xerces.internal.parsers.DOMParser;

public class ElementParser
{
	public Element element;
	private String filePath;
	private static int id;
	private boolean ckStop1, ckStop2;

	static final String ATT_X = " x=\"";
	static final String ATT_Y = "\" y=\"";
	static final String ATT_X1 = " x1=\"";
	static final String ATT_Y1 = "\" y1=\"";
	static final String ATT_X2 = "\" x2=\"";
	static final String ATT_Y2 = "\" y2=\"";
	static final String ATT_CX = " cx=\"";
	static final String ATT_CY = "\" cy=\"";
	static final String ATT_R = "\" r=\"";
	static final String ATT_FX = "\" fx=\"";
	static final String ATT_FY = "\" fy=\"";
	static final String ATT_WIDTH = "\" width=\"";
	static final String ATT_HEIGHT = "\" height=\"";
	static final String ATT_RX = "\" rx=\"";
	static final String ATT_RY = "\" ry=\"";
	static final String ATT_RADIUS = "\" r=\""; 
	static final String ATT_ID = " id=\"";
	static final String ATT_OFFSET = " offset=\"";
	static final String ATT_TRANSFORM = " transform=\"";
	static final String ATT_TRANSLATE = " translate(";
	static final String ATT_ROTATE = " rotate(";
	static final String ATT_SCALE = " scale(";
	static final String ATT_GRAD_TRANSFORM = " gradientTransform=\"";	//linearGradient 
	static final String ATT_SPREAD_METHOD = " spreadMethod=\"";			//pad(default) | repeat
	static final String ATT_GRADUNIT = " gradientUnits=\"userSpaceOnUse\"";
	static final String PROLOG = "<?xml version=\"1.0\" standalone=\"no\"?>" +
			"\r\n<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20000802//EN\" " +
			"\"http://www.w3.org/TR/2000/CR-SVG-20000802/DTD/svg-20000802.dtd\">";
	static final String XMLNS = "xmlns=\"http://www.w3.org/2000/svg\" version=\"1.1\"";
	
	private int layerNum=0;
	private int virtualLayerNum=0;
	private int parentLayerNum=0;
	private int parentLayerDepth=-1;
		
	private static ElementParser elementParser = null;

	private ShapeParser shapeParser;
	
	public static ElementParser getInstance() {
		if(elementParser==null)
			elementParser = new ElementParser();
		return elementParser;
	}
	
	private ElementParser()
	{
		shapeParser = ShapeParser.getInstance();
	}
	
	public void init() {
		ckStop1 = false;
		ckStop2 = false;
		id = 0;
		virtualLayerNum = 0;
		layerNum=0;
		virtualLayerNum=0;
		parentLayerNum=0;
		parentLayerDepth=-1;
		shapeParser.setViewX(0);
		shapeParser.setViewY(0);
		shapeParser.initIdGradList();
	}
	
	//SVG OPEN
	public void svgOpen(File file, Vector<Element> tempDrawVector) {			//svg 
		filePath = file.getPath();
		
		if(filePath == "")
		{
			System.out.println("  ʽϴ.");
			System.exit(1);
		}//end if
		
		//ļ ü 
		//theNode.getNodeName().
		DOMParser examParser = new DOMParser();
		try {  	
	    	BufferedReader in = new BufferedReader(new FileReader(filePath)); //ǲƮ 
	        String bs="";
	        StringBuffer tempDoc=new StringBuffer();
	        if(((bs = in.readLine()) != null)
	        		&& (!(bs.startsWith("<?")) && !(bs.startsWith("<!"))) ) {
	    		tempDoc.append(bs);
	    		tempDoc.append("\n");
	    	}
	        if(((bs = in.readLine()) != null)
	        		&& (!(bs.startsWith("<?")) && !(bs.startsWith("<!"))) ) {
	    		tempDoc.append(bs);
	    		tempDoc.append("\n");
	    	}
	        if(((bs = in.readLine()) != null)
	        		&& (!(bs.startsWith("<?")) && !(bs.startsWith("<!"))) ) {
	    		tempDoc.append(bs);
	    		tempDoc.append("\n");
	    	}
	        while ((bs = in.readLine()) != null) { //Ľ̽ ʿ SVG ڵ 
		    	//if(!(bs.startsWith("<?")) && !(bs.startsWith("<!")) && !(bs.endsWith("dtd\">"))) {
		    	tempDoc.append(bs);
		    	tempDoc.append("\n");		    		
	        }
	        in.close();	//Ʈ 
	        //System.out.println(tmp_bs);
			//ļ ̿Ͽ ĽѴ.
			//examParser.setIncludeIgnorableWhitespace(false);
	    	examParser.parse(new InputSource(new StringReader(tempDoc.toString())));	//String InputSouce ȯ Ľ
			
			System.out.println("\n\r Ľ ϷǾϴ._______________________");
	    }
		catch(Exception e) {			
			System.out.println("Parsing Error:" + e.toString());
		}//end try-catch
		
		//xmlϿ شϴ Document ü Ѵ.
		Document examDoc = examParser.getDocument();
		
		//Element ϱ ؼ Element ü Ѵ.
		Node root = examDoc.getDocumentElement();
		//getDocumentElement()޼ҵ ֻ  ȯ
		this.parsingDocument(root, tempDrawVector);
		
	}//end svgOpen
	public void parsingDocument(Node theNode, Vector<Element> tempDrawVector) {	//svgOpenԼ ȣ
		//boolean isFirstParsingDocumentCall = false;
		boolean groupMode = false;
		if(theNode != null) {
			switch(theNode.getNodeType()) {	
			
			case Node.ELEMENT_NODE:
				//if(theNode.hasAttributes()) {
					//System.out.println("[" +theNode.getNodeName()+ "]");
					String elementName = theNode.getNodeName();				
					
					if(!elementName.equals("stop")) {
						ckStop2 = true;
						shapeParser.addGradList(ckStop1, ckStop2);
						ckStop1 = false;
					}
					if(elementName.equals("linearGradient")) { // ׷Ʈ
						shapeParser.gradientOpen(theNode, element, tempDrawVector, false);
					}
					else if (elementName.equals("radialGradient")) { // ׷Ʈ
						shapeParser.gradientOpen(theNode, element, tempDrawVector, true);
					}
					else if(elementName.equals("stop")) {
						ckStop1 = true;
						shapeParser.stopOpen(theNode, element, tempDrawVector);
					}
					else if(elementName.equals("rect")) { //簢 or  簢	
						NamedNodeMap objattr = theNode.getAttributes();
						boolean rectCk = true;
						for(int i=0; i<objattr.getLength(); i++) {
							if(objattr.item(i).getNodeName().equals("rx") || 
									objattr.item(i).getNodeName().equals("ry")) {
								//System.out.println(":roundRect");
								shapeParser.roundRectOpen(theNode, element, tempDrawVector); // 簢
								rectCk = false;
								break;
							}
						}
						if(rectCk == true) {
							shapeParser.rectOpen(theNode, element, tempDrawVector);	//簢
							break;
						}
					}
					else if(elementName.equals("ellipse") || elementName.equals("circle")) { //Ÿ			
						shapeParser.ellipseOpen(theNode, element, tempDrawVector);
					}
					else if(elementName.equals("line")) { 	//			
						shapeParser.lineOpen(theNode, element, tempDrawVector);
					}
					else if(elementName.equals("path")) { 	//Ƽ(Path)			
						shapeParser.pathOpen(theNode, element, tempDrawVector);
					}
					else if(elementName.equals("polygon")) { 	//Ƽ(Path)			
						shapeParser.pathOpen(theNode, element, tempDrawVector);
					}
					else if(elementName.equals("text")) { 	//ؽƮ
						shapeParser.textOpen(theNode, element, tempDrawVector);
					}

					else if(elementName.equals("g")) { 		//׷
						NodeList objchild = theNode.getChildNodes();
						//System.out.println(objchild.getLength()+"g leghtn");
						
						if(theNode.hasChildNodes() && objchild.getLength()!=1) {
							if(theNode.hasAttributes()) {
								shapeParser.groupOpen(theNode, element, tempDrawVector);								
							}
							groupMode = true;
						} else {

						}
					}
				
					if(elementName.equals("svg")) { //svg
						//System.out.println("k");
						NamedNodeMap objattr = theNode.getAttributes();
						String tmpViewBox = "";
						String viewBox[];
						String widthValue = "", heightValue = "";
						float widthRate = 0.0f, heightRate = 0.0f;	
						for(int i=0; i<objattr.getLength(); i++) { //Canvas Size
							
							if(objattr.item(i).getNodeName().equals("width")) {
								widthValue = objattr.item(i).getNodeValue();
								//System.out.println("width = " + widthValue);
								if(widthValue.endsWith("cm")) {
									widthValue = 
										widthValue.substring(0, widthValue.indexOf("cm"));
									FileTool.getInstance().setCanvasWidth(
											Math.round(
													Float.parseFloat(widthValue) * 96.0f / 2.54f));
								}
								else if(widthValue.endsWith("px")) {
									widthValue = widthValue.replace("px", "");
									FileTool.getInstance().setCanvasWidth(
											Integer.parseInt(widthValue));
								}
								else {
									FileTool.getInstance().setCanvasWidth(
											Integer.parseInt(widthValue));
								}
							}
							else if(objattr.item(i).getNodeName().equals("height")) {
								heightValue = objattr.item(i).getNodeValue();
								//System.out.println("height = " + heightValue);
								if(heightValue.endsWith("cm")) {
									heightValue = 
										heightValue.substring(0, heightValue.indexOf("cm"));
									FileTool.getInstance().setCanvasHeight(
											Math.round(
													Float.parseFloat(heightValue) * 96.0f / 2.54f));
								}
								else if(heightValue.endsWith("px")) {
									heightValue = heightValue.replace("px", "");
									FileTool.getInstance().setCanvasHeight(
											Integer.parseInt(heightValue));
								}
								else {
									FileTool.getInstance().setCanvasHeight(
											Integer.parseInt(heightValue));
								}
							}
							else if(objattr.item(i).getNodeName().equals("viewBox")) {
								tmpViewBox = objattr.item(i).getNodeValue();
							}							
						}//end for

						//System.out.println("k2");
						//viewBox attribute not exist
						if(tmpViewBox.equals("")) {
							MainWindow.getInstance().makeNewCanvas();
						} 
						//viewBox attribute exist
						else {
							//svg canvas size is not exist
							if(widthValue.equals("") || heightValue.equals("")) {
								viewBox = tmpViewBox.split(" ");				
								FileTool.getInstance().setCanvasWidth(
										Integer.parseInt(viewBox[2]));
								FileTool.getInstance().setCanvasHeight(
										Integer.parseInt(viewBox[3]));
								MainWindow.getInstance().makeNewCanvas();
							} else {		//canvas size exist						
								viewBox = tmpViewBox.split(" ");	
								widthRate = Float.parseFloat(widthValue)/Float.parseFloat(viewBox[2]);
								heightRate = Float.parseFloat(heightValue)/Float.parseFloat(viewBox[3]);	
																
								if(widthRate <= heightRate) {								
									float viewCanvasHeight = Float.parseFloat(heightValue) * (1/widthRate);
									FileTool.getInstance().setCanvasHeight(Math.round(viewCanvasHeight));
									FileTool.getInstance().setCanvasWidth(
											Integer.parseInt(viewBox[2]));
								}
								else {
									float viewCanvasWidth = Float.parseFloat(widthValue) * (1/heightRate);							
									FileTool.getInstance().setCanvasWidth(Math.round(viewCanvasWidth));
									FileTool.getInstance().setCanvasHeight(
											Integer.parseInt(viewBox[3]));
								}
								MainWindow.getInstance().makeNewCanvas();
								
								float addWidth = 0, addHeight = 0; 							
								if(widthRate <= heightRate) {								
									//System.out.println("widthRate: " + widthRate);
									MainWindow.getInstance().getPanel().setResize(widthRate);
									MainWindow.getInstance().getResizeSlider().setValue(
											Math.round(widthRate*100));
									addHeight = Float.parseFloat(viewBox[3]) * (widthRate - heightRate);
								}
								else if(widthRate == heightRate) {
									//System.out.println("widthRate: " + widthRate);
									MainWindow.getInstance().getPanel().setResize(widthRate);
									MainWindow.getInstance().getResizeSlider().setValue(
											Math.round(widthRate*100));								
								}
								else if (widthRate > heightRate) {
									//System.out.println("heightRate: " + heightRate);
									MainWindow.getInstance().getPanel().setResize(heightRate);
									MainWindow.getInstance().getResizeSlider().setValue(
											Math.round(heightRate*100));	
									addWidth = Float.parseFloat(viewBox[2]) * (heightRate - widthRate);
								}
								
								if(viewBox[0] != "0" || viewBox[1] != "0") {
									shapeParser.setCkViewBox(true);
									//System.out.println("addWidth=" + addWidth + " | addHeight =" + addHeight);
									shapeParser.setViewX(Float.parseFloat(viewBox[0]) + addWidth);
									shapeParser.setViewY(Float.parseFloat(viewBox[1]) + addHeight);
								}
							}
						}						
						//11/19  Ϸ Ͽ g ֻ Ʈ ƴ  ʿ
						if(theNode.hasChildNodes()) {
							NodeList objchild = theNode.getChildNodes();
							//System.out.println(objchild.item(1).getLocalName() + "not same or not first element is group" + 
							//		objchild.item(1).equals(objchild.item(objchild.getLength()-2)));
							if(!objchild.item(1).equals(objchild.item(objchild.getLength()-2))
									|| !objchild.item(1).getNodeName().equals("g")) {

								shapeParser.groupOpen(theNode, element, tempDrawVector);
								
								//System.out.println(objchild.item(1).getLocalName() + "not same or not first element is group");
								groupMode = true;								
							}
						}
						//System.out.println("k3");
					}
					if(theNode.hasChildNodes()) {
						if(groupMode) {
							int originalLayerNum;
							int originalParentLayerNum;
							int originalParentLayerDepth = ++parentLayerDepth;
							
							parentLayerNum = layerNum;
							originalParentLayerNum = parentLayerNum;
							virtualLayerNum++;
							layerNum = virtualLayerNum;
							originalLayerNum = layerNum;
							
							NodeList objchild = theNode.getChildNodes();
							for(int i=0; i<objchild.getLength(); i++) {
								parsingDocument(objchild.item(i), tempDrawVector);	// ȣ
								layerNum = originalLayerNum;
								parentLayerNum = originalParentLayerNum;
								parentLayerDepth = originalParentLayerDepth;
								//groupMode = originalGroupMode;
							}
							
							Element element = new Layer(layerNum, parentLayerNum, parentLayerDepth);
							for(int idx=tempDrawVector.size()-1; idx>=0; idx-- ) {
				    			Element tempElement = tempDrawVector.get(idx);
				    			if(tempElement.getLayerNum() == layerNum) {
				    				element.addElementNum();
				    			} else if(tempElement.getParentLayerNum() == layerNum) {
				    				if(tempElement.getToolName() == DrawToolConst.LAYER)
				    					element.addElementNum(tempElement.getElementNum()+1);	
				    			}
							}
							
							tempDrawVector.add(element);	
							/*for(int i=tempDrawVector.size()-1; i>=0; i-- ) {
				    			Element temp = tempDrawVector.get(i);
				    			System.out.println(temp.getToolName() + " layer: " + temp.getLayerNum()+
				    					" elemNum: " + temp.getElementNum() + " index: " + i + 
				    					" parentLayer: " + temp.getParentLayerNum() + 
				    					" parentDepth: " + temp.getParentLayerDepth());
				    		}
				    		System.out.println(" ");*/	
							
						} else {
							NodeList objchild = theNode.getChildNodes();
							for(int i=0; i<objchild.getLength(); i++) {
								parsingDocument(objchild.item(i), tempDrawVector);	// ȣ
							}														
						}				
				}//end if
				break;				
			case Node.TEXT_NODE:
				//System.out.println(theNode.getNodeValue());
				break;				
			case Node.CDATA_SECTION_NODE:
				//System.out.println("<CDATA[[" + theNode.getNodeValue() + "]]>");
				break;				
			case Node.COMMENT_NODE:
				//System.out.println("<!--" + theNode.getNodeValue() + "-->\n");
				if(theNode.getNodeValue().trim().equals("ColorMode && GradientMode")) {
					//System.out.println("^");
					shapeParser.setPreTotalStyle(ShapeParser.getInstance().getTotalStyle());
					shapeParser.setGradContinue(true);
					tempDrawVector.remove(tempDrawVector.size()-1);
				}
				break;
		};//end switch
		}
		
	}//end parsingDocument
	
	
	//SVG SAVE
	public String makeTap(Element _element, boolean child) {
		Element element = _element;
		String tab = "";
		int depth = element.getParentLayerDepth();
		if(element.getToolName() != DrawToolConst.LAYER)
			depth++;
		if(child) {
			depth++;			
		}
		//System.out.println("depth" + element.getParentLayerDepth());
		for(int i=0; i<depth; i++) {
			tab += "\t";
		}
		return tab;
	}
	private String makeLine(Element _element) {
		String line = "";
		String linearGradLine = "";
		String radialGradLine = "";
		String textLine = "";
		Element element = _element;
		boolean isGroup = false;
		boolean ckElement = false;
		//element = (Element)tempDrawVector.elementAt(idx);		
		linearGradLine = linearGradientSave(element, line);
		radialGradLine = radialGradientSave(element, line);
		line = line + makeTap(element, false);
		if(element.getToolName() == DrawToolConst.LAYER) {
			line = line + "<g>\r\n";
			isGroup = true;
		}
		else if(element.getToolName() == DrawToolConst.RECT) {			//簢	
			line = line + "<rect";
			line = line + ATT_X + element.getX1() + 
				ATT_Y + element.getY1();
			line = line + ATT_WIDTH + element.getWidth() +
				ATT_HEIGHT + element.getHeight();			
			ckElement = true;
		}
		else if(element.getToolName() == DrawToolConst.ROUNDRECT) { 	// 簢		
			line = line + "<rect";
			line = line + ATT_X + element.getX1() + 
				ATT_Y + element.getY1();
			line = line + ATT_WIDTH + element.getWidth() +
				ATT_HEIGHT + element.getHeight();
			line = line + ATT_RX + ((RoundRectTool)(element)).getArcWidth()/2 +
				ATT_RY + ((RoundRectTool)(element)).getArcHeight()/2;		
			ckElement = true;
		}
		else if(element.getToolName() == DrawToolConst.ELLIPSE) { 		//Ÿ
			line = line + "<ellipse";
			line = line + ATT_CX + (element.getX1() + element.getWidth()*0.5) + 
				ATT_CY + (element.getY1() + element.getHeight()*0.5);
			line = line + ATT_RX + element.getWidth()*0.5 +
				ATT_RY + element.getHeight()*0.5;
			ckElement = true;
		}
		else if(element.getToolName() == DrawToolConst.LINE) { 		//
			line = line + "<line";
			line = line + ATT_X1 + element.getX1() + 
				ATT_Y1 + element.getY1();
			line = line + ATT_X2 + element.getX2() +
				ATT_Y2 + element.getY2();
			ckElement = true;
		}
		else if(element.getToolName() == DrawToolConst.MULTILINE) {	//Ƽ
			PointF[] mlPoints;
			mlPoints = ((MultiLineTool)element).getPoints().clone();
			
			int pointsSize = element.getPointCount();
			//System.out.println(pointsSize + "pointsSize");
			String tmpLine = "";
			for(int i=1; i<pointsSize; i++) {
				float px = mlPoints[i].getX();
				float py = mlPoints[i].getY();
				tmpLine = tmpLine + " L" + px + "," + py;
				//System.out.println(px + " pxy " + py);
			}
			line = line + "<path";
			line = line + " d=\"M " + mlPoints[0].x + ","
					+ mlPoints[0].y + tmpLine;
			if(((MultiLineTool)element).isClosePath()) {
				line = line + "z";
			}
			ckElement = true;
		}
		else if(element.getToolName() == DrawToolConst.PEN) {			//
			PointF[] penPoints;
			penPoints = ((PenTool)element).getPoints().clone();
			
			int pointsSize = element.getPointCount();
			String tmpLine = "";
			for(int i=1; i<pointsSize; i++) {
				float ctrlX1 = penPoints[i].getX();
				float ctrlY1 = penPoints[i].getY();
				i++;
				float ctrlX2 = penPoints[i].getX();
				float ctrlY2 = penPoints[i].getY();
				i++;
				float x2 = penPoints[i].getX();
				float y2 = penPoints[i].getY();
				
				tmpLine = tmpLine + " C"+ ctrlX1 +","+ ctrlY1 +" "+ ctrlX2 +","+ ctrlY2 +" "+ x2 +","+ y2;
				
			}
			line = line + "<path";
			line = line + " d=\"M " + penPoints[0].x + ","
					+ penPoints[0].y + tmpLine;
			ckElement = true;
		}
		else if(element.getToolName() == DrawToolConst.TEXT) { 		//ؽƮ
			line = line + "<text";
			line = line + ATT_X + element.getX1() + ATT_Y 
					+ ((TextTool)element).getTextY1AddedHeight();
			//text Style
			textLine = StyleParser.getInstance().toSvgTextParser(textLine, element);
			ckElement = true;
		}
		//Style
		line = StyleParser.getInstance().toSvgStyleParser(line, element);
		
		if(!isGroup) {
			if(!line.endsWith("\"/>\r\n") && ckElement == true) {
				line += "\"/>\r\n";
			}
			if(line.startsWith("\"/>\r\n")) {
				line = line.substring(5, line.length());
			}
		}
		
		if(textLine != "") { //Text Style
			line = line.substring(0, line.length()-5) + ";";
			line = line + textLine + "\">";
			line = this.transformSave(element, line);
			line = line + ((TextTool)element).getText() + "</text>\r\n";
		}
		else {
			line = this.transformSave(element, line);
		}
		line = linearGradLine + radialGradLine + line;
		return line;
	}
	private void makeElementAndLayer(int idx) {
		Element tmpElement = tempDrawVector.get(idx);
		int tmpLayerNum = tmpElement.getLayerNum();
		for(int index=idx-tmpElement.getElementNum(); index<idx; index++) {
			Element tempElement = tempDrawVector.get(index);
			//̾ Ʈ
			if(tmpLayerNum == tempElement.getLayerNum()) {
				doc = doc.append(makeLine(tempElement));
			} 
			//̾ ڽ Ʈ 
			else if(tempElement.getToolName() == DrawToolConst.LAYER &&
					tempElement.getParentLayerNum() == tmpLayerNum){
				doc = doc.append(makeLine(tempElement));
				makeElementAndLayer(index);
				//doc = doc + "</g>\r\n";
			}
		}
		doc = doc.append(makeTap(tmpElement, false) + "</g>\r\n");
	}
	
	StringBuffer doc;
	Vector<Element> tempDrawVector;
	public void svgSave(String filePath, int width, int height, 				//svg 
						Vector<Element> _tempDrawVector) {
		doc = new StringBuffer();
		tempDrawVector = _tempDrawVector;
		//String line = "";
		int arrSize = tempDrawVector.size()-1;
		int tmpLayerNum = 0;
		for(int idx=0;idx<=arrSize;idx++) {
			element = tempDrawVector.elementAt(idx);
			if(element.getToolName() == DrawToolConst.LAYER
					&& element.getParentLayerNum()==0) {
				tmpLayerNum = element.getLayerNum();
				doc = doc.append(makeLine(element));
				
				//Element tempLayerElement = element;
				for(int index=idx-element.getElementNum(); index<idx; index++) {
					Element tempElement = tempDrawVector.get(index);
					//̾ Ʈ
					if(tmpLayerNum == tempElement.getLayerNum()) {
						doc = doc.append(makeLine(tempElement));						
					} 
					//̾ ڽ Ʈ 
					else if(tempElement.getToolName() == DrawToolConst.LAYER &&
							tempElement.getParentLayerNum() == tmpLayerNum){
						doc = doc.append(makeLine(tempElement));
						makeElementAndLayer(index);
						//doc = doc + "</g>\r\n";
					}	
					//tempDrawVector.get(i).setLayerNum(tempLayerElement.getLayerNum());
				} //break;
				doc = doc.append(makeTap(element, false) + "</g>\r\n");
			}			
		}		
		
		try { // 
			File file = new File(filePath);
			//System.out.println(filePath);
			if(file.exists()) {
				file.delete();
				System.out.println("existing file");
			}
			else { System.out.println("new file"); } 
			 
		    RandomAccessFile raf = new RandomAccessFile(filePath, "rw");
		    
		    raf.writeBytes(PROLOG);
		    raf.writeBytes("\r\n<svg width=\"" + width 
		    		+ "\" height=\"" + height + "\" " + XMLNS + ">");
		    raf.writeBytes("\r\n" + doc + "</svg>");
		    
		    raf.close();
		 }
		 catch(IOException e) {	
			 System.out.println("svgSave() Error:" + e.toString());
		 }//end try-catch		
	}//end svgSave
	public String transformSave(Element _element, String line) { 				//Transform 
		String transLine = "";
		Element element = _element;

		if(element.getTransformMode()) {
			float x1, y1, lineX, lineY, transX, transY;
			x1 = -element.getWidth()/2f;
			y1 = -element.getHeight()/2f;
			lineX = -(element.getX2() - element.getX1())/2;
			lineY = -(element.getY2() - element.getY1())/2;
			
			if(element.getToolName() == DrawToolConst.LINE) {
				transX = element.getX1() - lineX;
				transY = element.getY1() - lineY;
			}
			else if(element.getToolName() == DrawToolConst.TEXT) {
				transX = element.getX1() + element.getWidth()/2;
				transY = element.getY1() + element.getHeight()/2;
				//transX = element.getX1() + element.getWidth()/2;
				//transY = element.getY1() + element.getWidth()/2 + element.getHeight()*(0.3f/0.4f);
				y1 = element.getHeight()/2*0.6f/0.7f;
			}
			else {
				transX = element.getX1() + element.getWidth()/2;
				transY = element.getY1() + element.getHeight()/2;
			}

			transLine = transLine + makeTap(element, false);
			transLine = ATT_TRANSFORM;
			transLine = transLine + ATT_TRANSLATE + transX +","+ transY + ")";			

			if(element.getRotateMode()) {
				transLine += ATT_ROTATE + element.getRotateAngle()+ ")";
			}
			if(element.getScaleMode()) {
				transLine += ATT_SCALE  + element.getScaleX() + "," + element.getScaleY() + ")";
			}
			
			//Transform ǥ 
			String tmpNewXY = "", tmpRearXY = "";
			if(element.getToolName() == DrawToolConst.RECT
					|| element.getToolName() == DrawToolConst.ROUNDRECT) {			
				tmpNewXY = "x=\"" + x1 + "\" y=\"" + y1 + "\" ";
				tmpRearXY = line.substring(line.indexOf("x"), line.indexOf("width"));
			}
			else if(element.getToolName() == DrawToolConst.ELLIPSE) {
				tmpNewXY = "cx=\"0" + "\" cy=\"0" + "\" ";
				tmpRearXY = line.substring(line.indexOf("cx"), line.indexOf("rx"));
			}
			else if(element.getToolName() == DrawToolConst.LINE) {
				tmpNewXY = "x1=\"" + lineX + "\" y1=\"" + lineY + "\" x2=\"" + (-lineX) + "\" y2=\"" + (-lineY) + "\" ";
				tmpRearXY = line.substring(line.indexOf("x1"), line.indexOf("style"));
			}
			else if(element.getToolName() == DrawToolConst.TEXT) {
				tmpNewXY = "x=\"" + x1 + "\" y=\"" + y1 + "\" ";
				tmpRearXY = line.substring(7, line.indexOf("style"));
			}
			line = line.replaceAll(tmpRearXY, tmpNewXY);
			
			if(line.contains("<!--")) {	//Color & Gradient
				String colorGradTransLine = "\" " + transLine + "\"/>\r\n";
				line = line.substring(0, line.length()-2);
				line = line.replace("\"/>\r\n", colorGradTransLine);
				if(line.contains("text")) { //Text
					line = line.substring(0, line.length()) + "\" " + transLine + "\"/>\r\n";
				}
				else {
					line = line.substring(0, line.length()-3) + "\" " + transLine + "\"/>\r\n";
				}				
			}
			else {
				if(line.contains("text")) { //Text
					line = line.substring(0, line.length()-2) + "\" " + transLine + "\"/>\r\n";
				}
				else {
					line = line.substring(0, line.length()-5) + "\" " + transLine + "\"/>\r\n";
				}
			}
		}//end if		
		return line;
	}//end transformSave()
	
	public String linearGradientSave(Element element, String line) { 			// ׷Ʈ  
		//Fill Gradient
		if(element.getGradientMode()
				&& element.getGradList() != null
				&& element.getGradStyle() == DrawToolConst.LINEAR_GRAD) { 
			String gradID = "id_"+ id++;
			String grayCycle = "pad";
			if(element.isGradCycle()) {
				grayCycle = "repeat";
			}
			line = line + "\r\n" + makeTap(element, false) + 
					"<linearGradient" + ATT_ID + gradID + "\"" +
					ATT_GRAD_TRANSFORM + ATT_ROTATE + element.getGradAngle() + ", 0.5, 0.5)" + 
					ATT_SCALE + element.getGradScale() + ")\"" +
					ATT_SPREAD_METHOD + grayCycle + "\">\r\n";
			element.setFillGradID(gradID);	//gradient ID save
			for(int j=0; j<element.getGradList().size(); j++) {
				int offset = element.getGradList().get(j).getX()/2;
				if(offset > 1) {
					line = line + makeTap(element, true);
					line = line + "<stop" + ATT_OFFSET + offset + "%";	
				}
				else {
					line = line + makeTap(element, true);
					line = line + "<stop" + ATT_OFFSET + offset;
				}
				line = StyleParser.getInstance().toSvgGradParser(line, element, j, false);
				line = line + "\"/>\r\n";
			}//end for
			line = line + makeTap(element, false) + "</linearGradient>\r\n";
		}//end if
		//Stroke Gradient
		if(element.getStrokeMode()
				&& element.getStrokeFillMode() == DrawToolConst.STROKE_GRADIENT
				&& element.getStrokeGradStyle() == DrawToolConst.LINEAR_GRAD) {
			String gradID = "id_"+ id++;
			String grayCycle = "pad";
			if(element.isStrokeGradCycle()) {
				grayCycle = "repeat";
			}
			line = line + "\r\n" + makeTap(element, false) + 
					"<linearGradient" + ATT_ID + gradID + "\"" +
					ATT_GRAD_TRANSFORM + ATT_ROTATE + element.getStrokeGradAngle() + ", 0.5, 0.5)" + 
					ATT_SCALE + element.getStrokeGradScale() + ")\"" +
					ATT_SPREAD_METHOD + grayCycle + "\">\r\n";
			element.setStrokeGradID(gradID);	//gradient ID save
			for(int j=0; j<element.getStrokeGradList().size(); j++) {
				int offset = element.getStrokeGradList().get(j).getX()/2;
				if(offset > 1) {
					line = line + makeTap(element, true);
					line = line + "<stop" + ATT_OFFSET + offset + "%";	
				}
				else {
					line = line + makeTap(element, true) + "<stop" + ATT_OFFSET + offset;
				}
				line = StyleParser.getInstance().toSvgGradParser(line, element, j, true) +
						"\"/>\r\n";
			}//end for
			line = line + makeTap(element, false) + "</linearGradient>\r\n";
		}//end if
		return line;
	}//end linearGradientSave()
	public String radialGradientSave(Element element, String line) {			// ׷Ʈ  
		float cx = element.getX1() + element.getWidth()/2;
		float cy = element.getY1() + element.getHeight()/2;
		float fillR = element.getGradRadius();
		float strokeR = element.getStrokeGradRadius();
		
		//϶, cx, cy ó
		
		//Fill Gradient
		if(element.getGradientMode()
				&& element.getGradList() != null
				&& element.getGradStyle() == DrawToolConst.RADIAL_GRAD) {
			if(element.getTransformMode()) {
				cx = cx - (element.getX1() + element.getWidth()/2);
				cy = cy - (element.getY1() + element.getHeight()/2);
			}			
			line = line + "\r\n" + makeTap(element, false) + "<radialGradient";
			
			String gradID = "id_"+ id++;
			String grayCycle = "pad";
			if(element.isGradCycle()) {
				grayCycle = "repeat"; }
			line = line + ATT_ID + gradID + "\"" + ATT_GRADUNIT + 
					ATT_CX + cx + ATT_CY + cy + 
					ATT_R + fillR + ATT_FX + cx + ATT_FY + cy + "\"" + 
					ATT_SPREAD_METHOD + grayCycle + "\">\r\n";		
			element.setFillGradID(gradID);	//gradient ID save
			for(int j=0; j<element.getGradList().size(); j++) {
				int offset = (element.getGradList().get(j).getX()/2);
				if(offset > 1) {
					line = line + makeTap(element, true) + 
							"<stop" + ATT_OFFSET + offset + "%";	
				}
				else {
					line = line + makeTap(element, true) + 
							"<stop" + ATT_OFFSET + offset;
				}
				line = StyleParser.getInstance().toSvgGradParser(line, element, j, false) + 
						"\"/>\r\n";
			}
			line = line + makeTap(element, false) + "</radialGradient>\r\n";
		}//end if
		//Stroke Gradient
		if(element.getStrokeMode()
				&& element.getStrokeFillMode() == DrawToolConst.STROKE_GRADIENT
				&& element.getStrokeGradStyle() == DrawToolConst.RADIAL_GRAD) {	
			if(element.getTransformMode()) {
				cx = cx - (element.getX1() + element.getWidth()/2);
				cy = cy - (element.getY1() + element.getHeight()/2);
			}			
			line = line + "\r\n" + makeTap(element, false) + "<radialGradient";
			
			String gradID = "id_"+ id++;
			String grayCycle = "pad";
			if(element.isStrokeGradCycle()) {
				grayCycle = "repeat";
			}
			line = line + ATT_ID + gradID + "\"" + ATT_GRADUNIT + 
					ATT_CX + cx + ATT_CY + cy + 
					ATT_R + strokeR + ATT_FX + cx + ATT_FY + cy + "\"" + 
					ATT_SPREAD_METHOD + grayCycle + "\">\r\n";			
			element.setStrokeGradID(gradID);	//gradient ID save
			for(int j=0; j<element.getStrokeGradList().size(); j++) {
				int offset = (element.getStrokeGradList().get(j).getX()/2);
				if(offset > 1) {
					line = line + makeTap(element, true) + 
					"<stop" + ATT_OFFSET + offset + "%";	
				}
				else {
					line = line + makeTap(element, true) + 
					"<stop" + ATT_OFFSET + offset;
				}
				line = StyleParser.getInstance().toSvgGradParser(line, element, j, true) + 
						"\"/>\r\n";
			}//end for
			line = line + makeTap(element, false) + "</radialGradient>\r\n";
		}//end if
		return line;
	}//end radialGradientSave()

	//Getter & Setter
	public int getLayerNum() {
		return layerNum;
	}
	public void setLayerNum(int layerNum) {
		this.layerNum = layerNum;
	}
	public int getParentLayerDepth() {
		return parentLayerDepth;
	}
	public void setParentLayerDepth(int parentLayerDepth) {
		this.parentLayerDepth = parentLayerDepth;
	}
	public int getParentLayerNum() {
		return parentLayerNum;
	}
	public void setParentLayerNum(int parentLayerNum) {
		this.parentLayerNum = parentLayerNum;
	}
}//end class
