package com.sharppaint.svg;

import java.awt.Color;
//import java.awt.Font;
import java.util.ArrayList;
import java.util.Vector;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

import com.sharppaint.drawtools.*;

public class ShapeParser {	
	//coordinates
	private float x, y, x2, y2;
	
	//width, height
	private float width, height;	
	//Color
	protected Color fillColor;
	//Stroke
	private Color strokeColor;
	private int strokePosition;
	private int strokeFillSelector;	
	private float strokeSize;
	//Style
	private String totalStyle;
	private String preTotalStyle;
	//Text
	private String fontFamily;
	private int fontStyle, fontSize;
	//Mode select variable 
	private boolean colorMode;
	private boolean strokeMode;
	private boolean gradientMode;
	//private boolean patternMode;	
	private boolean opacityMode;
	//Opacity
	//protected float groupOpacity=1.0f;
	private float colorOpacity;
	private float gradientOpacity;
	//protected float patternOpacity = 1.0f;
	private float strokeOpacity;	
	private int ckOpacity;
	//Gradient
	private float fillScaleGrad, fillAngleGrad;
	private float strokeScaleGrad, strokeAngleGrad;
	private boolean fillRepeatGrad, strokeRepeatGrad; 
	transient protected GradientTool gradRect;
	transient protected Color startColor, endColor;
	transient protected float startPos, endPos;
	private ArrayList<GradientTool> gradList, fillGradList, strokeGradList;
	protected ArrayList<ArrayList<GradientTool>> idGradList; //idList gradList ġ
	protected ArrayList<String> idList;
	protected ArrayList<Float> idGradRotateList, idGradScaleList;
	protected ArrayList<Boolean> idGradCycleList;	//pad, repeat
	protected ArrayList<Boolean> idGradStyleList;	//linear, radial
	private Color gradientColor;
	private boolean gradContinue; 
	private float radial;
	protected boolean fillGradStyle, strokeGradStyle;
	//Transform
	private int rotate;
	private float scaleX, scaleY, transX, transY, idGradRotate, idGradScale;
	private boolean ckTranslate, ckScale, ckRotate;
	//Path(MultiLine)
	private String pathPointList[];
	//ViewBox
	protected boolean ckViewBox;
	protected float viewX, viewY;

	private static ShapeParser shapeParser = null;
	
	public static ShapeParser getInstance() {
		if(shapeParser==null)
			shapeParser = new ShapeParser();
		return shapeParser;
	}

	private ShapeParser() {
		init();
		initIdGradList();
	}
	public void initIdGradList() {
		idList = new ArrayList<String>();
		idGradList = new ArrayList<ArrayList<GradientTool>>();		
		idGradRotateList = new ArrayList<Float>();
		idGradScaleList = new ArrayList<Float>();
		idGradCycleList = new ArrayList<Boolean>();
		idGradStyleList = new ArrayList<Boolean>();
	}
	public void init() {
		x = 0;
		y = 0;
		width = 0;
		height = 0;
		strokePosition = DrawToolConst.STROKE_POSITION_CENTER;	//center
		strokeFillSelector = DrawToolConst.STROKE_COLOR;
		//Mode
		colorMode = false;
		strokeMode = false;
		gradientMode = false;
		//patternMode = false;	
		opacityMode = false;
		gradContinue = false;
		//Color, Stroke
		fillColor = Color.white;
		strokeColor = Color.BLACK;
		strokeSize = 1.0f;	
		//Gradient
		fillScaleGrad=1.0f;
		fillAngleGrad=0.0f;
		gradientColor = Color.white;
		//Opacity
		strokeOpacity = 1.0f;	
		gradientOpacity = 1.0f;
		colorOpacity = 1.0f;
		ckOpacity = 0;
		//Transform
		rotate = 0;
		scaleX = 1.0f;
		scaleY = 1.0f;
		transX = 1.0f;
		transY = 1.0f;
		ckTranslate = false;
		ckScale = false;
		ckRotate = false;
		//Text
		fontFamily = "";
		fontSize = 0;
		fontStyle = 0;
	}

	private Element setElementLayerInform(Element _element) {
		Element element = _element;
		element.setLayerNum(ElementParser.getInstance().getLayerNum());
		element.setParentLayerNum(ElementParser.getInstance().getParentLayerNum());
		element.setParentLayerDepth(ElementParser.getInstance().getParentLayerDepth());
		return element;
	}

	public void rectOpen(Node theNode,							//簢 ׸
					Element element, 
					Vector<Element> tempDrawVector) { 
		if(gradContinue != true) {
			preTotalStyle = "";
			gradContinue = false;
		}
		this.init();
		NamedNodeMap objattr = theNode.getAttributes();
		//Style ⺻ ʱȭ
		this.setColorMode(true);
		this.fillColor = Color.black;
		this.setColorOpacity(1);
		
		for(int i=0; i<objattr.getLength(); i++) {
			if(objattr.item(i).getNodeName().equals("x")) {
				x = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("y")) {
				y = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("width")) {
				width = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("height")) {
				height = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("transform")) {		
				String transform = objattr.item(i).getNodeValue();
				this.transformDisplay(transform);
			}
			else if(objattr.item(i).getNodeName().equals("style")) {
				totalStyle = objattr.item(i).getNodeValue();
				//Ÿ
				StyleParser.getInstance().toJavaStyleParser(totalStyle);
				StyleParser.getInstance().toJavaPreStyleParser(preTotalStyle); // Color&Gradient Ÿ
			}
		}// end for

		this.shapeStyle(theNode, element, tempDrawVector);	//Ÿ  б
		
		if(ckViewBox == true) {
			x = x - viewX;
			y = y - viewY;
		}
		
		if(ckTranslate == true) {
			//ġ
			x = x + Math.round(transX);
			y = y + Math.round(transY);
		}
		
		element = 
			new RectangleTool(x, y);

		element.setWidth(width);
		element.setHeight(height);	
		//Transform
		element.setRotateAngle(rotate);
		element.setScaleX(scaleX);
		element.setScaleY(scaleY);
		//TransformMode
		element.setRotateMode(ckRotate);
		element.setScaleMode(ckScale);
		
		this.modeDisplay(element);
		element = setElementLayerInform(element);
		
		System.out.println(" x='"+ x + "' y='"+ y+ "' width='" +width+ "' height='" +height+ "'");
		tempDrawVector.add(element);
	}// end rectOpen
	public void roundRectOpen(Node theNode,						// 簢 ׸
							Element element, 
							Vector<Element> tempDrawVector) {
		if(gradContinue != true) {
			preTotalStyle = "";
			gradContinue = false;
		}
		this.init();
		NamedNodeMap objattr = theNode.getAttributes();
		//Style ⺻ ʱȭ
		this.setColorMode(true);
		this.fillColor = Color.black;
		this.setColorOpacity(1);
		
		int radCk=0, x2=0, y2=0;
		for(int i=0; i<objattr.getLength(); i++) {
			if(objattr.item(i).getNodeName().equals("x")) {
				x = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("y")) {
				y =  Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("rx")) {
				x2 = Math.round((Float.parseFloat(objattr.item(i).getNodeValue())));
				radCk++;
			}
			else if(objattr.item(i).getNodeName().equals("ry")) {
				y2 = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
				radCk++;
			}
			else if(objattr.item(i).getNodeName().equals("width")) {
				width = Math.round((Float.parseFloat(objattr.item(i).getNodeValue())));
			}
			else if(objattr.item(i).getNodeName().equals("height")) {
				height = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("transform")) {	
				String transform = objattr.item(i).getNodeValue();
				this.transformDisplay(transform);
			}
			else if(objattr.item(i).getNodeName().equals("style")) {
				totalStyle = objattr.item(i).getNodeValue();
				//Ÿ
				StyleParser.getInstance().toJavaStyleParser(totalStyle);
				StyleParser.getInstance().toJavaPreStyleParser(preTotalStyle);
			}// end else if	
		}// end for
		
		this.shapeStyle(theNode, element, tempDrawVector);	//Ÿ  б
		
		if(radCk == 1) { 
			if(x2 == 0) { x2 = y2; }
			else if(y2 == 0) { y2 = x2; }
		}
		
		if(ckViewBox == true) {
			x = x - viewX;
			y = y - viewY;
		}
		
		if(ckTranslate == true) {
			//ġ
			x = x + Math.round(transX);
			y = y + Math.round(transY);
		}
		
		element = 
			new RoundRectTool(x, y);
		//arcWidth, arcHeight
		((RoundRectTool)(element)).setArcWidth(x2*2);
		((RoundRectTool)(element)).setArcHeight(y2*2);
		element.setWidth(width);
		element.setHeight(height);
		//Transform
		element.setRotateAngle(rotate);
		element.setScaleX(scaleX);
		element.setScaleY(scaleY);
		//TransformMode
		element.setRotateMode(ckRotate);
		element.setScaleMode(ckScale);
		
		this.modeDisplay(element);
		element = setElementLayerInform(element);
		
		System.out.println(" x='"+ x + "' y='"+ y+ "' rx='"+ x2+ "' ry='" +y2+ "' width='" +width+ "' height='" +height+ "'");
		tempDrawVector.add(element);
	}// end roundRectOpen
		
	public void ellipseOpen(Node theNode,						//Ÿ  ׸
							Element element, 
							Vector<Element> tempDrawVector) { 
		if(gradContinue != true) {
			preTotalStyle = "";
			gradContinue = false;
		}
		this.init();
		NamedNodeMap objattr = theNode.getAttributes();
		//Style ⺻ ʱȭ
		this.setColorMode(true);
		this.fillColor = Color.black;
		this.setColorOpacity(1);

		for(int i=0; i<objattr.getLength(); i++) {
			if(objattr.item(i).getNodeName().equals("cx")) {
				x =  Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("cy")) {
				y =  Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("r")) {
				width = Math.round(Float.parseFloat(objattr.item(i).getNodeValue())*2);
				height = width;
			}
			else if(objattr.item(i).getNodeName().equals("rx")) {
				width =  Math.round(Float.parseFloat(objattr.item(i).getNodeValue())*2);
			}
			else if(objattr.item(i).getNodeName().equals("ry")) {
				height =  Math.round(Float.parseFloat(objattr.item(i).getNodeValue())*2);
			}
			else if(objattr.item(i).getNodeName().equals("transform")) {	
				String transform = objattr.item(i).getNodeValue();
				this.transformDisplay(transform);
			}
			else if(objattr.item(i).getNodeName().equals("style")) {
				totalStyle = objattr.item(i).getNodeValue();
				//Ÿ
				StyleParser.getInstance().toJavaStyleParser(totalStyle);
				StyleParser.getInstance().toJavaPreStyleParser(preTotalStyle);
			}// end else if
		}// end for
		
		this.shapeStyle(theNode, element, tempDrawVector);	//Ÿ  б
		
		if(ckViewBox == true) {
			x = x - viewX;
			y = y - viewY;
		}
		
		if(ckTranslate == true) {
			//ġ
			x = x + Math.round(transX);
			y = y + Math.round(transY);
		}

		element = 
			new EllipseTool(x-width/2, y-height/2);
		element.setWidth(width);
		element.setHeight(height);		
		//Transform
		element.setRotateAngle(rotate);
		element.setScaleX(scaleX);
		element.setScaleY(scaleY);
		//TransformMode
		element.setRotateMode(ckRotate);
		element.setScaleMode(ckScale);
		
		this.modeDisplay(element);
		element = setElementLayerInform(element);
		
		System.out.println(" cx='"+ x + "' cy='"+ y+ "' rx='" +width+ "' ry='" +height+ "'");
		tempDrawVector.add(element);
	}// end ellipseOpen
	
	public void lineOpen(Node theNode,							// ׸
						Element element, 
						Vector<Element> tempDrawVector){			
		if(gradContinue != true) {
			preTotalStyle = "";
			gradContinue = false;
		}
		this.init();
		//Style ⺻ ʱȭ
		this.setColorMode(true);
		this.fillColor = Color.black;
		this.setColorOpacity(1);

		NamedNodeMap objattr = theNode.getAttributes();
		for(int i=0; i<objattr.getLength(); i++) {
			if(objattr.item(i).getNodeName().equals("x1")) {
				x = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("y1")) {
				y = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("x2")) {
				x2 = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("y2")) {
				y2 = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("transform")) {					
				String transform = objattr.item(i).getNodeValue(); //rotate(num)
				this.transformDisplay(transform);
			}
			else if(objattr.item(i).getNodeName().equals("style")) {
				totalStyle = objattr.item(i).getNodeValue();
				//Ÿ
				StyleParser.getInstance().toJavaStyleParser(totalStyle);
				StyleParser.getInstance().toJavaPreStyleParser(preTotalStyle);
			}// end else if
		}// end for
		
		this.shapeStyle(theNode, element, tempDrawVector);	//Ÿ  б
		
		if(ckViewBox == true) {
			x = x - viewX;
			y = y - viewY;
		}
		
		if(ckTranslate == true) {
			//ġ
			x = x + Math.round(transX);
			y = y + Math.round(transY);
			x2 = x2 + Math.round(transX);
			y2 = y2 + Math.round(transY);
		}
		
		element = 
			new LineTool(x, y);
		element.setX2(x2);
		element.setY2(y2);
		element.setWidth(Math.abs(x2 - x));
		element.setHeight(Math.abs(y2 - y));
		//Transform
		element.setRotateAngle(rotate);
		element.setScaleX(scaleX);
		element.setScaleY(scaleY);
		//TransformMode
		element.setRotateMode(ckRotate);
		element.setScaleMode(ckScale);
		
		this.modeDisplay(element);
		element = setElementLayerInform(element);
		
		System.out.println(" cx='"+ x + "' cy='"+ y+ "' rx='" +width+ "' ry='" +height+ "'");
		
		tempDrawVector.add(element);
	}// end lineOpen()

	public void pathOpen(Node theNode,							//н ׸
						Element element, 
						Vector<Element> tempDrawVector){		
		if(gradContinue != true) {
			preTotalStyle = "";
			gradContinue = false;
		}
		this.init();		
		NamedNodeMap objattr = theNode.getAttributes();
		//Style ⺻ ʱȭ
		this.setColorMode(true);
		this.fillColor = Color.black;
		this.setColorOpacity(1);

		String pathPoint = "";
		String pointXY[];
		
		for(int i=objattr.getLength()-1; i>=0; i--) {
			if(objattr.item(i).getNodeName().equals("transform")) {					
				String transform = objattr.item(i).getNodeValue(); //rotate(num)
				this.transformDisplay(transform);
			}
			else if(objattr.item(i).getNodeName().equals("style")) {
				totalStyle = objattr.item(i).getNodeValue();
				//Ÿ
				StyleParser.getInstance().toJavaStyleParser(totalStyle);
				StyleParser.getInstance().toJavaPreStyleParser(preTotalStyle);
			}
			else if(objattr.item(i).getNodeName().equals("d")) {
				String multiLineValue = objattr.item(i).getNodeValue().toString();
				System.out.println("@" + multiLineValue);
				pathPointList = multiLineValue.split(" ");
				
				boolean curveMode = false;
				boolean ckMove = false, ckLine = false, ckCurve = false;
				boolean ckSmoothCurve = false, ckQuadratic = false;
				for(int pointIndex=0; pointIndex<pathPointList.length; pointIndex++) {
					pathPoint = pathPointList[pointIndex].trim();
					if(pathPoint.startsWith("C") || 
							pathPoint.startsWith("S") || 
							pathPoint.startsWith("Q") ||
							pathPoint.startsWith("T")) {
						curveMode = true;
						break;
					}
				}// end for	
				
				//PenTool
				if(curveMode) {
					int curvePointIndex = 1;	
					float ctrlX1=0.0f, ctrlY1=0.0f;
					float ctrlX2=0.0f, ctrlY2=0.0f;
					float x2=0.0f, y2=0.0f;
					
					for(int pointIndex=0; pointIndex<pathPointList.length; pointIndex++) {
						pathPoint = pathPointList[pointIndex].trim();
						
						if(pathPoint.startsWith("M")) {			
							//MoveTo(ǥ)
							ckMove = true; 
							ckLine = false;
							ckCurve = false;
							ckSmoothCurve = false;
							ckQuadratic = false;
							pathPoint = pathPoint.replace("M", "");
							if(pathPoint.contains(",")) {
								pointXY = pathPoint.split(",");
								//System.out.println("pen(M) " + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								element = new PenTool(x, y);
								element.setStrokeMode(true);
							} else {
								pathPointList[pointIndex+1] = "M" + pathPointList[pointIndex+1];
								//pathPointList[pointIndex+1] = "M" + pathPointList[pointIndex+1];
								//System.out.println("pen(M) next ");								
							}
						}					
						else if(pathPoint.startsWith("L"))	{	
							//Line To()
							ckMove = false;
							ckLine = true;
							ckCurve = false;
							ckSmoothCurve = false;
							ckQuadratic = false;
							pathPoint = pathPoint.replace("L", "");
							if(pathPoint.endsWith("z") || pathPoint.endsWith("Z")) {	
								//ClosePath(: )		
								ckLine = false;
								pathPoint = pathPoint.substring(0, pathPoint.length()-1);
								pointXY = pathPoint.split(",");
								System.out.println("pen(z) " + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								((MultiLineTool)element).setPathPoint(x, y);
								((MultiLineTool)element).setPoint(x, y);
								((MultiLineTool)element).setMultiLineClose();
							}
							else if(pathPoint.contains(",")) {
								pointXY = pathPoint.split(",");
								//System.out.println("pen(L) " + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								((PenTool)element).addCurve(x, y, x, y, x, y);
							}
							else {
								pathPointList[pointIndex+1]  = "L" + pathPointList[pointIndex+1];
								//System.out.println("pen(M) next ");
							}
						}
						else if(pathPoint.startsWith("C"))	{
							ckMove = false;
							ckLine = false;
							ckCurve = true;
							ckSmoothCurve = false;
							ckQuadratic = false;
							pathPoint = pathPoint.replace("C", "");
							if(pathPoint.contains(",")) {
								pointXY = pathPoint.split(",");
								if(curvePointIndex == 1) {
									curvePointIndex++;
									System.out.println("pen(1C)" + pointXY[0] + " : " + pointXY[1]);
									ctrlX1 = Math.round(Float.parseFloat(pointXY[0].toString()));
									ctrlY1 = Math.round(Float.parseFloat(pointXY[1].toString()));
								}
							}
						}	
						else if(pathPoint.startsWith("S")) {
							ckMove = false;
							ckLine = false;
							ckCurve = false;
							ckSmoothCurve = true;
							ckQuadratic = false;
							pathPoint = pathPoint.replace("S", "");
							if(pathPoint.contains(",")) {
								pointXY = pathPoint.split(",");
								if(curvePointIndex == 1) {
									curvePointIndex++;
									ctrlX1 = x2;
									ctrlY1 = y2 + Math.abs(Math.abs(ctrlY2) - Math.abs(y2));
									System.out.println("pen(1S)" + ctrlX1 + " : " + ctrlY1);
									System.out.println("pen(2S)" + pointXY[0] + " : " + pointXY[1]);
									ctrlX2 = Math.round(Float.parseFloat(pointXY[0].toString()));
									ctrlY2 = Math.round(Float.parseFloat(pointXY[1].toString()));
								}
							}
						}
						else if(pathPoint.startsWith("Q")) {
							ckMove = false; 
							ckLine = false;
							ckCurve = false;
							ckSmoothCurve = false;
							ckQuadratic = true;
							pathPoint = pathPoint.replace("Q",	"");
							if(pathPoint.contains(",")) {
								pointXY = pathPoint.split(",");
								if(curvePointIndex == 1) {
									curvePointIndex++;
									ctrlX1 = Math.round(Float.parseFloat(pointXY[0].toString()));
									ctrlY1 = Math.round(Float.parseFloat(pointXY[1].toString()));									
									ctrlX1 = ctrlX1 - Math.round(Math.abs(Math.abs(ctrlX1) - Math.abs(x))*0.35);
									ctrlY1 = ctrlY1 + Math.abs((Math.abs(ctrlY1)) - Math.abs(y))/3;
								}
							}
						}
						else if(pathPoint.startsWith("T")) {
							ckMove = false; 
							ckLine = false;
							ckCurve = false;
							ckSmoothCurve = false;
							ckQuadratic = false;
							pathPoint = pathPoint.replace("T", "");
							if(pathPoint.contains(",")) {
								pointXY = pathPoint.split(",");
								ctrlX1 = x + Math.abs(Math.abs(ctrlX2) - Math.abs(x));
								ctrlY1 = y + Math.abs(Math.abs(ctrlY2) - Math.abs(y));
								float tmpCtrlX1 = ctrlX1 + Math.round(Math.abs(Math.abs(ctrlX1) - Math.abs(x))*0.35);
								float tmpCtrlY1 = ctrlY1 - Math.abs((Math.abs(ctrlY1)) - Math.abs(y))/3;
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								ctrlX2 = tmpCtrlX1 + Math.round(Math.abs(Math.abs(ctrlX1) - Math.abs(x))*0.35);
								ctrlY2 = tmpCtrlY1 + (Math.abs((Math.abs(ctrlY1)) - Math.abs(y))/3);
								((PenTool)element).addCurve(
										ctrlX1, ctrlY1, ctrlX2, ctrlY2, x, y);
								curvePointIndex = 1;
								System.out.println("pen(1T)" + ctrlX1 + " : " + ctrlY1);
								System.out.println("pen(2T)" + ctrlX2 + " : " + ctrlY2);
								System.out.println("pen(3T)" + pointXY[0] + " : " + pointXY[1]);
							}
						}
						else if(pathPoint.startsWith("z") || pathPoint.startsWith("Z")) {	
							//((PenTool)element).setPenToolClose();
							ckMove = false; 
							ckLine = false;
							ckCurve = false;
							ckSmoothCurve = false;
							ckQuadratic = false;
							pathPoint = pathPoint.substring(0, pathPoint.length()-1);
							pointXY = pathPoint.split(",");
							x = Math.round(Float.parseFloat(pointXY[0].toString()));
							y = Math.round(Float.parseFloat(pointXY[1].toString()));
							//System.out.println("pen(z) " + pointXY[0] + " : " + pointXY[1]);
						}	
						else {
							pointXY = pathPoint.split(",");
							if(ckMove == true) {	
								pointXY = pathPoint.split(",");
								//System.out.println("pen(M) ckMove = true" + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								element = new PenTool(x, y);
							}
							else if(ckLine == true) {
								pointXY = pathPoint.split(",");
								//System.out.println("pen(L) ckLine = true" + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								((PenTool)element).setPoint(x, y);
							}
							else if(ckCurve == true) {
								if(pathPoint.contains(",")) {
									pointXY = pathPoint.split(",");

									if(curvePointIndex == 2) {
										System.out.println("pen(2C) ckCurve = true" + pointXY[0] + " : " + pointXY[1]);
										ctrlX2 = Math.round(Float.parseFloat(pointXY[0].toString()));
										ctrlY2 = Math.round(Float.parseFloat(pointXY[1].toString()));
										curvePointIndex++;
									}
									else if(curvePointIndex == 3) {
										System.out.println("pen(3C) ckCurve = true" + pointXY[0] + " : " + pointXY[1]);
										x = Math.round(Float.parseFloat(pointXY[0].toString()));
										y = Math.round(Float.parseFloat(pointXY[1].toString()));									
										((PenTool)element).addCurve(
												ctrlX1, ctrlY1, ctrlX2, ctrlY2, x, y);
										curvePointIndex = 1;
									}
								}
							}
							else if(ckSmoothCurve == true) {
								if(pathPoint.contains(",")) {
									pointXY = pathPoint.split(",");
									if(curvePointIndex == 2) {
										System.out.println("pen(3S) ckSmoothCurve = true" + pointXY[0] + " : " + pointXY[1]);
										x = Math.round(Float.parseFloat(pointXY[0].toString()));
										y = Math.round(Float.parseFloat(pointXY[1].toString()));									
										((PenTool)element).addCurve(
												ctrlX1, ctrlY1, ctrlX2, ctrlY2, x, y);
										curvePointIndex = 1;
									}
								}
							}
							else if(ckQuadratic == true) {
								if(pathPoint.contains(",")) {
									pointXY = pathPoint.split(",");
									if(curvePointIndex == 2) {
										float tmpCtrlX1 = ctrlX1 + Math.round(Math.abs(Math.abs(ctrlX1) - Math.abs(x))*0.35);
										float tmpCtrlY1 = ctrlY1 - Math.abs((Math.abs(ctrlY1)) - Math.abs(y))/3;
										x = Math.round(Float.parseFloat(pointXY[0].toString()));
										y = Math.round(Float.parseFloat(pointXY[1].toString()));
										ctrlX2 = tmpCtrlX1 + Math.round(Math.abs(Math.abs(ctrlX1) - Math.abs(x))*0.35);
										ctrlY2 = tmpCtrlY1 + (Math.abs((Math.abs(ctrlY1)) - Math.abs(y))/3);
										((PenTool)element).addCurve(
												ctrlX1, ctrlY1, ctrlX2, ctrlY2, x, y);
										curvePointIndex = 1;
										System.out.println("pen(1Q)" + ctrlX1 + " : " + ctrlY1);
										System.out.println("pen(2Q) ckQuadratic = true" + ctrlX2 + " : " + ctrlY2);
										System.out.println("pen(3Q) ckQuadratic = true" + pointXY[0] + " : " + pointXY[1]);
									}
								}
							}// end else if
						}//end else
					}// end for
					
					((PenTool)element).setPenBounds();
					width = element.getWidth();
					((PenTool)element).setPenWhileMode(false);
					
					if(ckTranslate == true) {
						//x = Math.round(transX);
						//y = Math.round(transY);
						//x = x + Math.round(transX);
						//y = y + Math.round(transY);
						element.translate(0, 0, transX, transY);
					}
					
					if(ckViewBox == true) {
						element.translate(0, 0, transX-viewX, transY-viewY);
					}
					//Transform
					element.setRotateAngle(rotate);
					element.setScaleX(scaleX);
					element.setScaleY(scaleY);
					//TransformMode
					element.setRotateMode(ckRotate);
					element.setScaleMode(ckScale);
					
					this.modeDisplay(element);
					element = setElementLayerInform(element);
					
					tempDrawVector.add(element);				
				}//end Pen
				
				//MultiLine
				else {				
					for(int pointIndex=0; pointIndex<pathPointList.length; pointIndex++) {
						pathPoint = pathPointList[pointIndex].trim();
						if(pathPoint.startsWith("M")) {			
							//MoveTo(ǥ)
							ckMove = true;
							ckLine = false;
							ckCurve = false;
							pathPoint = pathPoint.replace("M", "");
							if(pathPoint.contains(",")) {						
								pointXY = pathPoint.split(",");
								System.out.println("multiLine(M) " + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								element = new MultiLineTool(x, y);
								element.setStrokeMode(true);
							}
							else {
								pathPointList[pointIndex+1] = "M" + pathPointList[pointIndex+1];
							}
						}				
						else if(pathPoint.startsWith("L"))	{	
							//Line To()
							ckMove = false;
							ckLine = true;
							ckCurve = false;
							pathPoint = pathPoint.replace("L", "");
							if(pathPoint.endsWith("z") || pathPoint.endsWith("Z")) {	
								//ClosePath(: )		
								ckMove = false;
								ckLine = false;
								ckCurve = false;
								pathPoint = pathPoint.substring(0, pathPoint.length()-1);
								pointXY = pathPoint.split(",");
								System.out.println("multiLine(z) " + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								((MultiLineTool)element).setPathPoint(x, y);
								((MultiLineTool)element).setPoint(x, y);
								((MultiLineTool)element).setMultiLineClose();
							}
							else if(pathPoint.contains(",")) {
								pointXY = pathPoint.split(",");
								System.out.println("multiLine(L) " + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								((MultiLineTool)element).setPathPoint(x, y);
								((MultiLineTool)element).setPoint(x, y);
							}
							else {
								pathPointList[pointIndex+1] = "L" + pathPointList[pointIndex+1];
							}
						}
						else if(pathPoint.startsWith("H")) {
							ckMove = false;
							ckLine = false;
							pathPoint = pathPoint.replace("H", "");
							System.out.println("multiLine(H) " + pathPoint + " : " + y);
							x = Float.parseFloat(pathPoint.toString());
							((MultiLineTool)element).setPathPoint(x, y);
							((MultiLineTool)element).setPoint(x, y);
						}
						else if(pathPoint.startsWith("V")) {
							ckMove = false;
							ckLine = false;
							pathPoint = pathPoint.replace("V", "");
							System.out.println("multiLine(V) " + x + " : " + pathPoint);
							y = Float.parseFloat(pathPoint.toString());
							((MultiLineTool)element).setPathPoint(x, y);
							((MultiLineTool)element).setPoint(x, y);
						}
						else if(pathPoint.endsWith("z") || pathPoint.endsWith("Z")) {	
							//ClosePath(: )		
							ckMove = false;
							ckLine = false;
							ckCurve = false;
							pathPoint = pathPoint.substring(0, pathPoint.length()-1);
							pointXY = pathPoint.split(",");
							System.out.println("multiLine(z) " + pointXY[0] + " : " + pointXY[1]);
							x = Math.round(Float.parseFloat(pointXY[0].toString()));
							y = Math.round(Float.parseFloat(pointXY[1].toString()));
							((MultiLineTool)element).setPathPoint(x, y);
							((MultiLineTool)element).setPoint(x, y);
							((MultiLineTool)element).setMultiLineClose();
						}
						else {
							pointXY = pathPoint.split(",");
							if(ckMove == true) {	
								pointXY = pathPoint.split(",");
								System.out.println("multiLine(M) ckMove = true" + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								element = new MultiLineTool(x, y);
							}
							else if(ckLine == true) {
								pointXY = pathPoint.split(",");
								System.out.println("multiLine(L) ckLine = true" + pointXY[0] + " : " + pointXY[1]);
								x = Math.round(Float.parseFloat(pointXY[0].toString()));
								y = Math.round(Float.parseFloat(pointXY[1].toString()));
								((MultiLineTool)element).setPathPoint(x, y);
								((MultiLineTool)element).setPoint(x, y);
							}
						}
					}// end for
					((MultiLineTool)element).setMultiLineBounds();			
					
					if(ckTranslate == true) {
						//x = Math.round(transX);
						//y = Math.round(transY);
						//x = x + Math.round(transX);
						//y = y + Math.round(transY);
						element.translate(0, 0, transX, transY);
					}
					
					if(ckViewBox == true) {
						element.translate(0, 0, transX-viewX, transY-viewY);
					}
					
					//Transform
					element.setRotateAngle(rotate);
					element.setScaleX(scaleX);
					element.setScaleY(scaleY);
					//TransformMode
					element.setRotateMode(ckRotate);
					element.setScaleMode(ckScale);
					
					this.modeDisplay(element);
					element = setElementLayerInform(element);
					
					tempDrawVector.add(element);				
				}
			}// end if		
		}// end for
	}// end pathOpen()
	
	public void imageOpen() {									//̹ ׸
		if(gradContinue != true) {
			preTotalStyle = "";
			gradContinue = false;
		}
		this.init();
	}
	
	public void textOpen(Node theNode,							//ؽƮ ׸
						Element element, 
						Vector<Element> tempDrawVector){
		if(gradContinue != true) {
			preTotalStyle = "";
			gradContinue = false;
		}
		this.init();
		NamedNodeMap objattr = theNode.getAttributes();
		//Style ⺻ ʱȭ
		this.setColorMode(true);
		this.fillColor = Color.black;
		this.setColorOpacity(1);
		
		String textValue = "";
		for(int i=0; i<objattr.getLength(); i++) {
			if(objattr.item(i).getNodeName().equals("x")) {
				x = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("y")) {
				y = Math.round(Float.parseFloat(objattr.item(i).getNodeValue()));
			}
			else if(objattr.item(i).getNodeName().equals("transform")) {		
				String transform = objattr.item(i).getNodeValue();
				this.transformDisplay(transform);
			}
			else if(objattr.item(i).getNodeName().equals("style")) {
				totalStyle = objattr.item(i).getNodeValue();
				//Ÿ
				StyleParser.getInstance().toJavaStyleParser(totalStyle);
				StyleParser.getInstance().toJavaPreStyleParser(preTotalStyle);
			}			
		}// end for

		textValue = theNode.getFirstChild().getNodeValue(); //Text Value
		this.shapeStyle(theNode, element, tempDrawVector);
		
		if(ckViewBox == true) {
			x = x - viewX;
			y = y - viewY;
		}
		
		if(ckTranslate == true) {
			//ġ
			x = x + Math.round(transX);
			y = y + Math.round(transY);
		}
		element = new TextTool(x, y, fontSize, fontStyle, fontFamily, textValue);
		
		//Text		
	    ((TextTool)element).initTextTool();
	    ((TextTool)element).alignY1FromSVG();
		//Transform
		element.setRotateAngle(rotate);
		element.setScaleX(scaleX);
		element.setScaleY(scaleY);
		//TransformMode
		element.setRotateMode(ckRotate);
		element.setScaleMode(ckScale);
		//element = setElementLayerInform(element);
				
		this.modeDisplay(element);
		element = setElementLayerInform(element);
		
		System.out.println("x='" + x + "' y='" + y + "'");
		tempDrawVector.add(element);
	}// end textOpen
	
	public void groupOpen(Node theNode,							//׷  ׸
			Element element, 
			Vector<Element> tempDrawVector) {
		NamedNodeMap objattr = theNode.getAttributes();
		for(int i=0; i<objattr.getLength(); i++) {
			if(objattr.item(i).getNodeName().equals("transform")) {	
				String transform = objattr.item(i).getNodeValue();
				this.transformDisplay(transform);
			}
		}
		//element.groupTool = new GroupTool();
	}//end groupOpen()
	
	
	public void gradientOpen(Node theNode,						//׷Ʈ id, transform, r, spreadMethod
							Element element,
							Vector<Element> tempDrawVector, 
							boolean ckGradStyle){
		idGradStyleList.add(ckGradStyle);
		idGradRotateList.add(0.0f);		
		idGradScaleList.add(0.0f);
		idGradCycleList.add(false);		//default: pad
		NamedNodeMap objattr = theNode.getAttributes();
		gradList = new ArrayList<GradientTool>();
		for(int i=0; i<objattr.getLength(); i++) {
			if(objattr.item(i).getNodeName().equals("gradientTransform")) { //Gradient Angle
				String tmpGradTransform = objattr.item(i).getNodeValue();	//rotate(0.0)  scale(0.5)
				String gradTrans[];
				gradTrans = tmpGradTransform.split(" ");
				for(int g=0; g<gradTrans.length; g++) {
					if(gradTrans[g].trim().startsWith("rotate")) {
						idGradRotate = Float.parseFloat(
									gradTrans[g].trim().substring(7, gradTrans[g].length()-1));
						idGradRotateList.remove(idGradRotateList.size()-1);
						idGradRotateList.add(idGradRotate);	//Gradient ID   index gradRotate 
					}
					else if(gradTrans[g].trim().startsWith("scale")) {
						idGradScale = Float.parseFloat(
									gradTrans[g].trim().substring(6, gradTrans[g].length()-1));
						idGradScaleList.remove(idGradScaleList.size()-1);
						idGradScaleList.add(idGradScale);
					}
				}
			}
			else if(objattr.item(i).getNodeName().equals("id")) {		
				String id = objattr.item(i).getNodeValue();
				if(idList.isEmpty())
					idList.add(id);	//Gradient ID
				else {
					for(int j=0; j<idList.size(); j++ ) {			
						if(!idList.get(j).equals(id)) {
							idList.add(id);
							break;
						}
					}
				}
			}
			else if(objattr.item(i).getNodeName().equals("r")) {
				//ckRadialGrad = true;
				radial = Float.parseFloat(objattr.item(i).getNodeValue());
			}
			else if(objattr.item(i).getNodeName().equals("spreadMethod")) {
				String ckRepeat = objattr.item(i).getNodeValue();
				if(ckRepeat.trim().equals("repeat")) {	//repeat_Gradient
					//this.setGradCycle(true);
					idGradCycleList.remove(idGradCycleList.size()-1);
					idGradCycleList.add(true);
				}
			}
		}	
	}// end gradientOpen
	
	public void stopOpen(Node theNode,							//׷Ʈ : stop
			Element element,
			Vector<Element> tempDrawVector){
		NamedNodeMap objattr = theNode.getAttributes();
		String sOffset;
		int iOffset = 0;
		for(int i=0; i<objattr.getLength(); i++) {
			if(objattr.item(i).getNodeName().equals("offset")) {
				sOffset = objattr.item(i).getNodeValue();
				if(sOffset.endsWith("%")) { //
					sOffset = sOffset.substring(0, sOffset.length()-1);
					iOffset =  Math.round(Float.parseFloat(sOffset)*2);
				}
				else {
					iOffset =  Math.round(Float.parseFloat(sOffset)*200);
				}
			}
			else if(objattr.item(i).getNodeName().equals("style")) {
				totalStyle = objattr.item(i).getNodeValue();
				StyleParser.getInstance().toJavaStyleParser(totalStyle);
			}
			if(i%2 !=0) {
				gradRect = new GradientTool(iOffset, gradientColor);
				gradRect.setColor(gradientColor);
				gradList.add(gradRect);	
			}
		}// end for
		this.shapeStyle(theNode, element, tempDrawVector);
	}
	public void addGradList(boolean ckStop1, boolean ckStop2) {	//׷Ʈ : List߰
		if(ckStop1==true && ckStop2==true) {
			idGradList.add(gradList); //idList  ε idGradList gradList 
		}
	}
	
	public void transformDisplay(String transform) {			//Transform 
		String transformList[];
		transformList = transform.split(" ");
		for(int i=0; i<transformList.length; i++)
		{
			System.out.println(transformList[i]);
			if(transformList[i].trim().startsWith("translate")) {					//ǥ ̵
				String tmpTranslate = transform.trim().substring(10,transformList[i].trim().length()-2);
				String trans[];
				trans = tmpTranslate.split(",");
				transX =  Float.parseFloat(trans[0]);
				transY =  Float.parseFloat(trans[1]);
				//element  ش ǥ 
				System.out.println("*translate " +transX +":"+transY);
				ckTranslate = true;
			}
			else if(transformList[i].trim().startsWith("scale")) {		//Ȯ, 
				String tmpScale = transformList[i].trim().substring(6,transformList[i].trim().length()-1);
				if(tmpScale.indexOf(",") != -1) {
					String scale[];
					scale = tmpScale.split(",");
					scaleX = Float.parseFloat(scale[0]);
					scaleY = Float.parseFloat(scale[1]);			
					//Scale  ߽ɰ ٽ 
					ckScale = true;
				}
				else {
					scaleX = Float.parseFloat(tmpScale);
					scaleY = scaleX;
					ckScale = true;
				}
				System.out.println("*scale " +scaleX +":"+scaleY);
			}
			else if(transformList[i].trim().startsWith("rotate")) {		
				String tmpRotate = transformList[i].trim().substring(7,transformList[i].trim().length()-1);
				rotate =  Math.round(Float.parseFloat(tmpRotate));	
				ckRotate = true;
				System.out.println("*rotate " +rotate);
			}
		}
	}
	
	public void modeDisplay(Element element) {					//Mode ÷
		if(colorMode) {
			element.setFillColorFromSVG(fillColor, getColorOpacity());
		}
		if(strokeMode) {
			element.setStrokeFromSVG(
					strokeSize, 
					strokeOpacity, 
					strokePosition, 
					strokeFillSelector);
			if(strokeFillSelector == DrawToolConst.STROKE_COLOR) {	//stroke 
				element.setStrokeColor(strokeColor);
			}
			else if(strokeFillSelector == DrawToolConst.STROKE_GRADIENT) {	//stroke gradient
				if(this.strokeGradStyle == true) {
					element.setStrokeGradRadius(radial);
					element.setStrokeGradScale(radial);
					element.setStrokeGradStyle(DrawToolConst.RADIAL_GRAD);			    	
				}
				else if(strokeGradStyle == false) {
					element.setStrokeGradScale(strokeScaleGrad*100);
					element.setStrokeGradAngle(strokeAngleGrad);
					element.setStrokeGradStyle(DrawToolConst.LINEAR_GRAD);
				}
				/*if(strokeGradList.get(1).getX() != 200) {
					strokeGradList.get(1).setX(200);
				}
				if(strokeGradList.get(0).getX() != 0) {
					strokeGradList.get(0).setX(0);
				}*/	
				if(!strokeGradList.isEmpty()) {
					element.setStrokeGradient(strokeGradList);					
					element.setStrokeGradCycle(strokeRepeatGrad);
				}
			}
			else if(strokeFillSelector == DrawToolConst.STROKE_PATTERN) {	//stroke pattern
			}
			element.setStrokeOpacity(strokeOpacity);
		}
		if(gradientMode) {
		    if(fillGradStyle == true) {
		    	element.setGradRadius(radial);
		    	idGradScale = ((100/(width/radial))/100)*2;
		    	//idGradScale = 2/(width/radial);
		    	element.setGradScale(idGradScale);
				element.setGradStyle(DrawToolConst.RADIAL_GRAD);
			}
			else if(fillGradStyle == false) {
				element.setGradVarFromSVG(fillScaleGrad, fillAngleGrad);	
				element.setGradStyle(DrawToolConst.LINEAR_GRAD);
			}
			if(!fillGradList.isEmpty()) {
				/*if(fillGradList.get(fillGradList.size()-1).getX() != 200) {
					fillGradList.get(fillGradList.size()-1).setX(200);
				}
				if(fillGradList.get(0).getX() != 0) {
					fillGradList.get(0).setX(0);
				}*/
				element.setGradientFromSVG(fillGradList);				
				element.setGradOpacity(gradientOpacity);
				element.setGradCycle(fillRepeatGrad);
			}
		}
	}//end modeDisplay()
	
	public void shapeStyle(Node theNode,						//Ÿ  б(۾)
			Element element, 
			Vector<Element> tempDrawVector) {			

		boolean ckFontStyle = false;
		Color tmpFillColor = Color.black;
		
		NamedNodeMap objattr = theNode.getAttributes();
	
		for(int attIndex=0; attIndex<objattr.getLength(); attIndex++) {
			if(objattr.item(attIndex).getNodeName().equals("fill")) {
				String fillColor = objattr.item(attIndex).getNodeValue();
								
				if(fillColor.equals("none")) { 			//ä 
					this.setColorMode(false);
				}
				else if(fillColor.startsWith("url")) {	//׷Ʈ
					this.setGradientMode(true);
					fillColor = fillColor.substring(5, fillColor.length()-1);	//id 
					for(int i=0; i<this.idList.size(); i++) {
						if(this.idList.get(i).toString().equals(fillColor)) {	//id  index  ã
							this.setFillGradList((ArrayList<GradientTool>)this.idGradList.get(i));
							element.setGradAngle(this.idGradRotateList.get(i));	//gradientAngle
							element.setGradScale(this.idGradScaleList.get(i));	//gradientScale
							element.setGradCycle(this.idGradCycleList.get(i));	//gradientRepeat
							break;
						}
					}
				}
				else {									// ä
					//1. rgb(0,0,0)
					//2. black / Black
					//3. #000000
					this.setColorMode(true);
					if(fillColor.startsWith("rgb")) { //RGB
						fillColor = fillColor.replace("rgb(", "");
						fillColor = fillColor.replace(")", "");
						
						String[] tmp = fillColor.split(",");

						int r, g, b;
						r = Integer.parseInt(tmp[0]);
						g = Integer.parseInt(tmp[1]);
						b = Integer.parseInt(tmp[2]);
						
						tmpFillColor = new Color(r,g,b);
						this.setFillColor(tmpFillColor);
					}
					else if(fillColor.startsWith("#")) { //#000000
						ColorConverter cc = new ColorConverter();
						tmpFillColor = cc.RGB(fillColor);
						this.setFillColor(tmpFillColor);
					}
					else{ //Color Name
						tmpFillColor = ColorParser.getInstance().getColor(fillColor);						
						this.setFillColor(tmpFillColor);
					}
				}				 
			}			
			else if(objattr.item(attIndex).getNodeName().equals("fill-opacity")) {
				this.setOpacityMode(true);
				
				if(this.getColorMode() && this.getGradientMode()) { //Color & Gradient Mode
					ckOpacity++;	//ʱⰪ : 0
					if(ckOpacity != 0) {
						this.setGradOpacity(
								Float.parseFloat(objattr.item(attIndex).getNodeValue().trim()));
					}
					else {
						this.setColorOpacity(
								Float.parseFloat(objattr.item(attIndex).getNodeValue().trim()));
					}
				}
				else if(this.getColorMode()) {		//Color Mode
					this.setColorOpacity(
							Float.parseFloat(objattr.item(attIndex).getNodeValue().trim()));
				}
				else if(this.getGradientMode()){	//Gradient Mode
					this.setGradOpacity(
							Float.parseFloat(objattr.item(attIndex).getNodeValue().trim()));
				}
			}
			else if(objattr.item(attIndex).getNodeName().equals("stroke")) {
				this.setStrokeMode(true); //Mode 
				String fillColor = objattr.item(attIndex).getNodeValue();
				
				if(fillColor.trim().equals("none")) {
					this.setStrokeMode(false);	
				}
				else if(fillColor.startsWith("url")) {	//׷Ʈ	
					this.setStrokeFillMode(DrawToolConst.STROKE_GRADIENT);
					fillColor = fillColor.substring(5, fillColor.length()-1);	//id 
					for(int i=0; i<this.idList.size(); i++) {
						if(this.idList.get(i).toString().equals(fillColor)) {	//id  index  ã							
							this.setStrokeGradList((ArrayList<GradientTool>)this.idGradList.get(i));
							element.setGradAngle(this.idGradRotateList.get(i));	//gradientAngle
							element.setGradScale(this.idGradScaleList.get(i));	//gradientScale
							element.setGradCycle(this.idGradCycleList.get(i));	//gradientRepeat
							break;
						}
					}
				}
			}
			else if(objattr.item(attIndex).getNodeName().equals("stroke-width")) {
				this.setStrokeMode(true);
				this.setStrokeSize(
						Float.parseFloat(objattr.item(attIndex).getNodeValue().trim()));
			}
			else if(objattr.item(attIndex).getNodeName().equals("stroke-opacity")) {
				this.setOpacityMode(true);
				this.setStrokeOpacity(
						Float.parseFloat(objattr.item(attIndex).getNodeValue().trim()));
			}
			else if(objattr.item(attIndex).getNodeName().equals("font-family")) {
				this.setFontFamily(objattr.item(attIndex).getNodeValue().trim());
			}
			else if(objattr.item(attIndex).getNodeName().equals("font-size")) {
				this.setFontSize(
						Math.round(Float.parseFloat(objattr.item(attIndex).getNodeValue().trim())));	
			}
			else if(objattr.item(attIndex).getNodeValue().equals("font-style")) {
				if(objattr.item(attIndex).getNodeValue().equals("normal"))
					this.setFontStyle(0);				
				else if(objattr.item(attIndex).getNodeValue().equals("italic")) {
					if(ckFontStyle == false) {
						this.setFontStyle(2);
						ckFontStyle = true;
					}
				}
			}
			else if(objattr.item(attIndex).getNodeValue().equals("font-weight")) {
				if(objattr.item(attIndex).getNodeValue().equals("bold")) { 
					this.setFontStyle(1);	
					if(ckFontStyle == true) {
						this.setFontStyle(3);
					}
				}
				else if(objattr.item(attIndex).getNodeValue().equals("normal")) { 
					this.setFontStyle(0);		
				}
			}		
		}
		/*if(exitFill == false && exitOpacity == false) {
			shapeParser.setColorMode(true);
			shapeParser.setFillColor(tmpFillColor);
			shapeParser.setColorOpacity(1);
		}*/
	}//end shapeStyle()
	
	
	
	//Getter & Setter
	//Fill
	public void setColorMode(boolean colorMode) {
		this.colorMode = colorMode;
	}
	public boolean getColorMode() {
		return colorMode;
	}
	public Color getFillColor() {
		return fillColor;
	}
	public void setFillColor(Color fillColor) {
		this.fillColor = fillColor;
			colorMode = true;
	}	
	public void setFillColorFromSVG(Color _fillColor, float _colorOpacity) {
		fillColor = _fillColor;
		colorOpacity = _colorOpacity;
		colorMode = true;
	}
	//Stroke
	public boolean getStrokeMode() {
		return strokeMode;
	}
	public Color getStrokeColor() {
		return strokeColor;
	}
	public void setStrokeColor(Color strokeColor) {
		this.strokeColor = strokeColor;
	}
	public void setStrokeMode(boolean strokeMode) {
		this.strokeMode = strokeMode;
	}
	public float getStrokeSize() {
		return strokeSize;
	}
	public void setStrokeSize(float strokeSize) {
		this.strokeSize = strokeSize;
	}
	public void setStrokeFillMode(int _strokeFillMode) {
		strokeFillSelector = _strokeFillMode;
	}
	//Opacity
	public void setColorOpacity(float _colorOpacity) {
		colorOpacity = _colorOpacity;
	}	
	public float getColorOpacity() {
		return colorOpacity;
	}
	public void setStrokeOpacity(float _strokeOpacity) {
		strokeOpacity = _strokeOpacity;
	}	
	public float getStrokeOpacity() {
		return strokeOpacity;
	}
	//Gradient
	public void setGradOpacityPercent(int _gradOpacity) {
		gradientOpacity = _gradOpacity / 100.0f;
	}
	public void setGradOpacity(float _gradOpacity) {
		gradientOpacity = _gradOpacity;
	}
	public boolean isOpacityMode() {
		return opacityMode;
	}
	public void setOpacityMode(boolean opacityMode) {
		this.opacityMode = opacityMode;
	}
	public void setGradientFromSVG(ArrayList<GradientTool> _gradList) {
		gradList = new ArrayList<GradientTool>();
		for(int i=0; i<_gradList.size(); i++) {
			gradRect = new GradientTool(_gradList.get(i));
			gradList.add(gradRect);
		}
		gradientMode = true;
	}
	public Color getGradColor() {
		return gradientColor;
	}
	public void setGradColor(Color _backColor) {
		gradientColor = _backColor;
	}
	public ArrayList<GradientTool> getRearGradList() {
		return fillGradList;
	}
	public void setFillGradList(ArrayList<GradientTool> tempGradList) {
		fillGradList = tempGradList;
	}
	public void setStrokeGradList(ArrayList<GradientTool> tempGradList) {
		strokeGradList = tempGradList;
	}	
	public boolean getGradientMode() {
		return gradientMode;
	}
	public void setGradientMode(boolean gradientMode) {
		this.gradientMode = gradientMode;
	}
	public void setGradContinue(boolean gradContinue) {
		this.gradContinue = gradContinue;
	}
	public boolean isGradContinue() {
		return gradContinue;
	}	
	public void setFillGradAngle(float _angleGrad) {
		fillAngleGrad = _angleGrad;	
	}
	public void setFillGradScale(float _scaleGrad) {
		fillScaleGrad = _scaleGrad;
	}
	public void setStrokeScaleGrad(float _strokeScaleGrad) {
		strokeScaleGrad = _strokeScaleGrad;
	}
	public void setStrokeAngleGrad(float _strokeAngleGrad) {
		strokeAngleGrad = _strokeAngleGrad;
	}
	public void setFillGradCycle(boolean _fillRepeatGrad) {
		fillRepeatGrad = _fillRepeatGrad;
	}
	public void setStrokeGradCycle(boolean _strokeRepeatGrad) {
		strokeRepeatGrad = _strokeRepeatGrad;
	}
	public void setStrokeGradStyle(boolean strokeGradStyle) {
		this.strokeGradStyle = strokeGradStyle;
	}
	public void setFillGradStyle(boolean fillGradStyle) {
		this.fillGradStyle = fillGradStyle;
	}
	//Style
	public String getTotalStyle() {
		return totalStyle;
	}
	public String getPreTotalStyle() {		
		return preTotalStyle;
	}
	public void setPreTotalStyle(String preTotalStyle) {
		this.preTotalStyle = preTotalStyle;
	}
	//Text
	public String getFontFamily() {
		return fontFamily;
	}
	public void setFontFamily(String fontFamily) {
		this.fontFamily = fontFamily;
	}
	public int getFontSize() {
		return fontSize;
	}
	public void setFontSize(int fontSize) {
		this.fontSize = fontSize;
	}
	public int getFontStyle() {
		return fontStyle;
	}
	public void setFontStyle(int fontStyle) {
		this.fontStyle = fontStyle;
	}
	public void setCkViewBox(boolean ckViewBox) {
		this.ckViewBox = ckViewBox;
	}
	public void setViewX(float viewX) {
		this.viewX = viewX;
	}
	public void setViewY(float viewY) {
		this.viewY = viewY;
	}
	
	
}//end class