package com.sharppaint.svg;

import java.awt.Color;
import java.util.ArrayList;

import com.sharppaint.drawtools.*;

public class StyleParser {
	private String style[];
	private String styleName[];
	private String gradFillColor;
	
	private static StyleParser styleParser = null;
	static final String ATT_STYLE = "\" style=\"";
	static final String ATT_FONT_FAMILY = "font-family:";
	static final String ATT_FONT_STYLE = "font-style:";
	static final String ATT_FONT_WEIGHT = "font-weight:";
	static final String ATT_FONT_SIZE = "font-size:";
	static final String ATT_FILL = "fill:";
	static final String ATT_STROKE = "stroke:";
	static final String ATT_STROKE_WIDTH = "stroke-width:";
	static final String ATT_STROKE_OPACITY = "stroke-opacity:";
	static final String ATT_FILL_OPACITY = "fill-opacity:";
	static final String ATT_STOP_COLOR = "stop-color:";
	static final String ATT_URL = "url(#";
	
	private StyleParser() {
		gradFillColor = null;
	}
	
	public static StyleParser getInstance() {
		if(styleParser==null)
			styleParser = new StyleParser();
		return styleParser;
	}
	
	ShapeParser shapeParser = ShapeParser.getInstance();
	
	// ȭ鿡 
	public void toJavaStyleParser(String totalStyle) {	
		//Style ⺻  ʱȭ
		shapeParser.setColorMode(false);
		shapeParser.fillColor = Color.white;
		shapeParser.setColorOpacity(0);
		
		System.out.println("{" +totalStyle+ "}");		
		style = totalStyle.split(";");	
		
		boolean exitFill = false;	//fill,&opacity Ӽ : black (svg ȣȯ )
		boolean exitOpacity = false;
		boolean ckFontStyle = false;
		Color tmpFillColor = Color.black;
				
		for(int innerIndex=0; innerIndex<style.length; innerIndex++) {
			styleName = style[innerIndex].split(":");

			//Fill(ĥϱ)
			if(styleName[0].trim().equals("fill")) {
				exitFill = true;
				String fillColor = styleName[1].trim();
								
				if(fillColor.equals("none")) { 			//fill none
					shapeParser.setColorMode(false);
					//shapeParser.setGradientMode(false);
				}
				else if(fillColor.startsWith("url")) {	//fill Gradient
					shapeParser.setGradientMode(true);
					fillColor = fillColor.substring(5, fillColor.length()-1);	//id 
					for(int i=0; i<shapeParser.idList.size(); i++) {
						if(shapeParser.idList.get(i).toString().equals(fillColor)) {	//id  index  ã
							shapeParser.setFillGradList((ArrayList<GradientTool>)shapeParser.idGradList.get(i));
							shapeParser.setFillGradAngle(shapeParser.idGradRotateList.get(i));	//gradientAngle
							shapeParser.setFillGradScale(shapeParser.idGradScaleList.get(i));	//gradientScale
							shapeParser.setFillGradCycle(shapeParser.idGradCycleList.get(i));	//gradientRepeat
							shapeParser.setFillGradStyle(shapeParser.idGradStyleList.get(i));	//gradientStyle
							break;
						}
					}
				}
				else {									//fill Color
					//1. rgb(0,0,0)
					//2. black / Black
					//3. #000000
					shapeParser.setColorMode(true);
					if(fillColor.startsWith("rgb")) { //RGB
						fillColor = fillColor.replace("rgb(", "");
						fillColor = fillColor.replace(")", "");
						
						String[] tmp = fillColor.split(",");

						int r, g, b;
						r = Integer.parseInt(tmp[0]);
						g = Integer.parseInt(tmp[1]);
						b = Integer.parseInt(tmp[2]);
						
						tmpFillColor = new Color(r,g,b);
						shapeParser.setFillColor(tmpFillColor);
					}
					else if(fillColor.startsWith("#")) { //#000000
						ColorConverter cc = new ColorConverter();
						tmpFillColor = cc.RGB(fillColor);
						shapeParser.setFillColor(tmpFillColor);
					}
					else{ //Color Name
						tmpFillColor = ColorParser.getInstance().getColor(fillColor);						
						shapeParser.setFillColor(tmpFillColor);
					}
				}				 
			}
			//Stroke()
			else if(styleName[0].trim().equals("stroke")) {
				shapeParser.setStrokeMode(true); //StrokeMode
				String fillColor = styleName[1].trim();
				
				if(styleName[1].trim().equals("none")) {
					shapeParser.setStrokeMode(false);	
				}
				else if(fillColor.startsWith("url")) {	//Gradient	
					shapeParser.setStrokeFillMode(DrawToolConst.STROKE_GRADIENT);
					fillColor = fillColor.substring(5, fillColor.length()-1);	//id 
					for(int i=0; i<shapeParser.idList.size(); i++) {
						if(shapeParser.idList.get(i).toString().equals(fillColor)) {	//id  index  ã							
							shapeParser.setStrokeGradList((ArrayList<GradientTool>)shapeParser.idGradList.get(i));
							shapeParser.setStrokeAngleGrad(shapeParser.idGradRotateList.get(i));	//gradientAngle
							shapeParser.setStrokeScaleGrad(shapeParser.idGradScaleList.get(i));		//gradientScale
							shapeParser.setStrokeGradCycle(shapeParser.idGradCycleList.get(i));		//gradientRepeat
							shapeParser.setStrokeGradStyle(shapeParser.idGradStyleList.get(i));		//gradientStyle
							break;
						}
					}
					/*if(shapeParser.strokeGradList.size() > 2) {
						int arrSize = shapeParser.strokeGradList.size()-1;
						for(int j=1; j<arrSize; j++) {
							shapeParser.strokeGradList.remove(1);
						}
					}*/
				}
				//1. rgb(0,0,0)
				//2. black / Black
				//3. #000000
				else {
					shapeParser.setStrokeFillMode(DrawToolConst.STROKE_COLOR);
					if(fillColor.startsWith("rgb")) { //RGB
						fillColor = fillColor.replace("rgb(", "");
						fillColor = fillColor.replace(")", "");
						
						String[] tmp = fillColor.split(",");

						int r, g, b;
						r = Integer.parseInt(tmp[0]);
						g = Integer.parseInt(tmp[1]);
						b = Integer.parseInt(tmp[2]);
						
						shapeParser.setStrokeColor(new Color(r,g,b));
					}
					else if(fillColor.startsWith("#")) { //#000000
						ColorConverter cc = new ColorConverter();
						Color color = cc.RGB(fillColor);
						shapeParser.setStrokeColor(color);
					}
					else{ //Color Name
						Color color = ColorParser.getInstance().getColor(fillColor);						
						shapeParser.setStrokeColor(color);	
					}
				}
			}
			//Stroke-Width
			else if(styleName[0].trim().equals("stroke-width")) {
				shapeParser.setStrokeMode(true);
				shapeParser.setStrokeSize(Float.parseFloat(styleName[1].trim()));
			}
			//Gradient(Color, Opacity)
			else if(styleName[0].trim().equals("stop-color")) {
				gradFillColor = styleName[1].trim();
				//1. rgb(0,0,0)
				//2. black / Black
				//3. #000000
				if(gradFillColor.startsWith("rgb")) { //RGB
					gradFillColor = gradFillColor.replace("rgb(", "");
					gradFillColor = gradFillColor.replace(")", "");
					
					String[] tmp = gradFillColor.split(",");

					int r, g, b;
					r = Integer.parseInt(tmp[0]);
					g = Integer.parseInt(tmp[1]);
					b = Integer.parseInt(tmp[2]);
					
					shapeParser.setGradColor(new Color(r,g,b));
				}
				else if(gradFillColor.startsWith("#")) { //#000000
					ColorConverter cc = new ColorConverter();
					Color color = cc.RGB(gradFillColor);
					shapeParser.setGradColor(color);
				}
				else{ //Color Name
					Color color = ColorParser.getInstance().getColor(gradFillColor);						
					shapeParser.setGradColor(color);	
				}				
			}
			else if(styleName[0].trim().equals("stop-opacity")) {
				shapeParser.setGradOpacity(Math.round(Float.parseFloat(styleName[1].trim())));
			}
			//Opacity
			else if(styleName[0].trim().equals("fill-opacity")) {
				exitOpacity = true;
				shapeParser.setOpacityMode(true);
				
				if(shapeParser.getColorMode()) {
					shapeParser.setColorOpacity(Float.parseFloat(styleName[1].trim()));
				}
				else if(shapeParser.getGradientMode()){
					shapeParser.setGradOpacity(Float.parseFloat(styleName[1].trim()));
				}
			}
			else if(styleName[0].trim().equals("stroke-opacity")) {
				exitOpacity = true;
				shapeParser.setOpacityMode(true);
				shapeParser.setStrokeOpacity(Float.parseFloat(styleName[1].trim()));
			}
			//Text
			else if(styleName[0].trim().equals("font-family")) {
				shapeParser.setFontFamily(styleName[1].trim());
			}
			else if(styleName[0].trim().equals("font-size")) {
				shapeParser.setFontSize(Math.round(Float.parseFloat(styleName[1].trim())));				
			}
			else if(styleName[0].trim().equals("font-style")) {
				if(styleName[1].trim().equals("normal"))
					shapeParser.setFontStyle(0);				
				else if(styleName[1].trim().equals("italic")) {
					if(ckFontStyle == false) {
						shapeParser.setFontStyle(2);
						ckFontStyle = true;
					}
				}
			}
			else if(styleName[0].trim().equals("font-weight")) {
				if(styleName[1].trim().equals("bold")) { 
					shapeParser.setFontStyle(1);	
					if(ckFontStyle == true) {
						shapeParser.setFontStyle(3);
					}
				}
				else if(styleName[1].trim().equals("normal")) { 
					shapeParser.setFontStyle(0);		
				}
			}
		}// end for
		
		if(exitFill == false && exitOpacity == false) {
			shapeParser.setColorMode(true);
			shapeParser.setFillColor(tmpFillColor);
			shapeParser.setColorOpacity(1);
		}
		if(exitOpacity == false) {
			shapeParser.setColorOpacity(1);
		}
	}//end toJavaStyleParser
	
	public void toJavaPreStyleParser(String preTotalStyle) {
		
		System.out.println("{" +preTotalStyle+ "}");		
		style = preTotalStyle.split(";");	
		
		Color tmpFillColor = Color.black;
				
		for(int innerIndex=0; innerIndex<style.length; innerIndex++) {
			styleName = style[innerIndex].split(":");

			//Fill(ĥϱ)
			if(styleName[0].trim().equals("fill")) {
				String fillColor = styleName[1].trim();
								
				if(fillColor.equals("none")) { 			//fill none
					shapeParser.setColorMode(false);
					//shapeParser.setGradientMode(false);
				}
				else {									//fill Color
					//1. rgb(0,0,0)
					//2. black / Black
					//3. #000000
					shapeParser.setColorMode(true);
					if(fillColor.startsWith("rgb")) { //RGB
						fillColor = fillColor.replace("rgb(", "");
						fillColor = fillColor.replace(")", "");
						
						String[] tmp = fillColor.split(",");

						int r, g, b;
						r = Integer.parseInt(tmp[0]);
						g = Integer.parseInt(tmp[1]);
						b = Integer.parseInt(tmp[2]);
						
						tmpFillColor = new Color(r,g,b);
						shapeParser.setFillColor(tmpFillColor);
					}
					else if(fillColor.startsWith("#")) { //#000000
						ColorConverter cc = new ColorConverter();
						tmpFillColor = cc.RGB(fillColor);
						shapeParser.setFillColor(tmpFillColor);
					}
					else{ //Color Name
						tmpFillColor = ColorParser.getInstance().getColor(fillColor);						
						shapeParser.setFillColor(tmpFillColor);
					}
				}				 
			}
			//Opacity
			else if(styleName[0].trim().equals("fill-opacity")) {
				shapeParser.setOpacityMode(true);
				shapeParser.setColorOpacity(Float.parseFloat(styleName[1].trim()));
			}
		}
	}
	
	//SVGϿ 
	public String toSvgStyleParser(String line, Element element)
	{
		String tmpline = line + ATT_STYLE;
		String color;
		
		if(element.getGradientMode()) {
			if(element.getColorMode() && !element.getStrokeMode()) {	// Color & Gradient
				try {
					color = element.getFillColor().toString().replace("java.awt.Color[", "rgb(");
				}
				catch(Exception e) {
					color = Color.white.toString().replace("java.awt.Color[", "rgb(");
				}
				color = color.replace("]", ")");
				color = color.replace("r=", "");
				color = color.replace("g=", "");
				color = color.replace("b=", "");
				line = tmpline + ATT_FILL + color + ";";
				line = line + ATT_FILL_OPACITY + element.getColorOpacity() + "\"/>\r\n";
				if(element.getFillGradID() != null) {
					line = line + ElementParser.getInstance().makeTap(element, false);
					line = line + "<!-- ColorMode && GradientMode -->\r\n"; //ּ  Mode ˸
					line = line + tmpline + ATT_FILL + ATT_URL + element.getFillGradID() + ");";
					line = line + ATT_FILL_OPACITY + element.getGradOpacity() + "\"/>\r\n";
				}
			}
			else if(element.getStrokeMode() && !element.getColorMode()) {	// Stroke & Gradient
				line = tmpline + ATT_FILL + ATT_URL + element.getFillGradID()+ ");";
				line = line + ATT_FILL_OPACITY + element.getGradOpacity() + ";";
				if(element.getStrokeGradID() != null) {
					line = line + ATT_STROKE + ATT_URL + element.getStrokeGradID() + ");" +
					ATT_STROKE_WIDTH + element.getStrokeSize() + ";";
				}
				else if(element.getStrokeFillMode() == 0
						&& element.getStrokeColor()!=null){
					color = element.getStrokeColor().toString().replace("java.awt.Color[", "rgb(");
					color = color.replace("]", ")");
					color = color.replace("r=", "");
					color = color.replace("g=", "");
					color = color.replace("b=", "");
					line = line + ATT_STROKE + color + ";" +
					ATT_STROKE_WIDTH + element.getStrokeSize() + ";";
				}
				line = line + ATT_STROKE_OPACITY + element.getStrokeOpacity() + "\"/>\r\n";
			}
			else if(element.getStrokeMode() && element.getColorMode()) {	//Color & Stroke & Gradient
				try {
					color = element.getFillColor().toString().replace("java.awt.Color[", "rgb(");
				}
				catch(Exception e) {
					color = Color.white.toString().replace("java.awt.Color[", "rgb(");
				}
				color = color.replace("]", ")");
				color = color.replace("r=", "");
				color = color.replace("g=", "");
				color = color.replace("b=", "");
				line = tmpline + ATT_FILL + color + ";";
				line = line + ATT_FILL_OPACITY + element.getColorOpacity() + "\"/>\r\n";
				if(element.getFillGradID() != null) {
					line = line + ElementParser.getInstance().makeTap(element, false);
					line = line + "<!-- ColorMode && GradientMode -->\r\n";
					line = line + tmpline + ATT_FILL + ATT_URL + element.getFillGradID() + ");";
					line = line + ATT_FILL_OPACITY + element.getGradOpacity() + ";";
				}
				if(element.getStrokeFillMode() == 1) {
					line = line + ATT_STROKE + ATT_URL + element.getStrokeGradID() + ");" +
					ATT_STROKE_WIDTH + element.getStrokeSize() + ";";
					line = line + ATT_STROKE_OPACITY + element.getStrokeOpacity()+ "\"/>\r\n";
				}
				else if(element.getStrokeFillMode() == 0
						&& element.getStrokeColor()!=null){
					color = element.getStrokeColor().toString().replace("java.awt.Color[", "rgb(");
					color = color.replace("]", ")");
					color = color.replace("r=", "");
					color = color.replace("g=", "");
					color = color.replace("b=", "");
					line = line + ATT_STROKE + color + ";" +
					ATT_STROKE_WIDTH + element.getStrokeSize() + ";";				
					line = line + ATT_STROKE_OPACITY + element.getStrokeOpacity()+ "\"/>\r\n";
				}
			}
			else if(!element.getStrokeMode() && !element.getColorMode()){	//Only Gradient 
				line = tmpline + ATT_FILL + ATT_URL + element.getFillGradID()+ ");";
				line = line + ATT_FILL_OPACITY + element.getGradOpacity() + ";";
			}
		}//end GradientMode
		else if(element.getColorMode() && element.getStrokeMode()) {		//Stroke & Color
			//Color(fillColor)
			if(element.getColorMode()){
				color = element.getFillColor().toString().replace("java.awt.Color[", "rgb(");
			
				color = color.replace("]", ")");
				color = color.replace("r=", "");
				color = color.replace("g=", "");
				color = color.replace("b=", "");
				line = tmpline + ATT_FILL + color + ";";
				line = line + ATT_FILL_OPACITY + element.getColorOpacity() + ";";
			}
			//Stroke 
			if(element.getStrokeMode()) {				
				if(element.getStrokeFillMode() == 1) { //Stroke Gradient
					line = line + ATT_STROKE + ATT_URL + element.getStrokeGradID() + ");" +
					ATT_STROKE_WIDTH + element.getStrokeSize() + ";";
					line = line + ATT_STROKE_OPACITY + element.getStrokeOpacity()+ "\"/>\r\n";
				}
				else if(element.getStrokeFillMode() == 0
						&& element.getStrokeColor()!=null){
					color = element.getStrokeColor().toString().replace("java.awt.Color[", "rgb(");
					color = color.replace("]", ")");
					color = color.replace("r=", "");
					color = color.replace("g=", "");
					color = color.replace("b=", "");
					line = line + ATT_STROKE + color + ";" +
					ATT_STROKE_WIDTH + element.getStrokeSize() + ";";				
					line = line + ATT_STROKE_OPACITY + element.getStrokeOpacity()+ "\"/>\r\n";
				}
			}
		}
		else if(element.getStrokeMode() && !element.getColorMode()) {	//Stroke			
			line = tmpline + ATT_FILL + "rgb(255,255,255)" + ";";
			line = line + ATT_FILL_OPACITY + "0" + ";";	// fill: ϰ ó			
			
			if(element.getStrokeFillMode() == 1) {		// stroke gradients
				line = line + ATT_STROKE + ATT_URL + element.getStrokeGradID() + ");" +
				ATT_STROKE_WIDTH + element.getStrokeSize() + ";";
				line = line + ATT_STROKE_OPACITY + element.getStrokeOpacity()+ "\"/>\r\n";
			}
			else if(element.getStrokeFillMode() == 0
					&& element.getStrokeColor()!=null){
				color = element.getStrokeColor().toString().replace("java.awt.Color[", "rgb(");
				color = color.replace("]", ")");
				color = color.replace("r=", "");
				color = color.replace("g=", "");
				color = color.replace("b=", "");
				line = line + ATT_STROKE + color + ";" +
				ATT_STROKE_WIDTH + element.getStrokeSize() + ";";				
				line = line + ATT_STROKE_OPACITY + element.getStrokeOpacity()+ "\"/>\r\n";
			}			
		}
		else if(!element.getStrokeMode() && element.getColorMode()) {	//Color
			try {
				color = element.getFillColor().toString().replace("java.awt.Color[", "rgb(");
			}
			catch(Exception e) {
				color = Color.white.toString().replace("java.awt.Color[", "rgb(");
			}
			color = color.replace("]", ")");
			color = color.replace("r=", "");
			color = color.replace("g=", "");
			color = color.replace("b=", "");
			line = tmpline + ATT_FILL + color + ";";
			line = line + ATT_FILL_OPACITY + element.getColorOpacity() + "\"/>\r\n";
		}	
		return line;
	}
	
	//SVGϿ  : Gradient <Stop> Style
	public String toSvgGradParser(String line, Element element, int j, boolean stroke) {
		line = line + ATT_STYLE;

		String color = Color.white.toString();
		if(stroke == false) {
			color = element.getGradList().get(j).getColor().toString().replace("java.awt.Color[", "rgb(");
		}
		else if(stroke == true) {
			color = element.getStrokeGradList().get(j).getColor().toString().replace("java.awt.Color[", "rgb(");
		}
		
		color = color.replace("]", ")");
		color = color.replace("r=", "");
		color = color.replace("g=", "");
		color = color.replace("b=", "");
		line = line + ATT_STOP_COLOR + color;
	
		return line;
	}
	
	//SVGϿ  : Text(font)
	public String toSvgTextParser(String line, Element element) {
		int tmpFontStyle = ((TextTool)element).getFontStyle();
		String fontStyle = "";
		if(tmpFontStyle == 0) {
			fontStyle = "font-style:none;"; }
		else if(tmpFontStyle == 1) {
			fontStyle = "font-weight:bold;"; }
		else if(tmpFontStyle == 2) {
			fontStyle = "font-style:italic;"; }
		else if(tmpFontStyle == 3) {
			fontStyle = "font-weight:bold;font-style:italic;"; }
		
		line = line + ATT_FONT_FAMILY + ((TextTool)element).getFontName() +";"+
		fontStyle + ATT_FONT_SIZE + ((TextTool)element).getFontSize();
		return line;
	}
}
